/******************************************************************************
 * 
 * sdla_te3.h	Sangoma T3/E3 front end definitions.
 * 	
 * 		Alex Feldman <al.feldman@sangoma.com>
 * 		
 * 	Copyright Sangoma Technologies Inc. 1999, 2000, 2001, 2002, 2003, 2004
 *
 * 	This program is provided subject to the Software License included in 
 * 	this package in the file license.txt. By using this program you agree
 * 	to be bound bythe terms of this license. 
 *
 * 	Should you not have a copy of the file license.txt, or wish to obtain
 * 	a hard copy of the Software License, please contact Sangoma
 * 	technologies Corporation.
 *
 * 	Contact: Sangoma Technologies Inc. 905-474-1990, info@sangoma.com
 *
 *****************************************************************************/

#ifndef __SDLA_TE3_H
# define __SDLA_TE3_H

#define WAN_MEDIA_DS3		0x01
#define WAN_MEDIA_STS1		0x02
#define WAN_MEDIA_E3		0x03

#define WAN_FR_E3_G751	0x01
#define WAN_FR_E3_G832	0x02
#define WAN_FR_DS3_Cbit	0x03
#define WAN_FR_DS3_M13	0x04

#define WAN_LCODE_AMI		0x01
#define WAN_LCODE_B3ZS		0x02	/* DS3, Zero-Suppression code */
#define WAN_LCODE_HDB3		0x02	/* E3, Zero-Suppression code */

#define WAN_TE3_LIU_LB_NONE	0x00
#define WAN_TE3_LIU_LB_ANALOG	0x01
#define WAN_TE3_LIU_LB_REMOTE	0x02
#define WAN_TE3_LIU_LB_DIGITAL	0x03

#define WAN_TE3_RDEVICE_NONE		0x00
#define WAN_TE3_RDEVICE_ADTRAN		0x01
#define WAN_TE3_RDEVICE_DIGITALLINK	0x02
#define WAN_TE3_RDEVICE_KENTROX		0x03
#define WAN_TE3_RDEVICE_LARSCOM		0x04
#define WAN_TE3_RDEVICE_VERILINK	0x05	

typedef struct {
	int	reqen;		/* receive equalization enable (TRUE/FALSE) */
	int	taos;		/* transmit all ones select (TRUE/FALSE) */
	int	lb_mode;	/* loopback modes */
	int	tx_lbo;		/* transmit line build-out (TRUE/FALSE) */
} sdla_te3_liu_cfg_t;

typedef struct {
	sdla_te3_liu_cfg_t	liu_cfg;
	int			fractional;
	int			rdevice_type;
} sdla_te3_cfg_t;

#define IS_DS3(cfg)	((cfg)->media == WAN_MEDIA_DS3)
#define IS_E3(cfg)	((cfg)->media == WAN_MEDIA_E3)
#define IS_TE3(cfg)	(				\
		(cfg)->media == WAN_MEDIA_DS3 ||	\
		(cfg)->media == WAN_MEDIA_E3)


#if defined(WAN_KERNEL)

typedef struct {
	int dummy;
} sdla_te3_param_t;

#endif /* WAN_KERNEL */

#endif /* __SDLA_TE3_H */
