/************************************************************************
 * FILE NAME   : GpCallBacks.h                                          *
 *					                                                    *
 * DESCRIPTION : This module defines prototype declarations			    *
 *               for call back functions.                               *
 *                                                                      *
 * (C) Copyright 2001 by GlobeSpan Inc.									*
 *                                                                      *
 * $Header: /usr/local/cvsroot/wanpipe_common/adsl/Epci/GpCallBacks.h,v 1.2 2003/10/29 18:22:58 sangoma Exp $ *
 *                                                                      *
 ************************************************************************/

#ifndef GPCALLBACKS_H
#define GPCALLBACKS_H

//	Call back prototype definitions
//	These functions must be defined by the user of this API.          
//	These functions must be PAGE_LOCKED.  

// Note that this file is only a sample. The actual function names can be changed.
// The function addresses must be loaded into the call back function pointer table
// (defined in the DslModem structure in file GpDefine.h).

GP_VOID CustReceiveCells(PDSL_MODEM pDSLModem, GP_DWORD CellPtr, GP_WORD NumRxCells);
GP_VOID CustDelay(GP_DWORD delay );
GP_VOID CustXmitDmaDone(PDSL_MODEM pDSLModem );


GP_DWORD CustReadPciReg(
	    PDSL_MODEM pDslModem,
	    GP_WORD Address,
	    GP_BYTE *pData
	    );

GP_VOID CustWritePciReg(
	       PDSL_MODEM pDslModem,
	       GP_WORD Address,
	       GP_DWORD Data
	       );

GP_BYTE CustReadPciRegB(
	    PDSL_MODEM pDslModem,
	    GP_WORD Address,
	    GP_BYTE *pData
	    );

GP_VOID CustWritePciRegB(
	       PDSL_MODEM pDslModem, 
	       GP_WORD Address, 
	       GP_BYTE Data
	       );


#endif  // GPCALLBACKS_H

