
/************************************************************************
 * FILE NAME   : GpEoc.h                                                *
 *																	    *
 * DESCRIPTION : Constants and data structures used by the EOC module.  *
 *                                                                      *
 *                                                                      *
 * (C) Copyright 2001 by GlobeSpan Inc				                    *
 *                                                                      *
 *
 * $Header: /usr/local/cvsroot/wanpipe_common/adsl/Epci/GpEoc.h,v 1.2 2003/01/10 07:56:07 alex Exp $ *
 *                                                                      *
 ************************************************************************/

#ifndef GPEOC_H
#define GPEOC_H

#include "gti.h"
#include "gti_eoca.h"   

/* Routines, Data Structures for EOC messages  */

#define FIRST_EOC_CELL				0xFF
#define EOC_MESSAGE_SIZE			2
#define EOC_FIRST_CELL_MSGS			(ATM_PAYLOAD_SIZE/EOC_MESSAGE_SIZE)
#define EOC_SECOND_CELL_MSGS		(GTI_EOC_MAX_NUMOF_MSG - EOC_FIRST_CELL_MSGS)
#define EMPTY_PATTERN				0x0C0C
#define RXBUFFER_CELLCOUNT			4

/* structures for EOC messages  */ 

typedef struct _EOC_STATUS
{
	GTI_DWORD	RxEocOk;
	GTI_DWORD	RxEocError;
} EOC_STATUS , *PEOC_STATUS;


typedef struct _EOC_MESSAGES
{  
    GTI_WORD		rxBuff[RXBUFFER_CELLCOUNT][GTI_EOC_MAX_NUMOF_MSG];
    GTIEOC_CMD		EocCmd;
    EOC_STATUS		status;                    
    GTI_BYTE		CellWriteInd;
	GTI_BYTE		CellReadInd;
    GTI_BYTE		CellPendingCnt;

} EOC_MESSAGES , *PEOC_MESSAGES;

#endif /* GPEOC_H */ 
