/**********************************************************************
* Description  : Initializes the transceiver parameter array.
*		 This array must be initialized prior to calling
*		 GpCmdTransceiver or GpStartTraining.
*
* Input        : pDslModem: A pointer to the DslModem information structure.
*   
* Output       : None
*
* Return       : none
*
* (C) Copyright 2001 by GlobeSpan Inc   
*
* $Header: /usr/local/cvsroot/wanpipe_common/adsl/Epci/GpInitParameters.c,v 1.2 2003/09/24 14:07:40 sangoma Exp $ *
*                                                                      *
************************************************************************/

#include "GpInclude.h"

GP_VOID GpInitParameters(PDSL_MODEM pDslModem)
{
      pDslModem->XcvrParam[0].length = GTI_NUM_OF_ATU_R_CMD_PARAMETERS;   

      pDslModem->XcvrParam[0].item[GTI_ACTION_ITEM]		= 0; /* to be replaced */
      pDslModem->XcvrParam[0].item[GTI_MODE_ITEM]               = GTI_ATU_R;
      pDslModem->XcvrParam[0].item[GTI_INITIATE_ITEM]           = GTI_DEFAULT_INITIATE;
      pDslModem->XcvrParam[0].item[GTI_DATA_INTERFACE_TYPE_ITEM]= GTI_UTOPIA_L1_FRAMING;

      pDslModem->XcvrParam[0].item[GTI_EC_FDM_ITEM]             = GTI_FDM_MODE;
      pDslModem->XcvrParam[0].item[GTI_TRELLIS_ITEM]            = GTI_TRELLIS_ENABLE;  
      pDslModem->XcvrParam[0].item[GTI_STANDARD_ITEM]           = GTI_MULTIMODE_STANDARD; /* GTI_T1_413_STANDARD; */
      pDslModem->XcvrParam[0].item[GTI_MAX_BITS_PER_BIN_ITEM]   = 0x0e;   /* 14 */    
	  
      pDslModem->XcvrParam[0].item[GTI_TX_START_BIN_ITEM]       = 0x06;         
      pDslModem->XcvrParam[0].item[GTI_TX_END_BIN_ITEM]         = 0x1F; 
/*    pDslModem->XcvrParam[0].item[GTI_TX_BIN_ADJUST_ITEM]      = GTI_TX_BIN_DISABLE; */ 
      pDslModem->XcvrParam[0].item[GTI_RX_START_BIN_ITEM]       = 0x20; 
      pDslModem->XcvrParam[0].item[GTI_RX_END_BIN_ITEM]         = 0xFF; 
      pDslModem->XcvrParam[0].item[GTI_RX_BIN_ADJUST_ITEM]      = GTI_RX_BIN_DISABLE; 
      pDslModem->XcvrParam[0].item[GTI_TX_POWER_ATTENUATION_ITEM]= GTI_0DB_TX_PWR; 
      pDslModem->XcvrParam[0].item[GTI_LINE_DR_STBY_ITEM]       = 0x0; /* Disable */

      pDslModem->XcvrParam[0].item[GTI_NTR_ITEM]                = GTI_NTR_DISABLE;
      pDslModem->XcvrParam[0].item[GTI_PMODE_ITEM]              = GTI_ENABLE_PMODE;
      pDslModem->XcvrParam[0].item[GTI_CODING_GAIN_ITEM]        = GTI_AUTO_CODING_GAIN; 
      pDslModem->XcvrParam[0].item[GTI_TONE_ORDERING_ITEM]  	 = GTI_ENABLE_TONE_ORDERING;
	  
      pDslModem->XcvrParam[0].item[GTI_FRAMING_STRUCTURE_ITEM]  = GTI_FRAMING_TYPE_3;
      pDslModem->XcvrParam[0].item[GTI_UTOPIA_L2_TX_ADDR_ITEM]  = 0x00;
      pDslModem->XcvrParam[0].item[GTI_UTOPIA_L2_RX_ADDR_ITEM]  = 0x00;
	  pDslModem->XcvrParam[0].item[GTI_CLOCK_TYPE_ITEM]     = GTI_CLOCK_CRYSTAL; 
																					 
      pDslModem->XcvrParam[0].item[GTI_VENDOR_ID_ITEM]          = GP_XCVR_VENDOR_ID; /* GlobeSpan */
      pDslModem->XcvrParam[0].item[GTI_VENDOR_REV_SHORT_ITEM]   = 0x00;         
      pDslModem->XcvrParam[0].item[GTI_EXPANDED_EXCHANGE_ITEM]  = GTI_EXPANDED_EXCHANGE; 
      pDslModem->XcvrParam[0].item[GTI_ESCAPE_FAST_RETRAIN_ITEM]= GTI_ESCAPE_DISABLE;         

      pDslModem->XcvrParam[0].item[GTI_FAST_RETRAIN_ENABLE_ITEM]= 0x8000;  /* DISABLE */        
      pDslModem->XcvrParam[0].item[GTI_BIT_SWAP_ITEM]           = GTI_BIT_SWAP_ENABLE;    
	  pDslModem->XcvrParam[0].item[GTI_US_BIT_SWAP_ITEM]        = 0x00;    /* DISABLE */
	  pDslModem->XcvrParam[0].item[GTI_ERASE_PROFILES_ITEM]     = 0x00;    /* DISABLE */


      pDslModem->XcvrParam[0].item[GTI_PILOT_TONE_REQUEST_ITEM] = GTI_ENABLE_PILOT_TONE; 
      pDslModem->XcvrParam[0].item[GTI_MAX_DOWN_RATE_ITEM] 	 = 0x1ff; /* No limit (16 Mbps) */
	  pDslModem->XcvrParam[0].item[GTI_DUAL_LATENCY_ITEM] 		 = 0x0;  /* Disable */
	  pDslModem->XcvrParam[0].item[GTI_CUTBACK_ITEM] = GTI_CUTBACK_DISABLE;/* Analog hardware rev. 1 */
	                          
	  pDslModem->XcvrParam[0].item[GTI_HW_REV_ITEM] = GTI_HW_REV_ONE; 
}
