/************************************************************************
 * FILE NAME   : GpPrototype.h                                          *
 *					                                                    *
 * DESCRIPTION : This module defines function prototype declaration     *
 *                                                                      *
 * (C) Copyright 2001 by GlobeSpan Inc.									*
 *                                                                      *
 * $Header: /usr/local/cvsroot/wanpipe_common/adsl/Epci/GpPrototype.h,v 1.2 2003/01/10 07:56:07 alex Exp $ *
 *                                                                      *
 ************************************************************************/

#ifndef GPPROTOTYPE_H
#define GPPROTOTYPE_H

GP_DWORD
GpEepromRead(
              PDSL_MODEM pDslModem,
              GP_WORD Reg
              );

GP_VOID
GpEepromWrite(
              PDSL_MODEM pDslModem,
              GP_WORD Reg,
              GP_DWORD data
              );

GP_VOID
GpEepromShiftOut(
                PDSL_MODEM pDslModem,
                GP_DWORD data,
                GP_WORD count
                );

GP_VOID
GpEepromRaiseClock(
              PDSL_MODEM pDslModem,
              GP_DWORD *x
              );

GP_VOID
GpEepromLowerClock(
              PDSL_MODEM pDslModem,
              GP_DWORD *x
              );

GP_DWORD
GpEepromShiftIn(
               PDSL_MODEM pDslModem
               );

GP_VOID
GpEepromDisable(
                 PDSL_MODEM pDslModem
                 );

GP_VOID
GpEepromEnable(
                PDSL_MODEM pDslModem
                );


GP_WORD GpInitialize( PDSL_MODEM pDslModem );
GP_VOID GpInitParameters(PDSL_MODEM pDslModem);
GP_VOID GpInitRegisters(PDSL_MODEM pDslModem);
GP_WORD GpCheckHardware(PDSL_MODEM pDslModem);
GP_VOID GpResetTransceiver(PDSL_MODEM pDslModem);
GP_DWORD GpGetDataRate(PDSL_MODEM pDslModem);

GP_DWORD GpStartTraining(PDSL_MODEM pDslModem);
GP_DWORD GpSpectrumTest(PDSL_MODEM pDslModem);
GP_DWORD GpDigitalLoopTest(PDSL_MODEM pDslModem);
GP_WORD GpMonitorTransceiver(PDSL_MODEM pDslModem);

GP_VOID GpShutdown(PDSL_MODEM pDSL_MODEM);
GP_VOID GpSendDyingGasp(PDSL_MODEM pDslModem);
GP_VOID GpSetRxIdleCellCount(PDSL_MODEM pDslModem);
GP_DWORD GpCmdTransceiver(PDSL_MODEM pDslModem,GP_BYTE action);

GP_WORD GpGetStatusXcvr(PDSL_MODEM pDslModem,GP_BYTE opCode);
GP_VOID GpInitEoc(PDSL_MODEM pDslModem);
GP_VOID GpEnableInterrupt(PDSL_MODEM pDslModem);
GP_VOID GpDisableInterrupt(PDSL_MODEM pDslModem);

GP_VOID GpUpdateSNRStatus(PDSL_MODEM pDSLModem );
GP_WORD GpCheckInterrupts(PDSL_MODEM pDSLModem );
GP_VOID GpInterruptHandler(PDSL_MODEM pDSLModem );

GP_VOID GpReceiveDmaHandler(PDSL_MODEM pDSLModem );
GP_WORD GpTransmitCells(PDSL_MODEM pDSLModem, GP_DWORD TxBuffStartP, GP_DWORD TxBuffEndP );

GP_VOID GpResetDma(PDSL_MODEM pDSLModem );
GP_VOID GpDumpRcvBuffInfo (PDSL_MODEM pDslModem, GP_DWORD RxCellWrPtr, GP_DWORD RxCellRdPtr);
GP_DWORD GpFindIdleCells(GP_CELL *thisCell);
GP_WORD GpCheckRetrain(PDSL_MODEM pDslModem);


#endif  /* GPPROTOTYPE_H */

