/****************************************************/
/*         Set Default Parameters                   */
/*  (C) Copyright 1996-2002 by GlobespanVirata Inc  */
/****************************************************/

#include "gti.h"

GTI_WORD GTI_DefaultParameters[] = {
          0x0000, /*   0 (0x000)   Start CP                  = [Start Up                 ] */
          0x0001, /*   1 (0x001)   Mode                      = [ATU-R                    ] */
          0x00F0, /*   2 (0x002)   Initiate                  = [Default                  ] */
          0x0001, /*   3 (0x003)   Data Interface            = [UTOPIA Level 1           ] */
          0x8000, /*   4 (0x004)   Trellis                   = [Enable                   ] */
          0x0001, /*   5 (0x005)   EC FDM                    = [FDM Mode                 ] */
          0x0004, /*   6 (0x006)   Standard                  = [Multimode                ] */
          0x000E, /*   7 (0x007)   Max bits per bin          = [14                       ] */
          0x0006, /*   8 (0x008)   Tx Start Bin              = [0x0006                   ] */
          0x001F, /*   9 (0x009)   Tx End Bin                = [0x001F                   ] */
          0x0000, /*  10 (0x00A)   Line Driver Stdby         = [Disable                  ] */
          0x0020, /*  11 (0x00B)   Rx Start Bin              = [0x0020                   ] */
          0x00FF, /*  12 (0x00C)   Rx End Bin                = [0x00FF                   ] */
          0x0000, /*  13 (0x00D)   Rx Bin Adjust             = [Disable                  ] */
          0x0000, /*  14 (0x00E)   Tx Power Attenuation      = [0 dB                     ] */
          0x0000, /*  15 (0x00F)   NTR                       = [Disable                  ] */
          0x0001, /*  16 (0x010)   ATU-R pilot for data      = [Enable                   ] */
          0xFF00, /*  17 (0x011)   Coding Gain               = [Auto                     ] */
          0x0000, /*  18 (0x012)   Tone Ordering             = [Enable                   ] */
          0x0003, /*  19 (0x013)   Framing Structure         = [Type 3                   ] */
          0x0000, /*  20 (0x014)   UTOPIA L2 Tx Addr         = [0x0000                   ] */
          0x0000, /*  21 (0x015)   UTOPIA L2 Rx Addr         = [0x0000                   ] */
          0x0000, /*  22 (0x016)   Clock Type                = [Oscillator               ] */
          0x0039, /*  23 (0x017)   Vendor ID                 = [0x0039                   ] */
          0x0000, /*  24 (0x018)   Vendor Rev                = [0x0000                   ] */
          0x8000, /*  25 (0x019)   Expanded Exchange         = [Expanded                 ] */
          0x0000, /*  26 (0x01A)   Escape Fast Retrain       = [Disable                  ] */
          0x8000, /*  27 (0x01B)   Fast Retrain              = [Disable                  ] */
          0x8000, /*  28 (0x01C)   Bit Swap                  = [Enable                   ] */
          0x0000, /*  29 (0x01D)   US Bit Swap               = [Disable                  ] */
          0x0000, /*  30 (0x01E)   Erase Profiles            = [Disable                  ] */
          0x8000, /*  31 (0x01F)   Trigger Mode              = [Disable                  ] */
          0x0000, /*  32 (0x020)   Annex Type                = [Annex A                  ] */
          0x0000, /*  33 (0x021)   AnnexC Mode               = [FBM                      ] */
          0x0000, /*  34 (0x022)   AnnexC Pilot Tone         = [NEXT Enable              ] */
          0x0000, /*  35 (0x023)   AnnexC Tx Bin Adj         = [Disable                  ] */
          0x0000, /*  36 (0x024)   Pilot Tone Request        = [Enable                   ] */
          0x0FFF, /*  37 (0x025)   Max Down Rate             = [0x0FFF                   ] */
          0x0001, /*  38 (0x026)   Dual Latency              = [Enable                   ] */
          0x0001, /*  39 (0x027)   HW Revision               = [Rev 1                    ] */
          0x0000, /*  40 (0x028)   Cutback                   = [Disable                  ] */
          0x0000, /*  41 (0x029)   AnnexC TTR R Offset       = [0 sample                 ] */
          0x2000, /*  42 (0x02A)   Max Interleave D          = [256                      ] */
};




GTI_WORD 
GTI_Set_Defaults(struct PARAM_XCVR_ARRAY *ParamTbl, GTI_WORD wLen)
{
    GTI_WORD i;

    if(wLen != (sizeof(GTI_DefaultParameters)/sizeof(GTI_WORD)) )
        return GTI_FAIL;

    for(i=0; i< (sizeof(GTI_DefaultParameters)/sizeof(GTI_WORD));i++)
    {
         ParamTbl->item[i] = GTI_DefaultParameters[i];
    }
    return GTI_OK;
}
