/* 03/01/23 16:09:05 = RETRIEVAL
 * 01/10/25 09:33:22 = DELTA
 * @(#)gti_lbus.c	1.11
 */

/************************************************************************/
/* TSM         Application Code                                         */
/* (C) Copyright 1999-2000 by GlobeSpan Technologies Inc                */
/************************************************************************/

#include "gti.h"

#ifdef GTI_DSPOCTANE

#include "gtidsp.h"
#include "gtiextn.h"
#include "gti_lbus.h"

#ifdef __BORLANDC__
#pragma option -zELBTEST_TBL -zFSPECIAL
#endif

GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL LbTest_Tbl[] =
{
     0x80, 0x00, 0xa0, 0x0c, 0x2c, 0x04, 0x80, 0x02, 0x04, 0x00, 0x80, 0x80,
     0xa0, 0x00, 0x2c, 0x04, 0x00, 0x08, 0x06, 0x94, 0x01, 0x08, 0x07, 0x94,
     0xa0, 0x02, 0x2c, 0x04, 0x80, 0x02, 0xa0, 0x80, 0x2d, 0x04, 0xd8, 0x2e,
     0x00, 0x04,
     0x80, 0x03, 0xa0, 0x80, 0x2e, 0x04, 0x0f, 0x3c, 0x24, 0x7c, 0x25, 0x34,
     0x00, 0x04, 0x00, 0x04, 0x17, 0x24, 0x00, 0x04, 0xc4, 0x00, 0x00, 0x04,
     0x00, 0x04, 0x24, 0x3c, 0x26, 0x34, 0x00, 0x04, 0xc4, 0x00, 0x00, 0x04,
     0x09, 0x24, 0x0a, 0xbc, 0x06, 0x09, 0x00, 0x04, 0x00, 0x04, 0xf8, 0x5d,
     0x00, 0x04, 0xcc, 0x00, 0x00, 0x04,
     0x80, 0xa5, 0xa4, 0xa5, 0xd9, 0x13, 0x00, 0x04, 0x80, 0x5a, 0xa4, 0x5a,
     0xd9, 0x13, 0x00, 0x04, 0x09, 0x3c, 0x03, 0x08, 0x0a, 0x94, 0x06, 0x09,
     0x00, 0x04, 0x00, 0x04, 0xf8, 0x47, 0x09, 0x34, 0x02, 0x08, 0x0a, 0x94,
     0x06, 0x09, 0x00, 0x04, 0x00, 0x04, 0xf8, 0x47, 0x00, 0x04, 0xd8, 0x59,
     0x00, 0x04,
     0x09, 0x34, 0x80, 0xff, 0xaa, 0xff, 0x06, 0x09, 0x00, 0x04, 0x00, 0x04,
     0xf8, 0x52, 0x00, 0x04, 0x09, 0x3c, 0x20, 0x09, 0x07, 0x14,
     0x09, 0x34, 0x20, 0x09, 0x06, 0x14, 0x00, 0x04, 0x00, 0x04, 0xd8, 0x2e,
     0x00, 0x04, 0x80, 0x00, 0x04, 0x00, 0xd8, 0x60, 0x00, 0x04,
     0x80, 0x01, 0x04, 0x00, 0x00, 0x04,
     0x05, 0x30, 0x06, 0x38, 0xa0, 0x08, 0x2c, 0x04, 0xa0, 0x01, 0x6c, 0x02,
     0x80, 0x07, 0x7a, 0x02, 0x80, 0x01, 0x2c, 0x04, 0x00, 0x04, 0xd8, 0x6b,
     0x00, 0x04,
};

#ifdef __BORLANDC__
#pragma option -zE* -zF*
#endif

/*****************************************************************************/
/* Name:Gti_LocalBusTest                                                     */
/* Input:                                                                    */
/*****************************************************************************/
GTI_WORD Gti_LocalBusTest(GTI_XCVR_INFO* pXcvrPtr, GTI_DWORD dwStart,
                          GTI_DWORD dwEnd, GTI_DWORD *dwCurAddr)
{
    GTI_WORD wOfs, wSeg, wStatus;

    wStatus = GTI_ACTIVE;

    if(dwStart != dwEnd)
    {
        /* Load XDP RAM with xdp code */
        CONFIGURE_DSP( pXcvrPtr, GTI_DSP_A, GTI_DMA);
        WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0x00, GTI_XRAM0);

        WRITE_DSP_BLOCK(pXcvrPtr,GTI_DSP_A, GTI_DATAL_DSP,
            sizeof(LbTest_Tbl), LbTest_Tbl);

        /* Set Start XSAR */
        CONFIGURE_DSP( pXcvrPtr, GTI_DSP_A, GTI_AI);

        /* Set Start BAPR */
        WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0x00, GTI_XSRAM1);

        wOfs = (GTI_WORD)dwStart;
        wSeg = (GTI_WORD)((dwStart >> 0x10) & 0xff);
        WRITE_DSP_WORD(pXcvrPtr, GTI_DSP_A, LOBYTE(wOfs), HIBYTE(wOfs));
        WRITE_DSP_WORD(pXcvrPtr, GTI_DSP_A, LOBYTE(wSeg), HIBYTE(wSeg));

        wOfs = (GTI_WORD)dwEnd;
        wSeg = (GTI_WORD)((dwEnd >> 0x10) & 0xff);
        WRITE_DSP_WORD(pXcvrPtr, GTI_DSP_A, LOBYTE(wOfs), HIBYTE(wOfs));
        WRITE_DSP_WORD(pXcvrPtr, GTI_DSP_A, LOBYTE(wSeg), HIBYTE(wSeg));

        /* Reset the Status */
        CONFIGURE_DSP( pXcvrPtr, GTI_DSP_A, GTI_NO_AI);
        WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0x04, GTI_XSRAM1);
        WRITE_DSP_WORD(pXcvrPtr, GTI_DSP_A, GTI_ACTIVE, 0);

        /* Start the XDP engine */
        WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0xa6, GTI_IREGA);
        WRITE_DSP_WORD(pXcvrPtr, GTI_DSP_A, 0x00, 0xc8);
    }
    else
    {
        if((READ_DSP_REG(pXcvrPtr, GTI_INT_CLEAR_DSP | pXcvrPtr->dsp_B_cs) & 0x40) != 0)
        {
            /* Read the Status */
            CONFIGURE_DSP( pXcvrPtr, GTI_DSP_A, GTI_NO_AI);
            WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0x04, GTI_READ_DSP|GTI_XSRAM1);
            wStatus = READ_DSP_WORD(pXcvrPtr, GTI_DSP_A);

            /* Read the Current Address being tested */
            WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0x05, GTI_READ_DSP|GTI_XSRAM1);
            wOfs = READ_DSP_WORD(pXcvrPtr, GTI_DSP_A);
            WRITE_DSP_ADDR(pXcvrPtr, GTI_DSP_A, 0x06, GTI_READ_DSP|GTI_XSRAM1);
            wSeg = READ_DSP_WORD(pXcvrPtr, GTI_DSP_A);

            *dwCurAddr = ((GTI_DWORD)wSeg << 16 ) | wOfs;

            /* Clear The interrupt */
            WRITE_DSP_REG(pXcvrPtr, (GTI_INT_CLEAR_DSP | pXcvrPtr->dsp_B_cs), 0x40);
        }
        else
        {
            *dwCurAddr = 0;
        }
    }

    return wStatus;
}

GTI_WORD Gti_ExtMemoryAccess(GTI_XCVR_INFO* pXcvrInfo, GTI_WORD wMemType, GTI_BYTE bStartMemPage,
                             GTI_WORD wStartAddr, GTI_WORD wStartSize, GTI_BYTE GTI_ADDRESS_QUAL *pBuffer)
{
    GTI_BYTE bReadReg, bMemPage;
    GTI_WORD wAddr, wSize, wByteIndex;
    int nRead;

    if(pXcvrInfo == 0)
        return 0;

    /* Set SAP selector */
    switch(wMemType & 0x7fff)
    {
        case EXTERNAL_LBRAM:
            WRITE_DSP_REG(pXcvrInfo,  0xe7, 0x01);
            bReadReg = GTI_DATAL_DSP;
            break;
        case EXTERNAL_RSRAM:
            WRITE_DSP_REG(pXcvrInfo,  0xe7, 0x02);
            bReadReg = GTI_DATAH_DSP;
            break;
        default:
            return 0;
    }

    nRead = bStartMemPage & GTI_READ_DSP;

    bMemPage = (GTI_BYTE)((bStartMemPage << 1) | (HIBYTE(wStartAddr) >> 0x07));
    wStartAddr &= 0x7fff;
    wAddr = wStartAddr;

    for(wByteIndex = 0; wByteIndex < wStartSize; wByteIndex = (GTI_WORD)(wByteIndex + wSize))
    {
        wSize = (GTI_WORD)(wStartSize - wByteIndex);

        if((wAddr + (wSize/2)) > 0x8000)
            wSize = (GTI_WORD)((0x8000 - wAddr) * 2);

        WRITE_DSP_REG(pXcvrInfo,  0xe6, bMemPage & 0x3f);

        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_TOP, GTI_DMA);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_TOP, LOBYTE(wAddr), HIBYTE(wAddr) | nRead);

        if(nRead == 0)
            WRITE_DSP_BLOCK(pXcvrInfo, GTI_DSP_TOP, bReadReg, wSize, &pBuffer[wByteIndex]);
        else
            READ_DSP_BLOCK(pXcvrInfo,  GTI_DSP_TOP, bReadReg, wSize, &pBuffer[wByteIndex]);

        bMemPage++;
        wAddr = 0;
    }

    WRITE_DSP_REG(pXcvrInfo,  0xe7, 0x00);

    return wStartSize;
}

/*****************************************************************************/
/* Name:Gti_LocalBusCalcChksum                                               */
/* ---------------------                                                     */
/* Description: The procedure calculates the Local Bus checksum from a given */
/* Address. Returns the calculated checksum.                                 */
/* ------------------------------------------------------------------------- */
GTI_WORD Gti_LocalBusCalcChksum(
    GTI_XCVR_INFO* pXcvrInfo,   /* A pointer to the current chip Data Base   */
    GTI_DWORD dwStart,
    GTI_DWORD dwEnd)
{
    GTI_DWORD  dwCount;
    GTI_WORD  i, wSize, wOfs, wSeg, wChkSum, Buffer[64];

    wChkSum = 0;

    dwCount = dwStart;
    wSeg = (GTI_WORD)(dwStart >> 15);
    wOfs = (GTI_WORD)(dwStart & 0x7fff);

    WRITE_DSP_REG(pXcvrInfo,  0xe7, 0x01);

    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_TOP, GTI_DMA);

    while(dwCount <  dwEnd)
    {
        if((wOfs + sizeof(Buffer)/sizeof(Buffer[0])) > 0x7fff)
        {
            wSize = (GTI_WORD)(0x7fff - wOfs);
            wSeg++;
        }
        else
            wSize = sizeof(Buffer)/sizeof(Buffer[0]);

        if((dwCount + wSize) > dwEnd)
            wSize = (GTI_WORD)(dwEnd - dwCount);

        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_TOP, LOBYTE(wOfs), HIBYTE(wOfs) | GTI_READ_DSP);

        READ_DSP_BLOCK(pXcvrInfo,  GTI_DSP_TOP, GTI_DATAL_DSP, wSize * sizeof(Buffer[0]), &Buffer[0]);

        for(i=0; i < wSize; i++)
            wChkSum = (GTI_WORD)(wChkSum + Buffer[i]);

        WRITE_DSP_REG(pXcvrInfo, 0xe6, wSeg & 0x3f);

        wOfs = (GTI_WORD)((wOfs + wSize) & 0x7fff);
        dwCount += wSize;
    }

    WRITE_DSP_REG(pXcvrInfo,  0xe7, 0x00);

    return wChkSum;
}

/*****************************************************************************/
/* Name:Gti_SetSasBreakpoint                                                 */
/* ---------------------                                                     */
/* Description: The procedure sets abreakpoint on the SAS instruction on the */
/*              Local Bus.                                                   */
/* Returns TRUE or FALSE                                                     */
/* ------------------------------------------------------------------------- */
GTI_WORD Gti_SetSasBreakpoint(GTI_XCVR_INFO *pXcvrInfo, GTI_WORD wLineNumber,
                              GTI_WORD wPage, GTI_WORD wMode, GTI_BYTE *bCode)
{
    GTI_DWORD dwAddress, wSasAddress;
    GTI_BYTE arrData[4];

    if((wMode != 1) && (wMode != 2))
        return GTI_TRUE;

    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, GTI_READ_DSP,
        (GTI_WORD)(GTI_LBUS_PROJ_INFO + (wPage * GTI_LBUS_PROJ_INFO_SIZE)),
        4, arrData))
        return GTI_FALSE;

    dwAddress  = arrData[0];
    dwAddress |= (GTI_DWORD)(arrData[1]) << 8;
    dwAddress |= (GTI_DWORD)(arrData[2]) << 16;
    dwAddress |= (GTI_DWORD)(arrData[3]) << 24;

    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, (GTI_BYTE)(GTI_READ_DSP | (dwAddress >> 16)),
        (GTI_WORD)(dwAddress + 0x40), 2, arrData))
        return GTI_FALSE;

    wSasAddress = arrData[0];
    wSasAddress |= (GTI_DWORD)(arrData[1]) << 8;

    dwAddress = (GTI_DWORD)(dwAddress + 0x41 + wSasAddress + (wLineNumber * 2));

    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,  (GTI_BYTE)(GTI_READ_DSP | (dwAddress >> 16)),
            (GTI_WORD)(dwAddress), 2, arrData))
        return GTI_FALSE;

    if(wMode == 1) /* Set Breakpoint */
    {
        *bCode = arrData[0];
        arrData[0] = 0x0d;
    }
    else
    {
        arrData[0] = *bCode;
    }

    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,  (GTI_BYTE)(dwAddress >> 16),
        (GTI_WORD)dwAddress, 2, arrData))
        return GTI_FAIL;

    return GTI_TRUE;
}

/*****************************************************************************/
/* Name:Gti_LocalBusReadBootInfo                                             */
/* ---------------------                                                     */
/* Description: The procedure retrieves the info from the Local Bus.     .   */
/* Returns TRUE or FALSE                                                     */
/* ------------------------------------------------------------------------- */
GTI_WORD Gti_LocalBusReadBootInfo(
    GTI_XCVR_INFO *pXcvrInfo,   /* A pointer to the current chip Data Base   */
    GTI_LBUS_INFO *pLbusInfo,   /* A pointer to the Local Bus Info Structure */
    GTI_CONST_BYTE_ORDER
    GTI_ADDRESS_QUAL *pBuffer)  /* A pointer to file, if Null read from LBUS */
{
    GTI_BYTE BootInfo[64];

    if(pBuffer == NULL)
    {
        if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, GTI_READ_DSP,
            GTI_LBUS_BOOT_INFO, sizeof(BootInfo), BootInfo))
            return GTI_FALSE;

        pBuffer = &BootInfo[0];
    }

    pLbusInfo->wBootId = MAKEWORD(pBuffer[GTI_LBUS_BOOT_ID * 2],
        pBuffer[(GTI_LBUS_BOOT_ID * 2)+ 1]);

    pLbusInfo->wBootChksum = MAKEWORD(pBuffer[GTI_LBUS_BOOT_CHKSUM * 2],
        pBuffer[(GTI_LBUS_BOOT_CHKSUM * 2) + 1]);

    pLbusInfo->wBootLength = MAKEWORD(pBuffer[GTI_LBUS_BOOT_LENGTH * 2],
        pBuffer[(GTI_LBUS_BOOT_LENGTH * 2) + 1]);

    memcpy(pLbusInfo->bBootVer, &pBuffer[GTI_LBUS_BOOT_VERSION * 2],
        sizeof(pLbusInfo->bBootVer));

    return GTI_TRUE;
}


/*****************************************************************************/
/* Name:Gti_LbusLoadTblFromDesc                                              */
/* Input: XCVR pointer, Pointer to the Descriptor Table                      */
/*****************************************************************************/
int
Gti_LbusLoadTblFromDesc(GTI_XCVR_INFO *pXcvr,
                        GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL *pTblDesc)
{
    int i;
    GTI_WORD wMode, wLoaded;

    for(i=0, wMode=GTI_FW_LOAD_FIRST; (pTblDesc[i].pTblPtr != 0); i++)
    {
        if(Gti_LocalBusDspLoad(pXcvr, wMode,
            pTblDesc[i].pTblPtr,
            pTblDesc[i].wTblLength, &wLoaded) == GTI_FAIL)
        {
            return GTI_FAIL;
        }

        wMode = GTI_FW_LOAD_NEXT;
    }

    return GTI_OK;
}

/*****************************************************************************/
/* Name:Gti_LocalBusLoad                                                     */
/* Input: System pointer, Local Bus number                                   */
/*****************************************************************************/
int
Gti_LocalBusLoad(GTI_SYST_INFO *pSystInfo, int nLbusNum)
{

#ifndef GTI_USE_BINARY_DSP_OBJECT
    GTI_WORD wAnnexType, i;
    GTI_XCVR_INFO *pXcvr;

#ifdef GTI_PAGE_A_BUILT
    extern GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_DspTblDescriptor_a[];
#endif
#ifdef GTI_PAGE_B_BUILT
    extern GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_DspTblDescriptor_b[];
#endif
#ifdef GTI_PAGE_C_BUILT
    extern GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_DspTblDescriptor_c[];
#endif
#ifdef GTI_PAGE_D_BUILT
    extern GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_DspTblDescriptor_d[];
#endif

    pXcvr = 0;
    wAnnexType = (GTI_WORD)(pSystInfo->Lbus_db[nLbusNum].bLbConfiguration);

    /* Find the first XCVR on the local bus */
    for(i = 0; (i == 0) && (i < GTI_MAX_CHIPS_PER_SYSTEM); i++)
    {
        if(pSystInfo->Chip_db[i]->wLbusID == nLbusNum)
            pXcvr = pSystInfo->Chip_db[i]->XCVR_db[0];
    }

    if(pXcvr == 0)
        return GTI_FALSE;

#ifdef GTI_PROD_DMT
#ifdef GTI_PAGE_C_BUILT
    if(Gti_LbusLoadTblFromDesc(pXcvr, Gti_DspTblDescriptor_c) == GTI_FAIL)
        return GTI_FAIL;
#endif
#endif

#ifdef GTI_PAGE_A_BUILT
    if(wAnnexType & GTI_LB_CONFIG_ANNEX_A)
    {
        if(Gti_LbusLoadTblFromDesc(pXcvr, Gti_DspTblDescriptor_a) == GTI_FAIL)
            return GTI_FAIL;
    }
#endif
#ifdef GTI_PAGE_B_BUILT
    if(wAnnexType & GTI_LB_CONFIG_ANNEX_C)
    {
        if(Gti_LbusLoadTblFromDesc(pXcvr, Gti_DspTblDescriptor_b) == GTI_FAIL)
            return GTI_FAIL;
    }
#endif
#ifdef GTI_PAGE_D_BUILT
    if(wAnnexType & GTI_LB_CONFIG_ANNEX_B)
    {
        if(Gti_LbusLoadTblFromDesc(pXcvr, Gti_DspTblDescriptor_d) == GTI_FAIL)
            return GTI_FAIL;
    }
#endif

#else
    (void)pSystInfo;
    (void)nLbusNum;
#endif
    return GTI_OK;
}

GTI_WORD Gti_GetBitFromPageId(GTI_WORD wPageId)
{
    switch(wPageId)
    {
        case GTI_PROJECT_TYPE_0: /* DMT Annex A */
            return GTI_LB_CONFIG_ANNEX_A;
        case GTI_PROJECT_TYPE_1: /* DMT Annex C */
            return GTI_LB_CONFIG_ANNEX_C;
        case GTI_PROJECT_TYPE_2: /* DMT Common  */
            return GTI_LB_CONFIG_COMMON_DMT;
        case GTI_PROJECT_TYPE_3: /* DMT Annex B */
            return GTI_LB_CONFIG_ANNEX_B;
        case GTI_PROJECT_TYPE_4: /* DMT Annex H */
            return GTI_LB_CONFIG_ANNEX_H;
        default:
            return 0;
    }
}

/*****************************************************************************/
/* Name:Gti_LocalBusDspLoad                                                  */
/* ---------------------                                                     */
/* Description: The procedure loads the local bus from the provided table.   */
/*              The per local bus state machine is used.                     */
/* Returns:     GTI_ACTIVE, GTI_FAIL, GTI_OK                                 */
/* ------------------------------------------------------------------------- */
GTI_WORD Gti_LocalBusDspLoad(
    GTI_XCVR_INFO *pXcvrInfo,   /* A pointer to the current chip Data Base   */
    GTI_WORD wMode,             /* Mode of action, initiate or continue      */
    GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *pBuffer, /* A pointer to a buffer */
    GTI_WORD wSize,
    GTI_WORD *wLoadedIdx)             /* Size of a provided buffer                 */
{
    int i;
    GTI_WORD wProcessedIdx, wNumOfBytes, wChkSum, wProjBit, wReturn;
    GTI_DWORD dwAddr, dwAddr2;
    GTI_BYTE arrData[8];
    /* GTI_LBUS_INFO  sLbusInfo; */
    GTI_LBUS_INFO *pLbusInfo;

     *wLoadedIdx = 0;
     wReturn = GTI_OK;

    if(pXcvrInfo->pChipInfo->wLbusID >= GTI_MAX_BUSES_PER_SYSTEM)
        return GTI_FAIL;

    pLbusInfo =
        &(pXcvrInfo->pChipInfo->pSystInfo->Lbus_db[pXcvrInfo->pChipInfo->wLbusID]);

    wProcessedIdx = 0;

    /* The first load must have information about boot at least */
    if(wMode == GTI_FW_LOAD_FIRST)
    {
        /* pLbusInfo->dwMaxSize = 0;*/
        pLbusInfo->dwCurrentAdr = 0;
        pLbusInfo->bReloadBoot = 0;
        pLbusInfo->dwProjAddr = 0;
        pLbusInfo->bMode = GTI_LBUS_MODE_IDLE;

        if(wSize < ((GTI_LBUS_BOOT_INFO + GTI_LBUS_BOOT_INFO_SIZE) * 2))
            return GTI_FAIL;

        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_TOP, GTI_NO_AI);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_TOP, 0xa6, GTI_IREGA);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_TOP, 0x00, 0xa8);

        CONFIGURE_DSP(pXcvrInfo, GTI_ALL_CHIP_CORES, GTI_NO_AI);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_ALL_CHIP_CORES, 0xa6, GTI_IREGA);
        WRITE_DSP_WORD(pXcvrInfo, GTI_ALL_CHIP_CORES, 0x00, 0xa8);

        /* Read Local Bus info from the file first */
        if(!Gti_LocalBusReadBootInfo(pXcvrInfo, pLbusInfo, &(pBuffer[GTI_LBUS_BOOT_INFO * 2])))
            return GTI_FAIL;

        /* as for now, load BOOT always, with no exceptions */

        pLbusInfo->bReloadBoot = GTI_TRUE;

        /* Read Local Bus info from the Local bus itself*/
        /*
        if(!Gti_LocalBusReadBootInfo(pXcvrInfo,  &(sLbusInfo), NULL))
            return GTI_FAIL;
        if( (sLbusInfo.wBootId != pLbusInfo->wBootId) ||
            (sLbusInfo.wBootChksum != pLbusInfo->wBootChksum) ||
            (sLbusInfo.wBootLength != pLbusInfo->wBootLength))
        {
            pLbusInfo->bReloadBoot = GTI_TRUE;
        }
        else
        {
            for(i=0; i<(int)(sizeof(pLbusInfo->bBootVer)); i++)
            {
                if(sLbusInfo.bBootVer[i] != pLbusInfo->bBootVer[i])
                {
                    pLbusInfo->bReloadBoot = GTI_TRUE;
                }
            }
        }
        */

        pLbusInfo->bMode = GTI_LBUS_MODE_BOOT;
        wNumOfBytes = (GTI_LBUS_BOOT_INST_SIZE + GTI_LBUS_BOOT_INFO_SIZE) * 2;
        pLbusInfo->dwCurrentAdr = GTI_LBUS_BOOT_PROG;

        /* if(pLbusInfo->bReloadBoot == GTI_TRUE)
        {
        */
        if((wProcessedIdx + wNumOfBytes) >= wSize)
            return GTI_FAIL;

        /* Load the BOOT info first */
        /* ruin the BOOT ID, will write it later */
        /*  pBuffer[(GTI_LBUS_BOOT_INST_SIZE * 2) + GTI_LBUS_BOOT_ID + 0] = 0xff;
            pBuffer[(GTI_LBUS_BOOT_INST_SIZE * 2) + GTI_LBUS_BOOT_ID + 1] = 0xff;
        */
        if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, 0, 0,
            wNumOfBytes, (GTI_BYTE GTI_ADDRESS_QUAL *)pBuffer))
            return GTI_FAIL;
        /*
        }
        */

        wProcessedIdx = wNumOfBytes;
        *wLoadedIdx = wNumOfBytes;
    }

    wNumOfBytes = 0;

    /* State Machine For Download Sequence */
    while((wProcessedIdx < wSize) && (wReturn == GTI_OK))
    {
        switch(pLbusInfo->bMode)
        {
        case GTI_LBUS_MODE_BOOT:

            /* Have we finished with boot */
            if(pLbusInfo->dwCurrentAdr >= (GTI_DWORD)((GTI_LBUS_BOOT_PROG + (pLbusInfo->wBootLength / 2))))
            {
                /* Restore Boot ID, indicating that we've done with boot */
                /*
                if(pLbusInfo->bReloadBoot == GTI_TRUE)
                {
                    arrData[0] = LOBYTE(pLbusInfo->wBootId);
                    arrData[1] = HIBYTE(pLbusInfo->wBootId);

                    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,
                        0, GTI_LBUS_BOOT_INST_SIZE + GTI_LBUS_BOOT_ID, 2, arrData))
                        return GTI_FAIL;
                }
                */

                pLbusInfo->bMode = GTI_LBUS_MODE_PRJHEADER;
                pLbusInfo->dwCurrentAdr = GTI_LBUS_PROJ_ID;
                wNumOfBytes = 0;
            }
            else
            {
                wNumOfBytes = (GTI_WORD)(pLbusInfo->wBootLength -
                    ((pLbusInfo->dwCurrentAdr - GTI_LBUS_BOOT_PROG) * 2));

                if((wProcessedIdx + wNumOfBytes) >= wSize)
                    wNumOfBytes = (GTI_WORD)(wSize - wProcessedIdx);
            }
            break;

        case GTI_LBUS_MODE_PRJHEADER:

            wNumOfBytes = 2;

            switch(pLbusInfo->dwCurrentAdr - pLbusInfo->dwProjAddr)
            {
            case GTI_LBUS_PROJ_ID:
                pLbusInfo->wProjId = MAKEWORD(pBuffer[wProcessedIdx], pBuffer[wProcessedIdx + 1]);

                wProjBit = Gti_GetBitFromPageId(pLbusInfo->wProjId);

                if(wProjBit == 0)
                    return GTI_FAIL;

                /* Calculate thr INFO checksum */
                wChkSum = Gti_LocalBusCalcChksum(pXcvrInfo, GTI_LBUS_PROJ_INFO, GTI_LBUS_BOOT_PROG);

                /* Read the info checksum */
                if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, GTI_READ_DSP, GTI_LBUS_GNRL_CHKSUM, 2, arrData))
                    return GTI_FAIL;

                if((pLbusInfo->wLoadedAnnexBmp == 0) || ((wProjBit & pLbusInfo->wLoadedAnnexBmp) == 0))
                {
                    pLbusInfo->dwProjAddr = 0;
                }
                else
                {
                    /* Compare the Checksum that we calculated with what we read */
                    if( (LOBYTE(wChkSum) != arrData[0]) || (HIBYTE(wChkSum) != arrData[1]))
                    {
                        /* The General Info is not valid, so, fill it with zeros */
                        arrData[0] = 0;
                        arrData[1] = 0;
                        arrData[2] = 0;
                        arrData[3] = 0;

                        for( i= GTI_LBUS_GNRL_CHKSUM; i < GTI_LBUS_BOOT_PROG; i += 2)
                        {
                            if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, 0, (GTI_WORD)i, 4, arrData))
                                return GTI_FAIL;
                        }

                        pLbusInfo->dwProjAddr = 0; /* Need to Reload General Info */
                    }
                    else
                    {
                        /* Need to find the address from  General Info*/
                        if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, GTI_READ_DSP,
                            (GTI_WORD)(GTI_LBUS_PROJ_INFO + (pLbusInfo->wProjId * GTI_LBUS_PROJ_INFO_SIZE)), 4, arrData))
                            return GTI_FAIL;

                        pLbusInfo->dwProjAddr  = arrData[0];
                        pLbusInfo->dwProjAddr |= (GTI_DWORD)(arrData[1]) << 8;
                        pLbusInfo->dwProjAddr |= (GTI_DWORD)(arrData[2]) << 16;
                        pLbusInfo->dwProjAddr |= (GTI_DWORD)(arrData[3]) << 24;
                    }
                }

                if(pLbusInfo->dwProjAddr == 0)
                {
                    if(pLbusInfo->wLoadedAnnexBmp != 0)
                    {
                        /* Need to go over all projects and find the last loaded, so to know the availiable address */
                        for(i=0; i < GTI_LBUS_NUMBER_OF_PROJECTS; i ++)
                        {
                            if(Gti_GetBitFromPageId((GTI_WORD)i) & pLbusInfo->wLoadedAnnexBmp)
                            {
                                if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, GTI_READ_DSP,
                                        (GTI_WORD)(GTI_LBUS_PROJ_INFO + (i * GTI_LBUS_PROJ_INFO_SIZE)), 8, arrData))
                                    return GTI_FAIL;

                                dwAddr = arrData[0];
                                dwAddr |= (GTI_DWORD)(arrData[1]) << 8;
                                dwAddr |= (GTI_DWORD)(arrData[2]) << 16;
                                dwAddr |= (GTI_DWORD)(arrData[3]) << 24;

                                dwAddr2 = arrData[4];
                                dwAddr2 |= (GTI_DWORD)(arrData[5]) << 8;
                                dwAddr2 |= (GTI_DWORD)(arrData[6]) << 16;
                                dwAddr2 |= (GTI_DWORD)(arrData[7]) << 24;

                                dwAddr += dwAddr2;

                                if(dwAddr > pLbusInfo->dwProjAddr)
                                    pLbusInfo->dwProjAddr = dwAddr;
                            }
                        }
                    }

                    if(pLbusInfo->dwProjAddr == 0)
                        pLbusInfo->dwProjAddr = GTI_LBUS_BOOT_PROG + pLbusInfo->wBootLength/2;

                    /* allign on the boundary */
                    pLbusInfo->dwProjAddr = pLbusInfo->dwProjAddr + (0x8000 - (pLbusInfo->dwProjAddr & 0x7fff));
                }

                pLbusInfo->dwCurrentAdr = pLbusInfo->dwProjAddr;

                break;
            case GTI_LBUS_PROJ_CHKSUM:
                pLbusInfo->wProjChksum = MAKEWORD(pBuffer[wProcessedIdx], pBuffer[wProcessedIdx + 1]);
                break;
            case GTI_LBUS_PROJ_LENGTH:
                pLbusInfo->dwProjLength = MAKEWORD(pBuffer[wProcessedIdx], pBuffer[wProcessedIdx + 1]);
                break;
            case GTI_LBUS_PROJ_LENGTH + 1:
                pLbusInfo->dwProjLength |= (GTI_DWORD)(MAKEWORD(pBuffer[wProcessedIdx], pBuffer[wProcessedIdx + 1])) << 16;
                break;
            case GTI_LBUS_PROJ_VERSION + 0:
            case GTI_LBUS_PROJ_VERSION + 1:
            case GTI_LBUS_PROJ_VERSION + 2:
            case GTI_LBUS_PROJ_VERSION + 3:
            case GTI_LBUS_PROJ_VERSION + 4:
            case GTI_LBUS_PROJ_VERSION + 5:
            case GTI_LBUS_PROJ_VERSION + 6:
            case GTI_LBUS_PROJ_VERSION + 7:
                i = (int)((pLbusInfo->dwCurrentAdr - pLbusInfo->dwProjAddr - GTI_LBUS_PROJ_VERSION) * 2);
                if((i + 1) < (int)(sizeof(pLbusInfo->bProjVer)))
                {
                    pLbusInfo->bProjVer[i] = pBuffer[wProcessedIdx];
                    pLbusInfo->bProjVer[i + 1] = pBuffer[wProcessedIdx + 1];
                }

                if(pLbusInfo->dwCurrentAdr >= (pLbusInfo->dwProjAddr + GTI_LBUS_PROJ_VERSION + 7))
                {
                    /* finished with project info, start loading */
                    pLbusInfo->bMode = GTI_LBUS_MODE_PRJCODE;
                }

                break;
            default:
                break;
            }
            break;

            case GTI_LBUS_MODE_PRJCODE:
                wNumOfBytes = (GTI_WORD)(wSize - wProcessedIdx);
                if((pLbusInfo->dwCurrentAdr + wNumOfBytes/2) >= (pLbusInfo->dwProjAddr + pLbusInfo->dwProjLength/2))
                {
                    /* end of story, almost done */
                    wNumOfBytes = (GTI_WORD)((pLbusInfo->dwProjAddr + pLbusInfo->dwProjLength/2 - pLbusInfo->dwCurrentAdr) * 2);
                    pLbusInfo->bMode = GTI_LBUS_MODE_IDLE;

                    /* Update the project address in the table */
                    arrData[0] = (GTI_BYTE)(pLbusInfo->dwProjAddr);
                    arrData[1] = (GTI_BYTE)(pLbusInfo->dwProjAddr >> 8);
                    arrData[2] = (GTI_BYTE)(pLbusInfo->dwProjAddr >> 16);
                    arrData[3] = (GTI_BYTE)(pLbusInfo->dwProjAddr >> 24);
                    /* Update the project length in the table */
                    arrData[4] = (GTI_BYTE)(pLbusInfo->dwProjLength);
                    arrData[5] = (GTI_BYTE)(pLbusInfo->dwProjLength >> 8);
                    arrData[6] = (GTI_BYTE)(pLbusInfo->dwProjLength >> 16);
                    arrData[7] = (GTI_BYTE)(pLbusInfo->dwProjLength >> 24);

                    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, 0,
                        (GTI_WORD)(GTI_LBUS_PROJ_INFO + (pLbusInfo->wProjId * GTI_LBUS_PROJ_INFO_SIZE)), 8, arrData))
                        return GTI_FAIL;

                    /* Update the project address in the table */
                    arrData[0] = (GTI_BYTE)(GTI_LBUS_RW_START_ADDR & 0xff);
                    arrData[1] = (GTI_BYTE)((GTI_LBUS_RW_START_ADDR >> 8) & 0xff);
                    arrData[2] = (GTI_BYTE)((GTI_LBUS_RW_START_ADDR >> 16) & 0xff);
                    arrData[3] = 0;
                    arrData[4] = (GTI_BYTE)(GTI_LBUS_MAX_PROFILE_PER_CORE & 0xff);
                    arrData[5] = (GTI_BYTE)((GTI_LBUS_MAX_PROFILE_PER_CORE >> 8) & 0xff);

                    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, 0, GTI_LBUS_GNRL_STACK_DATA, 6, arrData))
                        return GTI_FAIL;

                    /* Calculate the INFO checksum */
                    wChkSum = Gti_LocalBusCalcChksum(pXcvrInfo, GTI_LBUS_PROJ_INFO, GTI_LBUS_BOOT_PROG);

                    arrData[0] = LOBYTE(wChkSum);
                    arrData[1] = HIBYTE(wChkSum);

                    if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM, 0, GTI_LBUS_GNRL_CHKSUM, 2, arrData))
                        return GTI_FAIL;

                    wReturn = GTI_COMPLETE_PASS;

                    Gti_SetDspProjectType(pXcvrInfo, (GTI_BYTE)pLbusInfo->wProjId);

                    pLbusInfo->wLoadedAnnexBmp |= Gti_GetBitFromPageId(pLbusInfo->wProjId);
                }
                break;

            case GTI_LBUS_MODE_IDLE:
            default:
                return GTI_FAIL;
        }

        /* Load the LBUS here, if there is need in it */
        if((wNumOfBytes) && (wProcessedIdx < wSize))
        {
            if((pLbusInfo->bMode != GTI_LBUS_MODE_BOOT) || (pLbusInfo->bReloadBoot))
            {
                if(!Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,
                    (GTI_BYTE)(pLbusInfo->dwCurrentAdr >> 16), (GTI_WORD)pLbusInfo->dwCurrentAdr,
                    wNumOfBytes, (GTI_BYTE GTI_ADDRESS_QUAL *)(&pBuffer[wProcessedIdx])))
                    return GTI_FAIL;
            }
            pLbusInfo->dwCurrentAdr += wNumOfBytes / 2;
            wProcessedIdx = (GTI_WORD)(wProcessedIdx + wNumOfBytes);
        }

    } /* while processing */


    if(wReturn == GTI_COMPLETE_PASS)
    {
        /* start the top level XDP from LBUS address 0000 */
        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_TOP, GTI_NO_AI);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_TOP, 0xa6, GTI_IREGA);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_TOP, 0x00, 0x80);
    }

    /* pLbusInfo->dwMaxSize += wProcessedIdx; */
    *wLoadedIdx = wSize;
    return wReturn;
}

#if defined(GTI_USE_XDPXFR)
/*****************************************************************************/
/* Name:    Gti_IsCXfrActive                                                 */
/* Input:                                                                    */
/* pSysPtr: System pointer                                                   */
/*****************************************************************************/
int Gti_IsCXfrActive(GTI_XCVR_INFO* pXcvrInfo)
{
    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_NO_AI);
    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, XSRAM_SAS_STATUS, GTI_XSRAM0|GTI_READ_DSP);
    return (READ_DSP_WORD(pXcvrInfo, GTI_DSP_A) == GTI_ACTIVE);
}
#endif

/*****************************************************************************/
/* Name:    Gti_GetHostDW                                                    */
/* Input:                                                                    */
/* pSysPtr: System pointer                                                   */
/* id:      Host Ram location byte                                           */
/*****************************************************************************/
GTI_WORD
Gti_GetHostDW(GTI_XCVR_INFO* pXcvrInfo, GTI_WORD wId)
{
    GTI_WORD wPage, wOffs, wResult;
    GTI_BYTE arrData[2];

    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, XSRAM_PROFILE_OFFS, GTI_XSRAM0|GTI_READ_DSP);
    wOffs = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    wPage = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);

    if(Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,
        (GTI_BYTE)(GTI_READ_DSP | wPage), (GTI_WORD)(wOffs + wId/2), 2, arrData))
    {
        wResult = (GTI_WORD)arrData[0];
        wResult |= (GTI_WORD)(arrData[1] << 8);
        return wResult;
    }

    return 0;
}

/*****************************************************************************/
/* Name:    Gti_GetHostDB                                                    */
/* Input:                                                                    */
/* pSysPtr: System pointer                                                   */
/* id:      Host Ram location byte                                           */
/*****************************************************************************/
GTI_BYTE
Gti_GetHostDB(GTI_XCVR_INFO* pXcvrInfo, GTI_WORD wId)
{
    GTI_WORD wPage, wOffs;
    GTI_BYTE arrData[2];

    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, XSRAM_PROFILE_OFFS, GTI_XSRAM0|GTI_READ_DSP);
    wOffs = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    wPage = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);

    if(Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,
        (GTI_BYTE)(GTI_READ_DSP | wPage), (GTI_WORD)(wOffs + wId/2), 2, arrData))
    {
            return arrData[wId & 0x1];
    }

    return 0;
}

/*****************************************************************************/
/* Name:    GetHostDB                                                        */
/* Input:                                                                    */
/* pSysPtr: System pointer                                                   */
/* id:      Host Ram location byte                                           */
/*****************************************************************************/
void
Gti_SetHostDB(GTI_XCVR_INFO* pSysPtr, GTI_WORD wId, GTI_BYTE bData)
{
/*
    int nMemID, nAddress;
    GTI_WORD wData;

    nAddress = wId/2;

    nMemID = (nAddress <= 0xff) ? GTI_IRAME : GTI_IRAMF;

    CONFIGURE_DSP(pSysPtr, GTI_DSP_A, GTI_NO_AI);
    WRITE_DSP_ADDR(pSysPtr, GTI_DSP_A, (GTI_BYTE)nAddress, nMemID|GTI_READ_DSP);
    wData = READ_DSP_WORD(pSysPtr, GTI_DSP_A);

    WRITE_DSP_ADDR(pSysPtr, GTI_DSP_A, (GTI_BYTE)nAddress, nMemID);

    if(wId & 0x1)
    {
        WRITE_DSP_WORD(pSysPtr, GTI_DSP_A, (GTI_BYTE)wData, bData);
    }
    else
    {
        WRITE_DSP_WORD(pSysPtr, GTI_DSP_A, bData, (GTI_BYTE)(wData >> 8));
    }

    */
    (void)pSysPtr;
    (void)wId;
    (void) bData;
}

/*****************************************************************************/
/* Name:    Gti_GetHostDBlock                                                */
/* Input:                                                                    */
/* pSysPtr: System pointer                                                   */
/* id:      Host Ram location byte                                           */
/*          Provided buffer should be at least 2 byte more than neccesary    */
/*          for the translation operations                                   */
/*****************************************************************************/
void
Gti_GetHostDBlock(GTI_XCVR_INFO* pXcvrInfo, GTI_WORD wId,
                  GTI_WORD wLength, GTI_BYTE *pBuffer)
{
    GTI_WORD wPage, wOffs;
    int i;
    GTI_BYTE arrData[512];

    if(wLength >= 512)
        return;

    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, XSRAM_PROFILE_OFFS, GTI_XSRAM0|GTI_READ_DSP);
    wOffs = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);
    wPage = READ_DSP_WORD(pXcvrInfo, GTI_DSP_A);

    if(Gti_ExtMemoryAccess(pXcvrInfo, EXTERNAL_LBRAM,
        (GTI_BYTE)(GTI_READ_DSP | wPage), (GTI_WORD)(wOffs + wId/2), wLength, arrData))
    {
        for(i=0; i<wLength ; i++)
            pBuffer[i] = arrData[i+1];
    }
}
/*****************************************************************************/
/* Name:    Gti_BuildDspMsg                                                  */
/* Input:                                                                    */
/* wId:     Msg Id                                                           */
/* Returns: Number of buffer elements                                        */
/*****************************************************************************/
GTI_WORD
Gti_BuildDspMsg(GTI_XCVR_INFO *pXcvrInfo, GTI_WORD wIndex,
                GTI_WORD wMsgId, GTI_WORD nLen, GTI_BYTE *pBuf)
{
    GTI_WORD nBufIdx, wTotalLen;

    if(nLen/2 >= GTI_MAX_MBOX_SIZE)
        return 0;

    nBufIdx = (GTI_WORD)(wIndex + nLen/2 + 2);
    wTotalLen = (GTI_WORD)(wIndex + nLen/2 + 2);

    CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_AI);

    if(wMsgId < 0xff)
    {
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, XSRAM_TRACE_OFFS, GTI_XSRAM0);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0x00, 0x00);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0x07, 0x00);
    }

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, GTI_MSG_LENGTH, GTI_XSRAM0);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, LOBYTE(wTotalLen), HIBYTE(wTotalLen));

    WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, GTI_MSG_BODY_START + wIndex, GTI_XSRAM1);
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, LOBYTE(wMsgId), HIBYTE(wMsgId));
    WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, LOBYTE(nLen/2), HIBYTE(nLen/2));

    if((pBuf) && (nLen))
    {
        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_DMA);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, GTI_MSG_BODY_START + wIndex + 2, GTI_XSRAM1);
        WRITE_DSP_BLOCK(pXcvrInfo, GTI_DSP_A, GTI_DATAL_DSP, nLen, pBuf);
    }

    return nBufIdx;
}
/*****************************************************************************/
/* Name:    Gti_SendDspMsg                                                   */
/* Input:                                                                    */
/* wId:         Msg Id                                                       */
/* pXcvrInfo:   Xcvr Info pointer                                            */
/*****************************************************************************/
GTI_WORD Gti_SendDspMsg(GTI_XCVR_INFO *pXcvrInfo, GTI_WORD wPageId)
{
    if(wPageId >= GTI_LBUS_NUMBER_OF_PROJECTS)
        return GTI_FALSE;

    if((pXcvrInfo->pChipInfo->pSystInfo->Lbus_db[pXcvrInfo->pChipInfo->wLbusID].wLoadedAnnexBmp)
        & (Gti_GetBitFromPageId(wPageId)))
    {
        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_A, GTI_NO_AI);

        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, GTI_XSRAM_PROJ_ID, GTI_XSRAM0);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, LOBYTE(wPageId), HIBYTE(wPageId));

        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, GTI_MSG_RESULT, GTI_XSRAM0);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0x00, 0x00);

        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_A, GTI_MSG_FLAG, GTI_XSRAM0);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_A, 0x01, 0x00);

        CONFIGURE_DSP(pXcvrInfo, GTI_DSP_TOP, GTI_NO_AI);
        WRITE_DSP_ADDR(pXcvrInfo, GTI_DSP_TOP, 0xa6, GTI_IREGA);
        WRITE_DSP_WORD(pXcvrInfo, GTI_DSP_TOP, 0x00, 0x10);

        UPDATE_DSP(pXcvrInfo);

        return GTI_TRUE;
    }
    else
        return GTI_FALSE;
}

#endif
