/* 03/01/23 16:09:05 = RETRIEVAL
 * 01/08/23 16:21:31 = DELTA
 * @(#)gti_lbus.h	1.6
 */

/************************************************************************/
/* TSM         Application Code header                                  */
/* (C) Copyright 1999-2000 by GlobeSpan Technologies Inc                */
/************************************************************************/

#define GTI_FW_LOAD_FIRST           0
#define GTI_FW_LOAD_NEXT            1


#define GTI_LBUS_MODE_IDLE          0
#define GTI_LBUS_MODE_BOOT          1
#define GTI_LBUS_MODE_PRJHEADER     2
#define GTI_LBUS_MODE_PRJCODE       3

/**************** Definitions for LBUS in 16 bit words ******************/
#define GTI_LBUS_NUMBER_OF_PROJECTS  32

#define GTI_LBUS_BOOT_INST          0x00
#define GTI_LBUS_BOOT_INST_SIZE     32
#define GTI_LBUS_BOOT_INFO          0x20
#define GTI_LBUS_BOOT_INFO_SIZE     32
#define GTI_LBUS_GNRL_INFO          0x40
#define GTI_LBUS_GNRL_INFO_SIZE     16
#define GTI_LBUS_PROJ_INFO          0x50
#define GTI_LBUS_PROJ_INFO_SIZE     8

#define GTI_LBUS_GNRL_CHKSUM        0x40
#define GTI_LBUS_GNRL_LOCKFL        0x41
#define GTI_LBUS_GNRL_STACK_DATA    0x42

#define GTI_LBUS_BOOT_PROG          0x150

#define GTI_LBUS_BOOT_ID            0
#define GTI_LBUS_BOOT_CHKSUM        1
#define GTI_LBUS_BOOT_LENGTH        2
#define GTI_LBUS_BOOT_VERSION       8
#define GTI_LBUS_BOOT_MKTIME        16

#define GTI_LBUS_PROJ_ID            0
#define GTI_LBUS_PROJ_CHKSUM        1
#define GTI_LBUS_PROJ_LENGTH        2
#define GTI_LBUS_PROJ_VERSION       8
#define GTI_LBUS_PROJ_MKTIME        16

/* defines for the core XSRAM */
#define XSRAM_TRACE_OFFS    0x09
#define XSRAM_TRACE_PAGE    0x0a

/* Definitions for Mailbox structure */
#define GTI_MAX_MBOX_SIZE   256

#define GTI_XSRAM_PROJ_ID   0x02

#define GTI_MSG_BODY_START  0x00
#define GTI_MSG_FLAG        0xF4
#define GTI_MSG_LENGTH      0xFE
#define GTI_MSG_RESULT      0xFF

#define GTI_NUM_OF_MSG_ID   0x00
