/*
 * @(#)gti_yat.c	1.13
*/

#include "gti.h"

#ifdef GTI_PAGE_A_BUILT
#include "gtipsasa.h"
#endif
#ifdef GTI_PAGE_B_BUILT
#include "gtipsasb.h"
#endif
#ifdef GTI_PAGE_C_BUILT
#include "gtipsasc.h"
#endif
#ifdef GTI_PAGE_D_BUILT
#include "gtipsasd.h"
#endif

#ifdef __BORLANDC__
#pragma option -zESTARTUP_TABLE -zFSPECIAL
#endif

/* The followng tables are the Startup Look Up tables that are used in gtiparam.c */

/******************************************** Page A *********************************************/

#ifdef GTI_PAGE_A_BUILT

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_a[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCoHVY_a_PAGE_CMD,   GTI_startDmtToneCpHVY_a_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDisHVY_a_PAGE_CMD,       GTI_abortCpDisHVY_a_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_abortCoDisHVY_a_PAGE_CMD,       GTI_abortCpDisHVY_a_PAGE_CMD,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecRevTstHVY_a_PAGE_CMD,     GTI_CpSpecRevTstHVY_a_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_TestRsMemory_a_PAGE_CMD,        GTI_TestRsMemory_a_PAGE_CMD,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTstHVY_a_PAGE_CMD,     GTI_CpSpecMedTstHVY_a_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_CoSpecPilotTstHVY_a_PAGE_CMD,   GTI_CpSpecPilotTstHVY_a_PAGE_CMD,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_COFastRetrain_a_PAGE_CMD,       GTI_CPFastRetrain_a_PAGE_CMD,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_COProfMngt_a_PAGE_CMD,          GTI_CPProfMngt_a_PAGE_CMD,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_CoSpecCoPBinTstHVY_a_PAGE_CMD,  GTI_CpSpecCoPBinTstHVY_a_PAGE_CMD,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_CPBitSwapping_a_PAGE_CMD,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_CoSpecCpPBinTstHVY_a_PAGE_CMD,  GTI_CpSpecCpPBinTstHVY_a_PAGE_CMD,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_a_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* After Jup Calibration        0 */ {StartAfterJupCalibration , GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,           GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,           GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,           GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,           GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};

#endif /* Page A */

#ifdef GTI_PAGE_B_BUILT

/******************************************** Page B *********************************************/

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_b[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCo_b_PAGE_CMD,   GTI_startDmtToneCp_b_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDis_b_PAGE_CMD,       GTI_abortCpDis_b_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecTest_b_PAGE_CMD,          GTI_CpSpecTest_b_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTst_b_PAGE_CMD,        GTI_CpSpecMedTst_b_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_b_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Comment about usage          0 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};
#endif /* End B  */

#ifdef GTI_PAGE_C_BUILT

/******************************************** Page C *********************************************/

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_c[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+------------------------- LABELS -----------------------*/
    /* ---------------------------------+------------ CO --------------+-------- CP -------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DISCONNECT_REQ           3  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_a_startALpbk_c_PAGE_CMD,        GTI_a_startALpbk_c_PAGE_CMD,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_a_startDLpbk_c_PAGE_CMD,        GTI_a_startDLpbk_c_PAGE_CMD,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_downLdTstCOM_c_PAGE_CMD,        GTI_downLdTstCOM_c_PAGE_CMD,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_AtmLoopBackCOM_c_PAGE_CMD,      GTI_AtmLoopBackCOM_c_PAGE_CMD,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_TestDriversCOM_c_PAGE_CMD,      GTI_TestDriversCOM_c_PAGE_CMD,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_REQ      30 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_R_MTPR_REQ      32 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_JupTxFltCali_c_PAGE_CMD,        GTI_JupTxFltCali_c_PAGE_CMD,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_SpecCRevTstRX_c_PAGE_CMD,       GTI_SpecCRevTstRX_c_PAGE_CMD,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_SpecCPBinTstRX_c_PAGE_CMD,      GTI_SpecCPBinTstRX_c_PAGE_CMD,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_c_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Jump To Jupiter calibration  0 */ {GTI_JupTxFltCali_c_PAGE_CMD,GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};

#endif /* Page "C" */

#ifdef GTI_PAGE_D_BUILT

/******************************************** Page D *********************************************/

GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_d[GTI_MAX_ACTION_REQ_NUMBER * 2] =
{
    /* --------- ACTIONS ---------------+--------------------------------- LABELS ------------------------------*/
    /* ---------------------------------+------------ CO -----------------------+-------- CP -------------------*/
    /* GTI_STARTUP_REQ              0  */   GTI_startDmtToneCoHVY_d_PAGE_CMD,   GTI_startDmtToneCpHVY_d_PAGE_CMD,
    /* GTI_TEST_REQ                 1  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ABORT_REQ                2  */   GTI_abortCoDisHVY_d_PAGE_CMD,       GTI_abortCpDisHVY_d_PAGE_CMD,
    /* GTI_DISCONNECT_REQ           3  */   GTI_abortCoDisHVY_d_PAGE_CMD,       GTI_abortCpDisHVY_d_PAGE_CMD,
    /*       ---                    4  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_REQ      5  */   GTI_CoSpecRevTstHVY_d_PAGE_CMD,     GTI_CpSpecRevTstHVY_d_PAGE_CMD,
    /* GTI_ANALOG_LB_REQ            6  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DIGITAL_LB_REQ           7  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DOWNLOAD_REQ             8  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_RS_MEM_TEST_REQ          9  */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_ATM_LP_REQ               10 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    11 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    12 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    13 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    14 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    15 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    16 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    17 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    18 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_START_REQ           19 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_BERT_STOP_REQ            20 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    21 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    22 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_DRIVERS_TEST_REQ         23 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    24 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /*       ---                    25 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_MEDLEY_REQ      26 */   GTI_CoSpecMedTstHVY_d_PAGE_CMD,     GTI_CpSpecMedTstHVY_d_PAGE_CMD,
    /* GTI_SPECTRUM_PILOT_REQ       27 */   GTI_CoSpecPilotTstHVY_d_PAGE_CMD,   GTI_CpSpecPilotTstHVY_d_PAGE_CMD,
    /* GTI_FAST_RETRAIN_REQ         28 */   GTI_COFastRetrain_d_PAGE_CMD,       GTI_CPFastRetrain_d_PAGE_CMD,
    /* GTI_PROF_MNGT_REQ            29 */   GTI_EMPTY_ACTION,                   GTI_CPProfMngt_d_PAGE_CMD,
    /* GTI_SPECTRUM_C_PBIN_REQ      30 */   GTI_CoSpecCoPBinTstHVY_d_PAGE_CMD,  GTI_CpSpecCoPBinTstHVY_d_PAGE_CMD,
    /* GTI_BIT_SWAPPING_REQ         31 */   GTI_EMPTY_ACTION,                   GTI_CPBitSwapping_d_PAGE_CMD,
    /* GTI_SPECTRUM_R_PBIN_REQ      32 */   GTI_CoSpecCpPBinTstHVY_d_PAGE_CMD,  GTI_CpSpecCpPBinTstHVY_d_PAGE_CMD,
    /*       ---                    33 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_JUPITER_TX_REQ  34 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_REVERB_RX_REQ   35 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
    /* GTI_SPECTRUM_C_MTPR_RX_REQ   36 */   GTI_EMPTY_ACTION,                   GTI_EMPTY_ACTION,
};

/* Context switching during Start Up */
struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_d_tbl[GTI_MAX_YAT_TABLE_SIZE] =
{
    /* --------- COMMENT ---------------+--SAS LABEL ----------------+---NOT USED----------------------------*/
    /* Comment about usage          0 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          1 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          2 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          3 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* Comment about usage          4 */ {GTI_EMPTY,                  GTI_PAGE_NONE},
    /* If adding more need to edit GTI_MAX_YAT_TABLE_SIZE and each "page" */
    /* Never delete lines, only change to "EMPTY"                         */
};

#endif /* Page "D" */


#ifdef __BORLANDC__
#pragma option -zE* -zF*
#endif
