/* 01/01/23 21:04:31 = RETRIEVAL
 * 01/01/23 17:07:07 = DELTA
 * @(#)gtistat.c	1.6.4.6
 */

/************************************************************************/
/* TSM     Application Code                                             */
/* (C) Copyright 1996-2002 by GlobeSpan Technologies Inc                */
/************************************************************************/

#include "gti.h"
#include "gti_rel.h"
#include "gtistat.h"
#include "gtidsp.h"
#include "gtiextn.h"
#include "gti_sym.h"

#ifdef GTI_DEBUG
#include "p3hw.h"
#include "extern.h"
#include "global.h"
#endif

void Gti_CalculateSNR(GTI_XCVR_INFO *pSys,char *pAverage, GTI_WORD dwAverage, GTI_WORD nAvSum);

#ifdef __BORLANDC__
#pragma option -zECONST -zFCONST -zHCONST
#endif

    GTI_WORD GTI_CONST_QUAL GTI_ADDRESS_QUAL Margin_Per_Bin_Trans[16] =
    {
        0,   0,   7,  11,  16,  23,  33,  46,
        66, 93, 132, 186, 264, 373, 527, 746
    };

    GTI_WORD GTI_CONST_QUAL GTI_ADDRESS_QUAL Avrg_Margin_Trans[] =
    {
        0xEFC0, 0xE256, 0xD5AD, 0xC9B9, 0xBE70, 0xB3C9, 0xA9BB, 0xA03C,
        0x9745, 0x8ECF, 0x86D2, 0x7F47, 0x7828, 0x7170, 0x6B17, 0x651A,
        0x5F72, 0x5A1B, 0x5511, 0x504E, 0x4BD0, 0x4793, 0x4392, 0x3FCA,
        0x3C39, 0x38DA, 0x35AC, 0x32AB, 0x2FD6, 0x2D29, 0x2AA2, 0x283F,
        0x25FF, 0x23DF, 0x21DD, 0x1FF8, 0x1E2E, 0x1C7E, 0x1AE6, 0x1965,
        0x17F9, 0x16A2, 0x155E, 0x142C, 0x130B, 0x11FA, 0x10F9, 0x1006,
        0x0F20, 0x0E47, 0x0D7B, 0x0CBA, 0x0C04, 0x0B58, 0x0AB5, 0x0A1C,
        0x098B, 0x0902, 0x0881, 0x0807, 0x0794, 0x0728, 0x06C1, 0x0661,
        0x0605, 0x05AF, 0x055E, 0x0511, 0x04C8, 0x0484, 0x0443, 0x0406,
        0x03CC, 0x0396, 0x0362, 0x0332, 0x0304, 0x02D9, 0x02B0, 0x028A,
        0x0265, 0x0243, 0x0223, 0x0204, 0x01E7, 0x01CC, 0x01B2, 0x019A,
        0x0183, 0x016D, 0x0159, 0x0145, 0x0133, 0x0122, 0x0112, 0x0102,
        0x00F4, 0x00E6, 0x00D9, 0x00CD, 0x00C2, 0x00B7, 0x00AC, 0x00A3,
        0x009A, 0x0091, 0x0089, 0x0081, 0x007A, 0x0073, 0x006D, 0x0067,
        0x0061, 0x005B, 0x0056, 0x0051, 0x004D, 0x0048, 0x0044, 0x0041,
        0x003D, 0x0039, 0x0036, 0x0033, 0x0030, 0x002E, 0x002B, 0x0029,
        0x0026, 0x0024, 0x0022, 0x0020, 0x001E, 0x001D, 0x001B, 0x0019,
        0x0018, 0x0017, 0x0015, 0x0014, 0x0013, 0x0012, 0x0011, 0x0010,
        0x000F, 0x000E, 0x000D, 0x000C, 0x000C, 0x000B, 0x000A, 0x000A,
        0x0009, 0x0009, 0x0008, 0x0008, 0x0007, 0x0007,
    };

#ifdef __BORLANDC__
#pragma option -zE* -zF* -zH*
#endif

/******************************************************************************/
/* Procedure: GetBitsPerBinStatus               Created: 09.24.98             */
/* ----------------------                                                     */
/* Description: The function retrieves Bits/Bin status by reading DSP memory  */
/*          and filling out the input/output buffer.                          */
/* -------------------------------------------------------------------------- */
GTI_WORD
GetBitsPerBinStatus(GTI_XCVR_INFO *pSys,                  /* Xcvr pointer     */
            GTI_WORD nStatusType,                         /* Status type      */
            GTI_BYTE *pBuffer,                            /* Data Buffer      */
            GTI_WORD nLength)                             /* Data Buffer Len  */
{
    GTI_BYTE bData, baseFDPAddr;
    GTI_WORD bTotalBins, nRetSize, i, nMultFact;
    GTI_WORD nTonesTblLoc, bBinsNumLoc, nTempLoc, nBinNum;
    GTI_BYTE read_blk_data[1536];
    GTI_BYTE start_ram;
    GTI_WORD wSize, wData, wAddress;

    nMultFact = 1;

    if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C )
    {
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            switch(nStatusType)
            {
            case GTI_BIT_LOADING_UP:
                nTonesTblLoc = GTI_RxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_noRxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAMC;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_NEXT_UP:
                nTonesTblLoc = GTI_RxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_noRxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAMC;
                nRetSize = GTI_BIT_LOADING_NEXT_UP_LEN;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_DN:
                nTonesTblLoc = GTI_TxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_noTxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAME;
                nMultFact = 2;
                wSize = 0x200;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            case GTI_BIT_LOADING_NEXT_DN:
                nTonesTblLoc = GTI_TxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_noTxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAM2;
                nMultFact = 2;
                wSize = 0x200;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            default:
                return 0;
            }

        }
        else /* CP */
        {
            switch(nStatusType)
            {
            case GTI_BIT_LOADING_UP:
                nTonesTblLoc = GTI_cpTxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_cpnoTxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAMF;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                nMultFact = 2;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_NEXT_UP:
                nTonesTblLoc = GTI_cpTxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_cpnoTxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAMF;
                nRetSize = GTI_BIT_LOADING_NEXT_UP_LEN;
                nMultFact = 2;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_DN:
                nTonesTblLoc = GTI_cpRxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_cpnoRxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAMA;
                wSize = 0x100;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            case GTI_BIT_LOADING_NEXT_DN:
                nTonesTblLoc = GTI_cpRxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_cpnoRxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAME;
                wSize = 0x100;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            default:
                return 0;
            }
        } /* if CO CP */
    }
    else
    {   /* not Annex C */
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            if((nStatusType == GTI_BIT_LOADING_UP) || (nStatusType == GTI_BIT_LOADING_NEXT_UP))
            {
                nTonesTblLoc = GTI_RxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_noRxBins_LOC;
                start_ram = GTI_FDPSRAM7;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                wSize = 0x40;
            }
            else
            {
                nTonesTblLoc = GTI_TxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_noTxBins_LOC;
                start_ram = GTI_FDPSRAM4;
                nMultFact = 2;
                wSize = 0x200;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
            }
        }
        else     /* CP */
        {
            if((nStatusType == GTI_BIT_LOADING_UP) || (nStatusType == GTI_BIT_LOADING_NEXT_UP))
            {
                nTonesTblLoc = GTI_cpTxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_cpnoTxBins_LOC;
                start_ram = GTI_FDPSRAMC;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                nMultFact = 2;
                wSize = 0x40;
            }
            else
            {
                nTonesTblLoc = GTI_cpRxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_cpnoRxBins_LOC;
                start_ram = GTI_FDPSRAM7;
                wSize = 0x100;
                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
            }
        }
    }

    if(nLength < nRetSize)
        return 0;

    for(i = 0; i < nRetSize; i++)
        pBuffer[i] = 0;

    for(i = 0; i < 1536; i++)
        read_blk_data[i] = 0;

    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);

    baseFDPAddr = (GTI_BYTE)(bBinsNumLoc >> 0x08);

    if( baseFDPAddr < 0x8 )
        baseFDPAddr = (GTI_BYTE)((baseFDPAddr + GTI_FDPSRAM0) | GTI_READ_DSP);
    else
        baseFDPAddr = (GTI_BYTE)((baseFDPAddr + GTI_FDPSRAM8 - 8) | GTI_READ_DSP);

    /* Read total number of bits/bin */
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, (GTI_BYTE)bBinsNumLoc, baseFDPAddr);

    bTotalBins = (GTI_WORD)((READ_DSP_BYTE(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP) >> 0x04) & 0x0f);
    bTotalBins |= (READ_DSP_WORD(pSys, GTI_DSP_A) & 0xff) << 0x04;

    wAddress = MAKEWORD((nTonesTblLoc & 0xff), start_ram);

    i = 0;
    while(wSize > 0)
    {
        if(wSize > (255 - LOBYTE(wAddress)))
            wData = (GTI_WORD)(255 - LOBYTE(wAddress));
        else
            wData = wSize;

        /* if we are reading the last word on the page */
        /* change the mode to non AI  to avoid lockups */

        if((LOBYTE(wAddress)) == 0xff)
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);
            wData = 1;
        }
        else
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_READ_BLOCK_MODE);
        }

        WRITE_DSP_ADDR(pSys, GTI_DSP_A, LOBYTE(wAddress),
            HIBYTE(wAddress)|GTI_READ_DSP);

        READ_DSP_EXT_BLOCK(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP, wData * 3, &read_blk_data[i]);

        wAddress = (GTI_WORD)(wAddress + wData);
        wSize = (GTI_WORD)(wSize - wData);
        i = (GTI_WORD)(i + (wData * 3));
    }

    for(nBinNum = 0, i = 0; i < bTotalBins; i++)
    {
        nTempLoc = (GTI_WORD)(nBinNum * nMultFact);

        /* list 4 bits are a Bits/Bin data */
        bData = (GTI_BYTE) ((read_blk_data[nTempLoc * 3] >> 0x04) & 0x0f);

        wData = (GTI_WORD)((read_blk_data[3 * nTempLoc + 1] | (read_blk_data[3 * nTempLoc + 2] << 8)));

        /* most 8 bits are the next offset */
        nBinNum = (GTI_WORD)(((wData >> 0x08) & 0xff));

        pBuffer[nBinNum] = bData;
    }

    return nRetSize; /* length of a buffer in bytes     */
}

/******************************************************************************/
/* Procedure: Gti_GetMeanSQStatus             Created: 09.24.98               */
/* --------------------------------                                           */
/* Description: The function calculates Signal Quality status                 */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_GetMeanSQStatus(GTI_XCVR_INFO *pSys,                  /* Xcvr pointer     */
            GTI_WORD nStatusType,                         /* Status type      */
            GTI_WORD *pBuffer,                            /* Data Buffer      */
            GTI_WORD nLength)                             /* Data Buffer Len  */
{
    GTI_WORD nRetSize;
    GTI_BYTE bAddress, bMemType, bFullArr[256 * 3];
    int i, k;

    /* Are we CO or CP */
    if(Gti_GetCurrentMode(pSys) == GTI_CO)
    {
        if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
        {
            if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                i = GTI_coNSRArrayNextHost_LOC;
            else
                i = GTI_coNSRArrayFextHost_LOC;
        }
        else
            i = GTI_co_NSR_ADR_LOC;

        bAddress = LOBYTE(i);
        bMemType = HIBYTE(i);
        nRetSize = 32;
    }
    else  /* CP */
    {
        if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
        {
            if(!Gti_IsCXfrActive(pSys)) /* if data mode, read RSRAM */
            {
                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD )
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_NSR_NEXT_ADDRESS_LOC;
                    else
                        i = GTI_NSR_FEXT_ADDRESS_LOC;

                    nRetSize = 128;
                }
                else
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_NSR_NEXT_ADDRESS_LOC;
                    else
                        i = GTI_NSR_FEXT_ADDRESS_LOC;

                    nRetSize = 256;
                }
            }
            else /* if training, read FDPRAM */
            {
                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD )
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_cpNSRArrayNextHost_LOC;
                    else
                        i = GTI_cpNSRArrayFextHost_LOC;

                    nRetSize = 128;
                }
                else
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_cpNSRArrayNextHost_LOC;
                    else
                        i = GTI_cpNSRArrayFextHost_LOC;

                    nRetSize = 256;
                }
            }
        }
        else /* not Annex C */
        {
            if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD )
            {
                i = GTI_cp_NSR_ADR_LOC;
                nRetSize = 128;
            }
            else
            {
                i = GTI_cp_NSR_ADR_LOC;
                nRetSize = 256;
            }
        }
        bAddress = LOBYTE(i);
        bMemType = HIBYTE(i);
    }

    if(nLength >= nRetSize)
    {
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
        }
        else /* CP */
        {
            if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
            {
                if( !Gti_IsCXfrActive(pSys) )
                    bMemType = (GTI_BYTE)(bMemType + GTI_IRAM0);
                else
                    bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
            }
            else /* not Annex C*/
                bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
        }

        /* Read SQ */
        CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_READ_BLOCK_MODE);
        WRITE_DSP_ADDR(pSys, GTI_DSP_A, bAddress, (GTI_BYTE)(bMemType | GTI_READ_DSP));

        READ_DSP_EXT_BLOCK(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP, nRetSize * 3, bFullArr);

        for(i=0, k=0; k < nRetSize; i+=3, k++)
        {
            pBuffer[k] = MAKEWORD((bFullArr[i + 1]), (bFullArr[i + 2]));

            if(Gti_GetCurrentMode(pSys) != GTI_CO)
            {
                if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
                {
                    if( !Gti_IsCXfrActive(pSys) )   /* divide by 8 in data mode only */
                    {
                        if(pBuffer[k] != 0xffff)
                            pBuffer[k] = (GTI_WORD)(pBuffer[k] / 8);
                    }
                }
            }
        }

        return  (GTI_WORD)(nRetSize * 2);
    }
    else
        return 0;
}

void Gti_CalculateSNR(GTI_XCVR_INFO *pSys,char *pAverage, GTI_WORD dwAverage, GTI_WORD nAvSum)
{
int nTempData = 0;
GTI_WORD wData=0;

   nTempData = (int)(dwAverage / nAvSum) - 30;

   nTempData = nTempData + ((int)GET_HOST_DB_B(pSys, GTI_ACT_CODING_GAIN2) & 0xff) / 2;

   *pAverage = (nTempData > 127) ? 127 : (char)nTempData;

   wData = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_TRELLIS)) |
         ((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_TRELLIS+1)) << 0x08);

   if(wData == GTI_TRELLIS_ENABLE)
   {
       *pAverage += 3;
   }

   *pAverage -= (char)GET_HOST_DB_B(pSys, GTI_MARGIN_O_D);
   *pAverage += (char)GET_HOST_DB_B(pSys, GTI_MARGIN_O_U);
}

/******************************************************************************/
/* Procedure: GetMarginPerBinStatus             Created: 09.24.98             */
/* --------------------------------                                           */
/* Description: The function calculates margin per bin status from SQ status  */
/*          and Bits per Bin status arrays.                                   */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_GetMarginPerBinStatus(GTI_XCVR_INFO *pSys,
                      GTI_WORD nStatusType,
                      GTI_WORD *pBuffer,
                      GTI_WORD nLength,
                      char *pAverage)
{
    GTI_WORD wSQ[256], wData, wAverage = 0, i, k, nUsedBins, nBitLoading, nAvSum = 0;
    int nTempData;
    GTI_BYTE bBitsPerBin[256];
    GTI_WORD sortData[256];
    GTI_WORD lowValue;
    GTI_WORD tData;

    if(pAverage)
        *pAverage = 0;

    switch(nStatusType)
    {

    case GTI_SNR_MARGIN_PER_BIN:
    case GTI_LCL_SNR_MARGIN:

        if(Gti_GetMeanSQStatus(pSys, nStatusType, wSQ, sizeof(wSQ)) == 0)
            return 0;

        if(Gti_GetCurrentMode(pSys) == GTI_CO)
            nBitLoading = GTI_BIT_LOADING_UP;
        else
            nBitLoading = GTI_BIT_LOADING_DN;
        break;

    case GTI_SNR_MARGIN_PER_BIN_NEXT:

        if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
        {
            if(Gti_GetMeanSQStatus(pSys, nStatusType, wSQ, sizeof(wSQ)) == 0)
                return 0;

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                nBitLoading = GTI_BIT_LOADING_NEXT_UP;
            else
                nBitLoading = GTI_BIT_LOADING_NEXT_DN;
        }
        else
        {
            if(Gti_GetMeanSQStatus(pSys, GTI_MEAN_SQ_ERROR, wSQ, sizeof(wSQ)) == 0)
                return 0;

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                nBitLoading = GTI_BIT_LOADING_UP;
            else
                nBitLoading = GTI_BIT_LOADING_DN;
        }
        break;

    default:
        return 0;
    }

    nUsedBins = Gti_SStatusXCVR(pSys, nBitLoading, bBitsPerBin,
        sizeof(bBitsPerBin), GTI_DSP_A);

    if(nUsedBins == 0)
        return 0;

    if(pBuffer && (nLength < (nUsedBins * sizeof(GTI_WORD))))
        return 0;


    if (GET_HOST_DB_W(pSys, GTI_RX_BIN_ADJUST) != 0xF0)
    {
       for(i=0; i < nUsedBins; i++)
       {
           if(bBitsPerBin[i] != 0)
           {
               wData = (GTI_WORD)((wSQ[i]/4) * (Margin_Per_Bin_Trans[bBitsPerBin[i] & 0xf]));

               if(pAverage)
               {
                   nAvSum ++;
                   for(k=0; k < sizeof(Avrg_Margin_Trans)/sizeof(GTI_WORD); k++)
                   {
                       if(wData > Avrg_Margin_Trans[k])
                       {
                           wAverage = (GTI_WORD)(wAverage + k);
                           break;
                       }
                   }
               }
           }
           else
               wData = 0;

           if(pBuffer)
               pBuffer[i] = wData;
       }

       /* Continue with Next average if Annex C DBM */

       if(nStatusType == GTI_LCL_SNR_MARGIN)
       {
           if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
           {
               if(GET_HOST_DB_B(pSys, GTI_ANNEX_C_MODE) == GTI_ANNEX_C_DBM )
               {
                   if(Gti_GetMeanSQStatus(pSys, GTI_MEAN_SQ_NEXT_ERROR, wSQ, sizeof(wSQ))== 0)
                       return 0;

                   if(Gti_GetCurrentMode(pSys) == GTI_CO)
                       nBitLoading = GTI_BIT_LOADING_NEXT_UP;
                   else
                       nBitLoading = GTI_BIT_LOADING_NEXT_DN;

                   nUsedBins = Gti_SStatusXCVR(pSys, nBitLoading, bBitsPerBin,
                       sizeof(bBitsPerBin), GTI_DSP_A);

                   if(nUsedBins == 0)
                       return 0;

                   if(pBuffer && (nLength < (nUsedBins * sizeof(GTI_WORD))))
                       return 0;

                   for(i=0; i < nUsedBins; i++)
                   {
                       if(bBitsPerBin[i] != 0)
                       {
                           wData = (GTI_WORD)((wSQ[i]/4) * (Margin_Per_Bin_Trans[bBitsPerBin[i] & 0xf]));

                           if(pAverage)
                           {
                               nAvSum ++;
                               for(k=0; k < sizeof(Avrg_Margin_Trans)/sizeof(GTI_WORD); k++)
                               {
                                   if(wData > Avrg_Margin_Trans[k])
                                   {
                                       wAverage = (GTI_WORD)(wAverage + k);
                                       break;
                                   }
                               }
                           }
                       }
                       else
                           wData = 0;

                       if(pBuffer)
                           pBuffer[i] = wData;
                   }
               }
           }
       }


       if(pAverage && nAvSum)
       {
           nTempData = (int)(wAverage / nAvSum) - 30;

           nTempData = nTempData + ((int)GET_HOST_DB_B(pSys, GTI_ACT_CODING_GAIN2) & 0xff) / 2;

           *pAverage = (char)((nTempData > 127) ? 127 : (char)nTempData);

           wData = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_TRELLIS) |
               ((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_TRELLIS+1)) << 0x08));

           if(wData == GTI_TRELLIS_ENABLE)
           {
               *pAverage += 3;
           }

           *pAverage = (char)(*pAverage - (char)GET_HOST_DB_B(pSys, GTI_MARGIN_O_D));
           *pAverage = (char)(*pAverage + (char)GET_HOST_DB_B(pSys, GTI_MARGIN_O_U));

       }
    }
    else
    {
       /* ANNEX-A ONLY */
       /* Initially goto through all of the bins before sorting it */
       for(i=0; i < nUsedBins; i++)
       {
           if(bBitsPerBin[i])
               wData = (GTI_WORD)((wSQ[i]/4) * (Margin_Per_Bin_Trans[bBitsPerBin[i] & 0xf]));
           else
               wData = 0;

           sortData[i] = wData;
           if(pBuffer)
               pBuffer[i] = wData;
       }

       /* To minimize the number of swaps, we have choosen to do selection swap (which
       ** would place everything in sequential order from low to high.
       */
       for(i=0; i < nUsedBins; i++)
       {
           lowValue = i;
           for(k=(i+1); k < nUsedBins; k++)
           {
               if (sortData[k] > sortData[lowValue])
                   lowValue = k;
           }
           /* Swap: lowValue data with i data */
           /* gti_swap(&sortData[i], &sortData[lowValue]); */
           tData = sortData[i];
           sortData[i] = sortData[lowValue];
           sortData[lowValue] = tData;
       }

       /* Maximum number of bins to used for average */
       for(i=0; i < nUsedBins; i++)
       {
           if ((pAverage) && ((GTI_WORD)sortData[i]))
           {
               nAvSum ++;
               for(k=0; k < (sizeof(Avrg_Margin_Trans)/sizeof(GTI_WORD)); k++)
               {
                   if(((GTI_WORD)sortData[i]) > Avrg_Margin_Trans[k])
                   {
                       wAverage += k;
                       break;
                   }
               }
           }
           /* 10% */
           if ((pAverage && nAvSum) && (i == (GTI_WORD)(nUsedBins/10)))
           {
               *pAverage = 0;
               Gti_CalculateSNR(pSys, pAverage, wAverage, nAvSum);
           }
       }
    }

    if(pAverage)
        return GTI_LCL_SNR_MARGIN_LEN;
    else
        return (GTI_WORD)(nUsedBins * sizeof(GTI_WORD));
}

/*****************************************************************************/
/* Procedure: Gti_GetAfeVersion                   Created: 03.24.00          */
/* ----------------------                                                    */
/* Description: The function gets the AFE version from the DSP mem space.    */
/*      Return: BYTE (AFE version number)                                    */
/* ------------------------------------------------------------------------- */
GTI_BYTE
Gti_GetAfeVersion(GTI_XCVR_INFO *pSys)
{
     
#define WRITE_DSP_IREG(pSys,bId,bReg,bDataL,bDataH) \
    CONFIGURE_DSP(pSys, bId, GTI_NO_AI);            \
    WRITE_DSP_ADDR(pSys, bId, bReg, GTI_IREGA);     \
    WRITE_DSP_WORD(pSys, bId, bDataL, bDataH);
  
#define READ_DSP_IREG(pSys,bId,bReg,wRegData)                 \
    CONFIGURE_DSP(pSys, bId, GTI_NO_AI);                      \
    WRITE_DSP_ADDR(pSys, bId, bReg, GTI_IREGA | GTI_READ_DSP);\
    wRegData = READ_DSP_WORD(pSys, bId);   
        
#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)
    GTI_WORD wResult = 0;
#endif
    GTI_BYTE bReturn = 0;      
 
#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)

    WRITE_DSP_IREG(pSys, GTI_DSP_A, 0x3c, 0x80, 0x8d);
    WRITE_DSP_IREG(pSys, GTI_DSP_A, 0x85, 0x50, 0x09);
    
    WRITE_DSP_IREG(pSys, GTI_DSP_A, 0x34, 0x80, 0x00);    
    READ_DSP_IREG(pSys, GTI_DSP_A, 0x0c, wResult);

    bReturn = (GTI_BYTE)((wResult >> 4) & 0xF);
#else
    (void)pSys;
#endif    
           
    return bReturn;
}

/*****************************************************************************/
/* Procedure: Gti_GetChipVersion                   Created: 03.24.00         */
/* ----------------------                                                    */
/* Description: The function gets the chip version from the DSP mem space.   */
/*      Return: BYTE (chip version number.                                   */
/* ------------------------------------------------------------------------- */
GTI_BYTE
Gti_GetChipVersion(GTI_XCVR_INFO *pSys)
{
#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)
    GTI_WORD wResult;
#endif
    GTI_BYTE bReturn = 0;

#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)

    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, 0x85, GTI_IREGA|GTI_READ_DSP);
    wResult = READ_DSP_WORD(pSys, GTI_DSP_A);

#if defined(GTI_DSPQUAD)
    bReturn = (GTI_BYTE)((wResult >> 1) & 0x03);
#else
    bReturn = (GTI_BYTE)((wResult >> 11) & 0x03);
#endif
#else
    bReturn = (GTI_BYTE)(READ_DSP_BYTE(pSys, GTI_DSP_A, GTI_MASKTEST_DSP) & 0x03);
#endif

    return bReturn;
}

/*****************************************************************************/
/* Procedure: Gti_SStatusXCVR                   Created: 09.24.98            */
/* ----------------------                                                    */
/* Description: The function analizes the XCVR system status information and */
/*          returns this information in a caller supplied buffer. The        */
/*          length of the returned information in bytes is returned. If      */
/*          the status is not availiable, on some processing error occurs    */
/*          the returned result is zero.                                     */
/* ------------------------------------------------------------------------- */
GTI_WORD
Gti_SStatusXCVR(GTI_XCVR_INFO *pSys,    /* System Pointer                   */
            GTI_WORD nStatusType,        /* type of required status          */
            void *pStatus,               /* Pointer to the status buffer     */
            GTI_WORD nLength,            /* Maximum length of the buffer     */
            GTI_BYTE nChanID
)
{
    GTI_DWORD *pDWordBuffer;
    GTI_WORD ntmpBuffer[4];
    GTI_BYTE tmp1, tmp2, nDspID,  *pByteBuffer;
    GTI_WORD j, i, nRetSize, *pWordBuffer;

    signed short nSResult[2] = {0, 0};

    nRetSize = 0;
    pWordBuffer = (GTI_WORD *)pStatus;
    pByteBuffer = (GTI_BYTE *)pStatus;

    nDspID = (GTI_BYTE)((nChanID == GTI_CH_A) ? GTI_DSP_A : GTI_DSP_B);
    nDspID = nDspID; /* kill warning if the dsp id is not used */

    pDWordBuffer = (GTI_DWORD *)pStatus;

    switch(nStatusType)
    {
    case GTI_FW_REL:
    /**************/
        if(nLength >= GTI_FW_REL_LEN)
        {
            nRetSize = GTI_FW_REL_LEN;
            memcpy(pStatus, RELEASE, GTI_FW_REL_LEN);
        }
        break;

    case GTI_LAST_FAILED_STATUS:
    /**************************/
        if(nLength >= GTI_LAST_FAILED_STATUS_LEN)
        {
            pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_LAST_FAILED_LOCATION);

#ifdef GTI_DUAL_CORE
            if(nChanID == GTI_CH_B)
            {
                pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_LAST_FAILED_LOCATION_B);
            }
#endif
            nRetSize = GTI_LAST_FAILED_STATUS_LEN;
        }
        break;

#ifdef GTI_DUAL_CORE
    case GTI_LINE_SWAP_STATUS:
    /************************/
        if(nLength >= GTI_LINE_SWAP_STATUS_LEN)
        {
            /* Configure for Reading Internal RAM */
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_CHANNEL_CROSS_FLAG_LOC,
                (GTI_BYTE)(GTI_PSRAM0W|GTI_READ_DSP));

            pWordBuffer[0] = READ_DSP_WORD(pSys, GTI_DSP_A);
            nRetSize = GTI_LINE_SWAP_STATUS_LEN;
        }
        break;
#endif

    case GTI_MEAN_SQ_ERROR:
    /*********************/
    case GTI_MEAN_SQ_NEXT_ERROR:   /* Annex C only */
    /**************************/
        nRetSize = Gti_GetMeanSQStatus(pSys, nStatusType, pWordBuffer, nLength);
        break;

    case GTI_OP_STATE:
    /****************/
        if(nLength >= GTI_OP_STATE_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_OP_CH_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_OP_STATE_LEN;
        }
        break;

    case GTI_RECEIVER_GAIN:
    /*********************/
        if(nLength >= GTI_RECEIVER_GAIN_LEN)
        {
            if( !Gti_IsCXfrActive(pSys) )
            {
                /* Check Which Annex */
                if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
                {
                    CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
                    WRITE_DSP_ADDR(pSys, nDspID, GTI_ragc_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                    pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_totalPGAgain_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[0] = (signed short)READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_analogRxMode_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[1] = (signed short)READ_DSP_WORD(pSys, nDspID);
                }
                else
                {
                    CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
                    WRITE_DSP_ADDR(pSys, nDspID, GTI_ragc_LOC, GTI_ISRAM|GTI_READ_DSP);
                    pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_totalPGAgain_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[0] = (signed short)READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_analogRxMode_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[1] = (signed short)READ_DSP_WORD(pSys, nDspID);
                }

                if(nSResult[1] == 1)
                    nSResult[1] = 0;
                else
                    nSResult[1] = (short)((Gti_GetCurrentMode(pSys) == GTI_CO) ? 260 : 370);

                pWordBuffer[1] = (GTI_WORD)(nSResult[0] - nSResult[1]);

                nRetSize = GTI_RECEIVER_GAIN_LEN;
            }
        }

        break;

    case GTI_DSP_VERSION:
    /***********************/
        if(nLength >= GTI_DSP_VERSION_LEN)
        {
            pByteBuffer[0] = Gti_GetChipVersion(pSys);
            nRetSize = GTI_DSP_VERSION_LEN;
        }
        break;
        
    case GTI_AFE_VERSION:
    /***********************/
        if(nLength >= GTI_AFE_VERSION_LEN)
        {
            pByteBuffer[0] = pSys->pChipInfo->bAfeVersion;
            nRetSize = GTI_AFE_VERSION_LEN;
        }
        break;        

#ifdef GTI_DSPQUAD             /* Trinity/Fourte */

    case GTI_LBUS_FW_VERSION:
    /***********************/
        if(nLength >= GTI_FW_REL_LEN)
        {
            memcpy(pStatus, pSys->pChipInfo->lBusVersion,
                sizeof(pSys->pChipInfo->lBusVersion));
            nRetSize = sizeof(pSys->pChipInfo->lBusVersion);
        }
        break;

#endif /* GTI_DSPQUAD */

    case GTI_RESERVED_0_STATUS:
        if(nLength >= GTI_RESERVED_0_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x34, GTI_IREGA|GTI_READ_DSP);
            pWordBuffer[0] = (GTI_WORD)(READ_DSP_WORD(pSys, nDspID) & 0x4500);
            nRetSize = GTI_RESERVED_0_STATUS_LEN;
        }
        break;

    case GTI_RESERVED_1_STATUS:
        if(nLength >= GTI_RESERVED_1_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x12, GTI_IREGA|GTI_READ_DSP);
            pWordBuffer[0] = (GTI_WORD)(READ_DSP_WORD(pSys, nDspID) & 0x3333);
            nRetSize = GTI_RESERVED_1_STATUS_LEN;
        }
        break;

    case GTI_XMIT_POWER:
    /******************/
        if(nLength >= GTI_XMIT_POWER_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_XMIT_LOCATION, GTI_ISRAM|GTI_READ_DSP);
            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_XMIT_POWER_LEN;
        }
        break;

    case GTI_START_PROGRESS:
    /**********************/
        if(nLength >= GTI_START_PROGRESS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_PROGRESS_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_START_PROGRESS_LEN;
        }
        break;

     case GTI_WATCHDOG_TIMER:
    /**********************/
        if(nLength >= GTI_WATCHDOG_TIMER_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_WATCHDOG_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_WATCHDOG_TIMER_LEN;

                /* Clear WatchDog Timer */
            WRITE_DSP_ADDR(pSys, nDspID, GTI_WATCHDOG_LOCATION, GTI_ISRAM);
            WRITE_DSP_WORD(pSys, nDspID, 0x00,0x00);
        }
        break;

    case GTI_ANALOG_REC_MODE:
    /**********************/
        if(nLength >= GTI_ANALOG_REC_MODE_LEN)
        {
            /* REC Mode Valid for ADSL-6M 640 CP only */
            /* Configure for Reading Internal RAM */
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_ANALOG_REC_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_ANALOG_REC_MODE_LEN;
        }
        break;

    case GTI_BERT_ERROR:
    /******************/
        if(nLength >= GTI_BERT_ERROR_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_OP_CH_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            if ( READ_DSP_WORD(pSys, nDspID) == GTI_DATA_OP )
            {
                WRITE_DSP_ADDR(pSys, nDspID, 0x9b,(GTI_BYTE)(GTI_PSRAM0W|GTI_READ_DSP) );
                pWordBuffer[1] = (GTI_WORD)(( READ_DSP_WORD(pSys,nDspID) & 0x01 ) << 0x07 );

                WRITE_DSP_ADDR(pSys, nDspID, 0xbc, (GTI_BYTE)(GTI_PSRAM0W|GTI_READ_DSP) );
                pWordBuffer[0] = READ_DSP_WORD(pSys,nDspID);

                WRITE_DSP_ADDR(pSys, nDspID, 0xbc, GTI_PSRAM0W);
                WRITE_DSP_WORD(pSys, nDspID, 0x00,0x00);
            }
            else
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_BERT_SYNC_LOCATION, (GTI_BYTE)(GTI_IREGA|GTI_READ_DSP) );

                pWordBuffer[1] = (GTI_WORD)((READ_DSP_WORD(pSys, nDspID) >> 0x08) & 0x0080);

                WRITE_DSP_ADDR(pSys, nDspID, GTI_BERT_ERROR_LOCATION, (GTI_BYTE)(GTI_IREGA|GTI_READ_DSP) );

                pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
                if ( pWordBuffer[0] & 0x8000 )
                    pWordBuffer[0] = 0x7fff ;
            }

            nRetSize = GTI_BERT_ERROR_LEN;

        }
        break;

    case GTI_UPSTREAM_MARGIN_STATUS:
    /************************************/
        if(nLength >= GTI_UPSTREAM_MARGIN_STATUS_LEN)
        {
            pByteBuffer[0] = (GTI_BYTE) (( GET_HOST_DB_B( pSys, GTI_C_MSG2 +2 )) & 0x1f);
            nRetSize =  GTI_UPSTREAM_MARGIN_STATUS_LEN;
        }
        break;

    case GTI_LCL_XMIT_POWER_STATUS:
    /******************/
        if(nLength >= GTI_LCL_XMIT_POWER_STATUS_LEN)
        {
            pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_SEL_TX_POWER_ATTENUATION);

            /* FDP is 20 bits so shift down by 4 to align lsb */
            pWordBuffer[1] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_NO_TX_BINS) >> 0x04) |
                (GET_HOST_DB_B(pSys, GTI_NO_TX_BINS+1) << 0x04));

            nRetSize = GTI_LCL_XMIT_POWER_STATUS_LEN;
        }
        break;

    case GTI_RMT_TX_POWER_STATUS:
    /******************/
        if(nLength < GTI_RMT_TX_POWER_STATUS_LEN)
            return 0;

        /* FDP is 20 bits so shift down by 4 to align lsb */
        pWordBuffer[0] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_NO_RX_BINS) >> 0x04) |
            (GET_HOST_DB_B(pSys, GTI_NO_RX_BINS+1) << 0x04));

        nRetSize = GTI_RMT_TX_POWER_STATUS_LEN;
        break;

    case GTI_RMT_VENDOR_ID_STATUS:
    /*****************************/

        /* Length is dependent on standard type */
        tmp1 = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD));
        i = GTI_RMT_VENDOR_ID_STATUS_LEN;

        if( (tmp1 == GTI_G_LITE_STANDARD))
            i = GTI_RMT_VENDOR_ID_G_LITE_STATUS_LEN;
        else if( (tmp1 == GTI_G_DMT_STANDARD) )
            i = GTI_RMT_VENDOR_ID_G_DMT_STATUS_LEN;
        else
            i = GTI_RMT_VENDOR_ID_STATUS_LEN;

        if(nLength >= i)
        {
            /* Location is dependent on standard type */
            if( (tmp1 == GTI_G_LITE_STANDARD) || (tmp1 == GTI_G_DMT_STANDARD) ){
                pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+1) << 0x08) );
                pWordBuffer[1] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk+2) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+3) << 0x08) );
                pWordBuffer[2] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk+4) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+5) << 0x08) );
            }
            else
            {
                pWordBuffer[0] = (GTI_WORD)(((GET_HOST_DB_B(pSys, GTI_RMT_MSG_2+1) >> 0x04) & 0x0f) |
                    ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_3) << 0x04) & 0x0ff0) |
                    ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_3+1) << 12) & 0xf000));
            }

            nRetSize = i;
        }
        break;

    case GTI_RMT_VENDOR_REV_STATUS:
    /*****************************/
        if(nLength >= GTI_RMT_VENDOR_REV_STATUS_LEN)
        {
            /* Location of information is dependent on standard type */
            i = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD));
            if((i == GTI_G_LITE_STANDARD) || (i == GTI_G_DMT_STANDARD))
            {
                pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk+6) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+7) << 0x08) );
            }
            else
            {
                pWordBuffer[0] = (GTI_WORD) ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_2) >> 2) & 0x1f);
            }

            nRetSize = GTI_RMT_VENDOR_REV_STATUS_LEN;
        }
        break;

    case GTI_RS_FRAME_COUNTER:
    /*****************************/
        if((nLength >= GTI_RS_FRAME_COUNTER_LEN) && (!Gti_IsCXfrActive(pSys)))
        {
            /* Counter for RS Frames */
            /* IPU counter * 68/PCU# */
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);

            /* Check Which Annex */
            if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_C_LOC, GTI_ISRAM|GTI_READ_DSP);
            }
            else
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_LOC, GTI_ISRAM|GTI_READ_DSP);
            }
            i = READ_DSP_WORD(pSys, nDspID);
            i *= 68;

            if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_C_LOC, GTI_ISRAM );
            }
            else
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_LOC, GTI_ISRAM );
            }

            WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x00);

            tmp1 = (GTI_BYTE) ((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD+2))&0x3f);
            tmp2 = (GTI_BYTE) ((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD+7))&0x3f);

            if( tmp1 == 0 ) tmp1 = 1;
            if( tmp2 == 0 ) tmp2 = 1;

            /* Word 0 - Down RS Frame Count */
            pWordBuffer[0] = (GTI_WORD) (i/tmp1);

            /* Word 1 - Up RS Frame Count */
            pWordBuffer[1] = (GTI_WORD) (i/tmp2);

            nRetSize = GTI_RS_FRAME_COUNTER_LEN;
        }
        break;

    case GTI_ATM_CELL_COUNTER:
    /*************************/
        if(nLength >= GTI_ATM_CELL_COUNTER_LEN)
        {
            /* Counter for ATM cells  */

            /* RX cell counter */
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0xbb, GTI_PSRAM0W|GTI_READ_DSP);

            ntmpBuffer[0] = READ_DSP_WORD(pSys, nDspID);

            /* TX cell counter */
            WRITE_DSP_ADDR(pSys, nDspID, 0xfb, GTI_PSRAM0W|GTI_READ_DSP);

            ntmpBuffer[1] = READ_DSP_WORD(pSys, nDspID);

            /* Subtract previous from current */
            /* Current = ntmpbuffer           */
            /* Previous = hostram DB          */

            j = GET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_RX_CELL_CNT);
            pWordBuffer[0] = (GTI_WORD)(ntmpBuffer[0] - j);

            j = GET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_TX_CELL_CNT);
            pWordBuffer[1] = (GTI_WORD)(ntmpBuffer[1] - j);

            /* Save current value */
            SET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_RX_CELL_CNT, ntmpBuffer[0] );
            SET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_TX_CELL_CNT, ntmpBuffer[1] );

            nRetSize = GTI_ATM_CELL_COUNTER_LEN;
        }
        break;

    case GTI_IDLE_BERT_STATUS:
    /************************/
        if(nLength >= GTI_IDLE_BERT_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0xbc, (GTI_PSRAM0W|GTI_READ_DSP) );

            /* BERT_ERRORS */
            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);

            /* BERT Cells */
            pWordBuffer[1] = READ_DSP_WORD(pSys, nDspID);

            /* clear both counters */
            WRITE_DSP_ADDR(pSys, nDspID, 0xbc, GTI_PSRAM0W);
            WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x00);
            WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x00);

            nRetSize = GTI_IDLE_BERT_STATUS_LEN;
        }
        break;

    case GTI_FAST_RETRAIN_STATUS:
    /***************************/
        if((nLength >= GTI_FAST_RETRAIN_STATUS_LEN) && (!Gti_IsCXfrActive(pSys)))
        {
            pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_FRSTATUS);
            pWordBuffer[1] = GET_HOST_DB_W(pSys, GTI_TX_PROFILE);
            pWordBuffer[2] = GET_HOST_DB_W(pSys, GTI_RX_PROFILE);

            /* clear status */
            i = GTI_FRSTATUS;
            j = GTI_FAST_RETRAIN_NO_ACTIVITY;
            SET_HOST_DB_W(pSys, i, j);

            nRetSize = GTI_FAST_RETRAIN_STATUS_LEN;
        }
        break;

    case GTI_LCL_SNR_MARGIN:
    /**********************/
        if((nLength >= GTI_LCL_SNR_MARGIN_LEN) && (!Gti_IsCXfrActive(pSys)))
            nRetSize = Gti_GetMarginPerBinStatus(pSys, nStatusType, 0, nLength, (char *)&pByteBuffer[0]);
        break;

    case GTI_LCL_ANNEX_C_MODE:
    /************************/
        if(nLength >= GTI_LCL_ANNEX_C_MODE_LEN)
        {
            pByteBuffer[0] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_ANNEX_C_MODE));
            nRetSize = GTI_LCL_ANNEX_C_MODE_LEN;
        }
        break;

    case GTI_OVERLAP_STATUS:
    /**********************/
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            j = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_TX_START_BIN));
        }
        else
        {
            if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
            {
                j = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_RX_START_BIN + 2));
            }
            else
            {
                /* FDP is 20 bits so shift down by 4 to align lsb */
                j = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_RX_START_BIN) >> 0x04) |
                    (GET_HOST_DB_B(pSys, GTI_RX_START_BIN + 1) << 0x04));
            }
        }

        if(j < 0x20)
            pByteBuffer[0] = 0x1; /* overlap mode */
        else
            pByteBuffer[0] = 0x0; /* non overlap mode */

        nRetSize = GTI_OVERLAP_STATUS_LEN;
        break;

    case GTI_LCL_FW_REV_NUM:
    /**********************/
        if(nLength >= GTI_LCL_FW_REV_NUM_LEN)
        {
            pByteBuffer[0] = GTI_LCL_FW_REV_NUM_VALUE ;
            nRetSize = GTI_LCL_FW_REV_NUM_LEN ;
        }
        break;

    case GTI_LCL_CODING_GAIN:
    /***********************/
        if(nLength >= GTI_LCL_CODING_GAIN_LEN)
        {
            pByteBuffer[0] = (GTI_BYTE)((GET_HOST_DB_B(pSys, GTI_ACT_CODING_GAIN2) & 0xff) / 2);
            nRetSize = GTI_LCL_CODING_GAIN_LEN;
        }
        break;

    case GTI_BIT_LOADING_UP:
    /**********************/
    case GTI_BIT_LOADING_DN:
    /**********************/
    case GTI_BIT_LOADING_NEXT_UP:
        /***************************/
    case GTI_BIT_LOADING_NEXT_DN:
    /***************************/
        nRetSize = GetBitsPerBinStatus(pSys, nStatusType, (GTI_BYTE *)pStatus, nLength);
        break;

    case GTI_SNR_MARGIN_PER_BIN:
    /**************************/
    case GTI_SNR_MARGIN_PER_BIN_NEXT:
    /*******************************/
        /* If TSM state machine is active then return 0 */
        if( !Gti_IsCXfrActive(pSys) )
            nRetSize = Gti_GetMarginPerBinStatus(pSys, nStatusType, (GTI_WORD *)pStatus, nLength, 0);
        break;

    case GTI_RX_BYTES_STATUS:
    /***********************/
        if(nLength >= GTI_RX_BYTES_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x3, (GTI_PSRAM0W|GTI_READ_DSP) );

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAL_DSP);
            else
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAH_DSP);

            nRetSize = GTI_RX_BYTES_STATUS_LEN;
        }
        break;

    case GTI_TX_BYTES_STATUS:
    /***********************/
        if(nLength >= GTI_TX_BYTES_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x2, (GTI_PSRAM0W|GTI_READ_DSP));

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAH_DSP);
            else
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAL_DSP);

            nRetSize = GTI_TX_BYTES_STATUS_LEN;
        }
        break;

    case GTI_COUNTERS:
    /*****************/
         if(nLength >= GTI_COUNTERS_LEN)
         {
             /* If TSM state machine is active then return 0 */
             if( !Gti_IsCXfrActive(pSys) )
             {
                 CONFIGURE_DSP(pSys, nDspID, GTI_READ_BLOCK_MODE);

                 /* Check Which Annex */
                 if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_local_RSI_counter_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_local_RSI_counter_LOC, GTI_ISRAM|GTI_READ_DSP);
                 }

                 nRetSize = GTI_COUNTERS_LEN;

                 READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, GTI_COUNTERS_LEN, pByteBuffer);

                 for(i=0; i < (GTI_COUNTERS_LEN / sizeof(GTI_WORD)); i++)
                 {
                     j = MAKEWORD(pByteBuffer[i * 2], pByteBuffer[(i * 2) + 1]);
                     pWordBuffer[i] = j;
                 }

                 /* Set Flag to Clear Counter */
                 if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_clrCounters_C_LOC, GTI_ISRAM );
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_clrCounters_LOC, GTI_ISRAM );
                 }

                 WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x80);

                 if(Gti_GetCurrentMode(pSys) == GTI_CO)
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_RSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECI_COUNTER] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_RSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECF_COUNTER] = 0;
                     }
                 }
                 else /* CP */
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_RSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECI_COUNTER] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_RSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECF_COUNTER] = 0;
                     }
                 }
             }
         }
         break;

     case GTI_FAILURES:
         /****************/
         if(nLength >= GTI_FAILURES_LEN)
         {
             /* If TSM state machine is active then return 0 */
             if( !Gti_IsCXfrActive(pSys) )
             {
                 /* Read ISRAM to get local and Remote Counters */
                 /* then set flag to clear counter          */
                 CONFIGURE_DSP(pSys, nDspID, GTI_READ_BLOCK_MODE);

                 /* Check Which Annex */
                 if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_C_LOC, (GTI_ISRAM|GTI_READ_DSP ) );
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_LOC, (GTI_ISRAM|GTI_READ_DSP ) );
                 }

                 READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, GTI_FAILURES_LEN, pByteBuffer);

                 for(i=0; i < (GTI_FAILURES_LEN / sizeof(GTI_WORD)); i++)
                 {
                     j = MAKEWORD(pByteBuffer[i * 2], pByteBuffer[(i * 2) + 1]);
                     pWordBuffer[i] = j;
                 }

                 nRetSize = GTI_FAILURES_LEN;


                 /* Clear Overall Failure Counter directly */
                 /* Check Which Annex */
                 if(Gti_GetCurrentAnnexType(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_C_LOC, GTI_ISRAM );
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_LOC, GTI_ISRAM );
                 }
                 WRITE_DSP_WORD(pSys, nDspID , 0x00, 0x00);

                 if(Gti_GetCurrentMode(pSys) == GTI_CO)
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_NCDI_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDI_FAILURE] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_NCDF_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDF_FAILURE] = 0;
                     }
                 }
                 else /* CP */
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_NCDI_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDI_FAILURE] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_NCDF_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDF_FAILURE] = 0;
                     }
                 }

                 for(i=0; i < (GTI_FAILURES_LEN / sizeof(GTI_WORD)); i++)
                 {
                     if(i != GTI_OVERALL_FAILURE)
                     {
                         if(pWordBuffer[i] >= 127)
                             break;
                     }
                 }

                 if(i >= GTI_FAILURES_LEN / sizeof(GTI_WORD))
                     pWordBuffer[GTI_OVERALL_FAILURE] = 0;
             }
         }
         break;

    case GTI_ACTUAL_CONFIGURATION:
        /****************************/
        if(nLength >= GTI_ACTUAL_CONFIGURATION_LEN)
        {
            nRetSize = GTI_ACTUAL_CONFIGURATION_LEN;

            for(i = 0; i < GTI_ACTUAL_CONFIGURATION_LEN/sizeof(GTI_WORD); i++)
                pWordBuffer[i] = 0;

            /* Copy Select Host Ram Locations to Status Buffer */
            /* Fast or Interleaved  is determined by which is != 0*/

            /* Framing OH */
            pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_FRAME_STRUCTURE+1) >> 0x01);

            /* Trellis */
            pWordBuffer[1] = (GTI_WORD)(GET_HOST_DB_W(pSys, GTI_ACTUAL_TRELLIS));

            /***************************/
            /* Rates1 Map             */
            /*    HIGH    LOW         */
            /* 0  AS1bytes    AS0bytes*/
            /* 2  AS3bytes    AS2bytes*/
            /* 4  LS1dwn      LS0dwn  */
            /* 6  LS0 up      LS2dwn  */
            /* 8  LS2 up      LS1 up  */
            /***************************/

            /* Fast R RS UP */
            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) != 0) /* As0 Bytes down - */
            {
                pWordBuffer[2] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF);
                if ((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_FRAME_STRUCTURE+1) >> 0x01) ==3 )
                {
                    pWordBuffer[2] = (GTI_WORD)( GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) |
                        ( (((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD+1) ))<<0x1) & 0x0100) );
                }
                pWordBuffer[3] = GTI_FAST_BUFFER;
            }
            else
            {
                /* Need to get high Bit of AS0 speed */
                pWordBuffer[2] = (GTI_WORD)( GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BI) |
                    ( (((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD+1) ))<<0x1) & 0x0100) );
                pWordBuffer[3] = GTI_INTERLEAVE_BUFFER;
            }

            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF + 1) != 0) /* As1 Bytes down */
            {
                pWordBuffer[4] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF + 1);
                pWordBuffer[5] = GTI_FAST_BUFFER;
            }
            else
            {
                pWordBuffer[4] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BI + 1);
                pWordBuffer[5] = GTI_INTERLEAVE_BUFFER;
            }

            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7) != 0) /* Ls0 Bytes up */
            {
                pWordBuffer[6] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7);
                pWordBuffer[7] = GTI_FAST_BUFFER;
            }
            else
            {
                pWordBuffer[6] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BI + 7);
                pWordBuffer[7] = GTI_INTERLEAVE_BUFFER;
            }

            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 8) != 0) /* Ls1 Bytes up */
            {
                pWordBuffer[8] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 8);
                pWordBuffer[9] = GTI_FAST_BUFFER;
            }
            else
            {
                pWordBuffer[8] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BI + 8);
                pWordBuffer[9] = GTI_INTERLEAVE_BUFFER;
            }

            /***************************/
            /* RRSD Map                */
            /*    HIGH    LOW          */
            /* 0  Dwn-RSi    Dwn-FastR */
            /* 2  Dwn-D      Dwn-S     */
            /* 4  Up-FastR             */
            /* 6  Up-S       Up-RSi    */
            /* 8             Up-D      */
            /***************************/

            /* Fast R RS UP */
            pWordBuffer[10] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 5);

            /* S RS UP */
            pWordBuffer[11] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 7)) & 0x3f);

            /* D RS UP  10 bits*/
            i = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 7) & 0x00c0));
            i = (GTI_WORD)(i << 0x02);
            pWordBuffer[12] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 8)) | i);

            /* R RS UP  = RSi X S*/
            pWordBuffer[13] =
                (GTI_WORD)( (GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 7) & 0x3f) *
                (GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 6) & 0x3f) );

            /* Fast R RS Down */
            pWordBuffer[14] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD);

            /* S RS DOWN */
            pWordBuffer[15] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 2)) & 0x3f);

            /* D RS DOWN  10 bits*/
            i = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 2) & 0x00c0));
            i = (GTI_WORD)(i << 0x02);
            pWordBuffer[16] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 3)) | i);


            /* R RS DOWN  = RSi X S*/
            if (pWordBuffer[15] == 0)  /* S=1/2 case */
            {
                pWordBuffer[17] =
                    (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 1) & 0x3f);
            }
            else
            {
                pWordBuffer[17] =
                    (GTI_WORD)( (GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 2) & 0x3f) *
                    (GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 1) & 0x3f) );
            }


            /* Selected Standard */
            pWordBuffer[18] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD);
        }

        break;

    case GTI_ATTENUATION_STATUS:
        /**************************/
        if(nLength >= GTI_ATTENUATION_STATUS_LEN)
        {
            nRetSize = GTI_ATTENUATION_STATUS_LEN;

            /* Local Attenuation */
            if(Gti_GetCurrentMode(pSys) == GTI_CO)
            {
                /* Local - CMsg2 31-26 6bits  */
                pByteBuffer[0] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_C_MSG2 + 3) >> 2);

                /* Read 16 bits and shift down by 3 */
                /*
                j = GET_HOST_DB_W(pSys, GTI_CO_ATTN);
                j = (GTI_WORD)(j>>3);
                pByteBuffer[0] = (GTI_BYTE)(j);
                */
                /* Remote - RMsg2 31-25 7bits  */
                pByteBuffer[1] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1);
            }
            else
            {
                /* Local - RMsg2 31-25 7bits  */
                pByteBuffer[0] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1);

                /* Remote - CMsg2 31-26 6bits  */
                pByteBuffer[1] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_C_MSG2 + 3) >> 2);

                /* If remote end is ALCTL then add 3 db to local Attenuation */
                tmp1 = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD));
                if( (tmp1 == GTI_G_LITE_STANDARD) || (tmp1 == GTI_G_DMT_STANDARD) ){

                    if(  (  ((GTI_WORD)(  GET_HOST_DB_B(pSys, GTI_vndIDBlk+2)
                           | (GET_HOST_DB_B(pSys, GTI_vndIDBlk+3) << 0x08) ) == GTI_RMT_VENDORID_ALCTL1)
                        &&((GTI_WORD)(  GET_HOST_DB_B(pSys, GTI_vndIDBlk+4)
                           | (GET_HOST_DB_B(pSys, GTI_vndIDBlk+5) << 0x08) ) == GTI_RMT_VENDORID_ALCTL2) ))
                    {
                       /* Max number is 0x7f so  check that we don't go over */
                       if( pByteBuffer[0] <= 0x7b ){
                             pByteBuffer[0] +=4;
                       }else{
                             pByteBuffer[0] = 0x7f;
                       }
                    }
                }else /* T314 */
                {
                   if( (GTI_WORD)(((GET_HOST_DB_B(pSys, GTI_RMT_MSG_2+1) >> 0x04) & 0x0f) |
                       ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_3) << 0x04) & 0x0ff0) |
                       ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_3+1) << 12) & 0xf000)) == 0x0022 )
                   {
                       if( pByteBuffer[0] <= 0x7b ){
                         pByteBuffer[0] +=4;
                       }else{
                         pByteBuffer[0] = 0x7f;
                       }
                   } 

                }


            }
        }
        break;

    case GTI_UTOPIA_CELL_DROP_COUNT:
        /******************************/
        if(nLength >= GTI_UTOPIA_CELL_DROP_COUNT_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_AI);
            WRITE_DSP_ADDR(pSys,nDspID, 0x9c, (GTI_PSRAM0W|GTI_READ_DSP) );

            nRetSize = GTI_UTOPIA_CELL_DROP_COUNT_LEN;

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
        }
        break;

    case GTI_DUMMY_STATUS:
        /***********************/
        if(nLength >= GTI_DUMMY_STATUS_LEN)
        {
            pByteBuffer[0] = GET_HOST_DB_B(pSys, GTI_DUMMY) ;
            pByteBuffer[1] = GET_HOST_DB_B(pSys, GTI_DUMMY + 1) ;
            nRetSize = GTI_DUMMY_STATUS_LEN;
        }
        break;

    case GTI_RX_TEST_RESULTS_1_64:
    case GTI_RX_TEST_RESULTS_64_128:
    case GTI_RX_TEST_RESULTS_128_192:
    case GTI_RX_TEST_RESULTS_192_256:
        /*******************************/
        if(nLength >= GTI_RX_TEST_RESULTS_LEN)
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_AI);

            if(nStatusType == GTI_RX_TEST_RESULTS_1_64)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 0, (GTI_FDPSRAMA|GTI_READ_DSP));
            }
            else
            if(nStatusType == GTI_RX_TEST_RESULTS_64_128)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 128, (GTI_FDPSRAMA|GTI_READ_DSP));
            }
            else
            if(nStatusType == GTI_RX_TEST_RESULTS_128_192)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 0, (GTI_FDPSRAMB|GTI_READ_DSP));
            }
            else
            if(nStatusType == GTI_RX_TEST_RESULTS_192_256)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 128, (GTI_FDPSRAMB|GTI_READ_DSP));
            }

            for(i = 0; i < GTI_RX_TEST_RESULTS_LEN/4; i++)
            {
                GTI_WORD wBin1 = READ_DSP_WORD(pSys, GTI_DSP_A);
                GTI_WORD wBin2 = READ_DSP_WORD(pSys, GTI_DSP_A);

                if(wBin1 & 0x8000) wBin1 = (GTI_WORD)(0xffff - wBin1 + 1);
                if(wBin2 & 0x8000) wBin2 = (GTI_WORD)(0xffff - wBin2 + 1);

                pDWordBuffer[i]  =  (GTI_WORD)(LOBYTE(wBin1) * LOBYTE(wBin1)) +
                    ((GTI_DWORD)(LOBYTE(wBin1) * HIBYTE(wBin1)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin1) * LOBYTE(wBin1)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin1) * HIBYTE(wBin1)) << 0x10) +
                    (GTI_WORD)(LOBYTE(wBin2) * LOBYTE(wBin2)) +
                    ((GTI_DWORD)(LOBYTE(wBin2) * HIBYTE(wBin2)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin2) * LOBYTE(wBin2)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin2) * HIBYTE(wBin2)) << 0x10);
            }

            nRetSize = GTI_RX_TEST_RESULTS_LEN;
        }
        break;

    case GTI_BIT_SWAP_COUNT:
        /**************************/
        if(nLength >= GTI_BIT_SWAP_COUNT_LEN)
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_AI);
            WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_host_BSCounter_LOC, (GTI_ISRAM|GTI_READ_DSP));

            pWordBuffer[0] = READ_DSP_WORD(pSys, GTI_DSP_A);

            nRetSize = GTI_BIT_SWAP_COUNT_LEN;
        }
        break;

    case GTI_ANNEX_SELECTED_STATUS:
        /**************************/
        if(nLength >= GTI_ANNEX_SELECTED_LEN)
        {
            pWordBuffer[0] = (GTI_WORD)( Gti_GetCurrentAnnexType(pSys) );
            nRetSize = GTI_ANNEX_SELECTED_LEN;
        }
        break;

    case GTI_INTERNAL_SAS:
        /********************/
        if(nLength >= GTI_INTERNAL_SAS_LEN)
        {
#ifndef GTI_USE_DMAXFR
            pByteBuffer[0] = pSys->state;
#else
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_DMA_window, GTI_ISRAM|GTI_READ_DSP);
            pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAL_DSP);

#endif
            nRetSize = GTI_INTERNAL_SAS_LEN;
        }
        break;

    default:
        break;

    } /* end of switch */

    return nRetSize;
}
/* End of SStatusXCVR                                                         */
/******************************************************************************/

GTI_WORD
Gti_ConvertCoarseDB(GTI_WORD slade0)
{
    GTI_WORD GTI_LOCAL_QUAL dbnum;

    switch(slade0&0x00e0)
    {
    case 0x00:
        dbnum=0;
        break;
    case 0x20:
        dbnum=6;
        break;
    case 0x40:
        dbnum=12;
        break;
    case 0x60:
        dbnum=18;
        break;
    case 0x80:
        dbnum=24;
        break;
    default:
        dbnum=30;
        break;
    }
    return(dbnum);
}

GTI_WORD
Gti_ConvertFineDB(GTI_WORD slade0)
{
    GTI_WORD GTI_LOCAL_QUAL dbnum;

    switch(slade0&0x000e)
    {
    case 0x00:
        dbnum=0;
        break;
    case 0x02:
        dbnum=30;
        break;
    case 0x04:
        dbnum=60;
        break;
    case 0x06:
        dbnum=90;
        break;
    case 0x08:
        dbnum=120;
        break;
    default:
        dbnum=150;
        break;
    }
    return(dbnum);
}

GTI_WORD
Gti_ConvertSuperDB(GTI_WORD slade0)
{
    GTI_WORD GTI_LOCAL_QUAL dbnum;

    switch(slade0&0x00f0)
    {
    case 0x00:
        dbnum=0;
        break;
    case 0x10:
        dbnum=3;
        break;
    case 0x20:
        dbnum=6;
        break;
    case 0x30:
        dbnum=10;
        break;
    case 0x40:
        dbnum=13;
        break;
    case 0x50:
        dbnum=16;
        break;
    case 0x60:
        dbnum=20;
        break;
    case 0x70:
        dbnum=24;
        break;
    case 0x80:
        dbnum=28;
        break;
    default:
        dbnum=32;
        break;
    }
    return(dbnum);
}

#ifndef GTI_DEBUG
/****************************************************************************/
/* Procedure: Gti_CopyMemory                              Created: 04.06.98 */
/* ----------------------------                                             */
/* Description: The procedure copies memory buffer                          */
/* -------------------------------------------------------------------------*/
void Gti_CopyMemory(GTI_BYTE GTI_ADDRESS_QUAL *pDst,
                    GTI_BYTE GTI_ADDRESS_QUAL *pSrc, GTI_WORD nCount)
{
    GTI_WORD i;

    for(i=0; i < nCount; i++)
        *(pDst++) = *(pSrc++);
}
#endif
