
#include "Gp.h"

#define CALC_RX_CRC

extern wan_adsl_vcivpi_t	adsl_vcivpi_list[];
extern int			adsl_vcivpi_num;

#if defined(__FreeBSD__) || defined(__OpenBSD__)
void adsl_atm_tasklet (void* data, int pending);
#else
void adsl_atm_tasklet (unsigned long data);
#endif
static unsigned long update_crc(unsigned long, char*, int);
static int capture_trace_packet (adapter_t *, void *, char);
static int capture_atm_trace_packet(adapter_t*,void*,int,char);
static int parse_prot_header(adapter_t*, void*);
static void Purge_List(adapter_t *, LIST_NODE *, unsigned char);
static void* create_inarp_request(adapter_t *);
static void handle_atm_admin_packet(adapter_t *, void *);
static void handle_oam_cell_loopback(adapter_t *, void *);


#if 0
static void* create_ethernet_arp_request(adapter_t *pAdapter);
#endif

static unsigned char 
atm_oam_req[]={0x00, 0x00, 0x00, 0x00, 
	       0x18, 0x01, 0x00, 0x03, 0x66, 0xA9, 0xFF, 0xFF, 0xFF, 0xFF, 
	       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
	       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	       0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	       0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x00, 0x00};

		   
/*************************** CALCULATE A 32-BIT CRC ***************************/
#define INITIAL_FCS_VALUE 0xFFFFFFFF
#define EIGHT_BITS 8
#define CRC_OK 0xC704DD7B
#define RX_DMA_BUFFER_LEN 512*52		/*512 Cells */
#define TX_DMA_SINGLE_BUFFER_LEN  1700		/*1536 pkt size */
					        /*1536/42 = 32 cells per frame */
						/*32*4(atm header) = 128 + 10(prot header) = 1674 */
						/*1674 round up to 1700 :) */
#define FLIP_CRC(a,b)  { b=0; \
			 b |= (a&0x000000FF)<<24 ; \
			 b |= (a&0x0000FF00)<<8; \
			 b |= (a&0x00FF0000)>>8; \
			 b |= (a&0xFF000000)>>24; }

#define CLP_BIT		0
#define PT_SDU1		1
#define PT_CONGESTION 	2			 
#define PT_ADMIN	3

#define PAD_CHAR	0x6A

#define WPVPI(cell)	(   (((unsigned char*)(cell))[0]<<4)| \
			    ((((unsigned char*)(cell))[1]&0xF0)>>4) ) 

#define WPVCI(cell)       ( ((((unsigned char*)(cell))[1]&0x0F)<<12) |\
	                    (((unsigned char*)(cell))[2]<<4) | \
	  		    ((((unsigned char*)(cell))[3]&0xF0)>>4) )
			 

/* ATM Header 
 * 
 * --8---7---6---5---4---3---2---1--
 * |             VPI               |
 * |-------------------------------|
 * |     VPI       |    VCI        |
 * |-------------------------------|
 * |             VCI               |
 * |-------------------------------|
 * |      VCI      |    PT     |CLP|
 * |-------------------------------|
 * |             HEC               |
 * |-------------------------------|
 * |                               |
 * |     Information Payload       |
 * |       (48 Octects)            |
 * ---------------------------------
 */
		
/* Protocol Headers 
 *
 * --1-----1-----1--------3---------2--------<=65,527-----
 * |DSAP|SSAP|Control|Unique Id|Protocol Id|   PDU       |
 * -------------------------------------------------------
 *
 * Bridged LLC: Ethernet over ATM
 * 	DSAP		=0xaa
 * 	SSAP		=0xaa
 * 	Control		=0x03
 *	Unique ID	=0x00 0x80 0xC2 	#Bridged PDU
 *	Protocol Id	=0x00 0x07		#802.3/Ethernet 
 *						#Witout Preserverd FCS 
 *	Pading		=0x00 0x00
 *			
 * Classical IP over ATM
 *	DSAP  		=0xAA
 *	SSAP		=0xAA
 *	Control		=0x03
 *	Unique Id	=0x00 0x00 0x00
 *
 *	Protocol Id 	=0x80 0x00  : IP
 *	Protocol Id	=0x80 0x06  : ARP
 *
 *      MTU=8192
 */
			 

static unsigned char g_trailer[]={0x00, 0x00, 0xEE, 0xEE, 0xFF, 0xFF, 0xFF, 0xFF};

/*static int handle_atm_arp(adapter_t *pAdapter, unsigned char*, int);*/
static int handle_atm_arp(adapter_t *pAdapter, void* rx_skb);
void gen_crc_table(void);


/* crc32h.c -- package to compute 32-bit CRC one byte at a time using   */
/*             the high-bit first (Big-Endian) bit ordering convention  */
/*                                                                      */
/* Synopsis:                                                            */
/*  gen_crc_table() -- generates a 256-word table containing all CRC    */
/*                     remainders for every possible 8-bit byte.  It    */
/*                     must be executed (once) before any CRC updates.  */
/*                                                                      */
/*  unsigned update_crc(crc_accum, data_blk_ptr, data_blk_size)         */
/*           unsigned crc_accum; char *data_blk_ptr; int data_blk_size; */
/*           Returns the updated value of the CRC accumulator after     */
/*           processing each byte in the addressed block of data.       */
/*                                                                      */
/*  It is assumed that an unsigned long is at least 32 bits wide and    */
/*  that the predefined type char occupies one 8-bit byte of storage.   */
/*                                                                      */
/*  The generator polynomial used for this version of the package is    */
/*  x^32+x^26+x^23+x^22+x^16+x^12+x^11+x^10+x^8+x^7+x^5+x^4+x^2+x^1+x^0 */
/*  as specified in the Autodin/Ethernet/ADCCP protocol standards.      */
/*  Other degree 32 polynomials may be substituted by re-defining the   */
/*  symbol POLYNOMIAL below.  Lower degree polynomials must first be    */
/*  multiplied by an appropriate power of x.  The representation used   */
/*  is that the coefficient of x^0 is stored in the LSB of the 32-bit   */
/*  word and the coefficient of x^31 is stored in the most significant  */
/*  bit.  The CRC is to be appended to the data most significant byte   */
/*  first.  For those protocols in which bytes are transmitted MSB      */
/*  first and in the same order as they are encountered in the block    */
/*  this convention results in the CRC remainder being transmitted with */
/*  the coefficient of x^31 first and with that of x^0 last (just as    */
/*  would be done by a hardware shift register mechanization).          */
/*                                                                      */
/*  The table lookup technique was adapted from the algorithm described */
/*  by Avram Perez, Byte-wise CRC Calculations, IEEE Micro 3, 40 (1983).*/

#define POLYNOMIAL 0x04c11db7L

static unsigned long crc_table[256];

void gen_crc_table(void)
{ 
   register int i, j;  register unsigned long crc_accum;
   for ( i = 0;  i < 256;  i++ )
       { crc_accum = ( (unsigned long) i << 24 );
         for ( j = 0;  j < 8;  j++ )
              { if ( crc_accum & 0x80000000L )
                   crc_accum =
                     ( crc_accum << 1 ) ^ POLYNOMIAL;
                else
                   crc_accum =
                     ( crc_accum << 1 ); }
         crc_table[i] = crc_accum; }
   return; 
}

static unsigned long update_crc(unsigned long crc_accum, char *data_blk_ptr,
                                                    int data_blk_size)
{ 	
	register int i, j;
   	for ( j = 0;  j < data_blk_size;  j++ )
       	{ i = ( (int) ( crc_accum >> 24) ^ *data_blk_ptr++ ) & 0xff;
         crc_accum = ( crc_accum << 8 ) ^ crc_table[i]; }
   	return crc_accum; 
}

#define CRC10_POLYNOMIAL 0x633
static unsigned short byte_crc10_table[256];
static void gen_byte_crc10_table(void)
/* generate the table of CRC-10 remainders for all possible bytes */
{
    register int i, j;
    register unsigned short crc10_accum;

    for ( i = 0;  i < 256;  i++ )
    {
        crc10_accum = ((unsigned short) i << 2);
        for ( j = 0;  j < 8;  j++ )
        {
            if ((crc10_accum <<= 1) & 0x400) crc10_accum ^= CRC10_POLYNOMIAL;
        }
        byte_crc10_table[i] = crc10_accum;
    }
    return;
}

static __inline unsigned char is_idle_cell(unsigned int *data)
{
	unsigned long atm_header = *data;
	

	/* Idle Cell or Physical Layer OAM Cell */
	if (atm_header == 0x01000000 || atm_header == 0x03000000){
		return 1;
	}

	atm_header &= 0xf1ffff0f;

	/* Reserved for Physical Layer or Unassigned Cell */
	if (atm_header == 0x00000000 || atm_header == 0x01000000){
		return 1;
	}

	/* Data Cell */
	return 0;
}

ATM_PHY_STATUS PciPhyBind(PATM_PHY_BIND_INPUT pBindInput,
                          PATM_PHY_BIND_OUTPUT pBindOutput)
{
	return ATM_PHY_STATUS_SUCCESS;	
}

void gsi_phy_send_complete(PCI_PHY *pPci)
{
#define pAdapter   ((adapter_t*)pPci->AdapterHandle)
	PHY_DESCR *phy_descr;

	ADSL_ASSERT1((!pPci));
	
	if (!pAdapter)
		return;

	while (!IS_LIST_EMPTY(&(pPci->TxCompleteList))){

		phy_descr=(PHY_DESCR*)PHY_REMOVE_LIST(&(pPci->TxCompleteList));
		if (!phy_descr){
			wpabs_debug_event("(PHY_REC): ERROR Phy_descr invalid\n");
			break;
		}
	
		NdisMSendComplete(pAdapter,
				  phy_descr->Buffer->AllocatorContext, 
				  NDIS_STATUS_SUCCESS);		

		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length=0;
		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->chan=NULL;
		phy_descr->Buffer->Size = 0;
		
		PHY_ADD_LIST(&(pPci->TxFreeList),phy_descr);
	}	

	return;
#undef pAdapter
}


/* ethernet broadcast address */
#define MAC_BCAST_ADDR "\xff\xff\xff\xff\xff\xff"

#define ETH_P_PPPOE_DISC 0x8863 /* discovery stage */
#define ETH_P_PPPOE_SESS 0x8864 /* session stage */

/* PPPoE codes */
#define CODE_SESS 0x00 /* PPPoE session */
#define CODE_PADI 0x09 /* PPPoE Active Discovery Initiation */
#define CODE_PADO 0x07 /* PPPoE Active Discovery Offer */
#define CODE_PADR 0x19 /* PPPoE Active Discovery Request */
#define CODE_PADS 0x65 /* PPPoE Active Discovery Session-confirmation */
#define CODE_PADT 0xa7 /* PPPoE Active Discovery Terminate */

struct ethhdr 
{
	unsigned char	h_dest[6];	/* destination eth addr	*/
	unsigned char	h_source[6];	/* source ether addr	*/
	unsigned short	h_proto;		/* packet type ID field	*/
} __attribute__((packed));

/* PPPoE packet; includes Ethernet headers and such */
struct wan_pppoe_packet {
    struct ethhdr	ethhdr; /* ethernet header */
    unsigned int	ver:4; /* pppoe version */
    unsigned int	type:4; /* pppoe type */
    unsigned int	code:8; /* pppoe code CODE_* */
    unsigned int	session:16; /* session id */
    unsigned short	length; /* payload length */
    /* payload follows */
};
/* PPPoE tag; the payload is a sequence of these */
struct wan_pppoe_tag {
    unsigned short type; /* tag type TAG_* */
    unsigned short length; /* tag length */
    /* payload follows */
};

/* PPPoE tag types */
#define TAG_END_OF_LIST        0x0000
#define TAG_SERVICE_NAME       0x0101
#define TAG_AC_NAME            0x0102
#define TAG_HOST_UNIQ          0x0103
#define TAG_AC_COOKIE          0x0104
#define TAG_VENDOR_SPECIFIC    0x0105
#define TAG_RELAY_SESSION_ID   0x0110
#define TAG_SERVICE_NAME_ERROR 0x0201
#define TAG_AC_SYSTEM_ERROR    0x0202
#define TAG_GENERIC_ERROR      0x0203


void *create_pppoe_discovery_packet(adapter_t *pAdapter)
{
	int    size = 0;
	struct wan_pppoe_packet	pkt;
	struct wan_pppoe_tag	tag;
	void*	tx_skb = NULL;
	
	size = sizeof(struct wan_pppoe_packet) + sizeof(struct wan_pppoe_tag);
	if ((tx_skb = wpabs_skb_alloc(size)) == NULL){
		wpabs_debug_event("%s: Failed allocate PPPoE LCP Request packet!\n",
					pAdapter->devname);
		return NULL;
	}
	
	wpabs_memcpy(pkt.ethhdr.h_dest, MAC_BCAST_ADDR, ETHER_ADDR_LEN);
    	wpabs_memcpy(pkt.ethhdr.h_source, &pAdapter->macAddr[0], ETHER_ADDR_LEN);
    	pkt.ethhdr.h_proto	= wpabs_htons(ETH_P_PPPOE_DISC);
    	pkt.ver 		= 1;
	pkt.type		= 1;
	pkt.code		= CODE_PADI;
	pkt.session		= 0;
	pkt.length		= wpabs_htons(size - sizeof(struct wan_pppoe_packet));
	wpabs_skb_copyback(tx_skb, 
			  wpabs_skb_len(tx_skb), 
			  sizeof(struct wan_pppoe_packet), 
			  (unsigned long)&pkt);
    
	/* fill out a blank service-name tag */
	tag.type	= wpabs_htons(TAG_SERVICE_NAME);
	tag.length	= wpabs_htons(0);
	wpabs_skb_copyback(tx_skb, 
			  wpabs_skb_len(tx_skb), 
			  sizeof(struct wan_pppoe_tag), 
			  (unsigned long)&tag);

	return tx_skb;
}

	
void adsl_auto_vci_vpi(unsigned long data)
{
	adapter_t  *pAdapter = (adapter_t *) data;
	void* tx_skb = NULL, *tx_skb1=NULL;
	int timeout=1;

	if ((pAdapter->auto_vcivpi_status != ADSL_AUTO_VCI_VPI_STOP) && 
	    !adsl_can_tx(pAdapter) && wpabs_test_bit(0, &pAdapter->atm_autocfg_running)){
	
		/* Auto detecting VCI/VPI values */
		if ((pAdapter->auto_vcivpi_status == ADSL_AUTO_VCI_VPI_KNOWN) && 
		    (pAdapter->auto_vcivpi_index < adsl_vcivpi_num)){
			/* First, trying standart VCI/VPI values */
			pAdapter->auto_vci = 
				adsl_vcivpi_list[pAdapter->auto_vcivpi_index].vci;
			pAdapter->auto_vpi = 
				adsl_vcivpi_list[pAdapter->auto_vcivpi_index].vpi;
			pAdapter->auto_vcivpi_index++;
		}else
		{
			/* Second, searching all other values for VCI/VPI */
			if (pAdapter->auto_vcivpi_status == ADSL_AUTO_VCI_VPI_KNOWN){
				pAdapter->auto_vcivpi_status = ADSL_AUTO_VCI_VPI_SEARCH;
				pAdapter->auto_vci = 0;
				pAdapter->auto_vpi = 0;
			}else{	
				if (pAdapter->auto_vci++ == 0xFFFF){
					pAdapter->auto_vpi++;
				}

				/* Skip vci number 21, it seems to be the loopback
				 * VCI number */
				if (pAdapter->auto_vci == 21){
					pAdapter->auto_vci++;
				}
				
				if (pAdapter->auto_vci == 0x00 && pAdapter->auto_vpi == 0x00){
					pAdapter->auto_vcivpi_status = ADSL_AUTO_VCI_VPI_STOP;
				}
			}
		}
	
		if (pAdapter->auto_vcivpi_status == ADSL_AUTO_VCI_VPI_STOP){
			return;
		}
				
		if (pAdapter->EncapMode == RFC_MODE_BRIDGED_ETH_LLC ||
		    pAdapter->EncapMode == RFC_MODE_BRIDGED_ETH_LLC){
			wpabs_debug_event("%s: ATM Discovery: Sending PPPoE LCP Request (Vci=%d, Vpi=%d)\n",
				pAdapter->devname, pAdapter->auto_vci,pAdapter->auto_vpi);
			tx_skb=create_pppoe_discovery_packet(pAdapter);
			/*tx_skb1=create_ethernet_arp_request(pAdapter);*/
			
		}else if (pAdapter->EncapMode == RFC_MODE_ROUTED_IP_LLC){
			wpabs_debug_event("%s: ATM Discovery: Sending InARP LCP Request (Vci=%d, Vpi=%d)\n",
				pAdapter->devname, pAdapter->auto_vci,pAdapter->auto_vpi);
			tx_skb=create_inarp_request(pAdapter);
		}else{
			timeout=5;
		}

		if (tx_skb){
			adsl_send(pAdapter, tx_skb, 1);
		}

		if (tx_skb1){
			adsl_send(pAdapter, tx_skb1, 1);
		}
		
		wpabs_add_timer(pAdapter->auto_vcivpi, timeout);
	}else{
		wpabs_del_timer(pAdapter->auto_vcivpi);
	}

	if (tx_skb){
		wpabs_skb_free(tx_skb);
	}
	if (tx_skb1){
		wpabs_skb_free(tx_skb1);
	}
	return;	
}
		
		
void gsi_phy_receive_complete(PCI_PHY *pPci)
{
#define pAdapter   ((adapter_t*)pPci->AdapterHandle)
	wpabs_debug_rx("(Debug RX): Schedule Rx task.\n");
	wpabs_tasklet_schedule(pAdapter->tq_atm_task);
	return;
#undef pAdapter
}

#if defined(__FreeBSD__) || defined(__OpenBSD__)
void adsl_atm_tasklet (void* data, int pending)
#else
void adsl_atm_tasklet (unsigned long data)
#endif
{	
#define pAdapter 	((adapter_t*)data)
#define pPci	 	((PCI_PHY*)(&(pAdapter->pciPhy)))	
#define pLan		((gsi_lan_t*)&(pAdapter->lan))

	PHY_DESCR*		phy_descr;
	volatile GP_CELL*	atm_cell;
	void*			rx_skb = pAdapter->rx_skb;
	unsigned short 		info_len;
	GP_BYTE*		data_ptr = NULL;
	int 			num_of_cells = 0;
	int 			i;
#ifdef CALC_RX_CRC
	volatile unsigned long 	pdu_crc = INITIAL_FCS_VALUE;
	volatile unsigned long  org_pdu_crc;
#endif	
	if (wpabs_test_bit(1,&pAdapter->tq_atm_task_running)){
		wpabs_debug_event("CRITICAL IN TASKLET!\n");
		wpabs_tasklet_end(pAdapter->tq_atm_task);
		return;
	}
	wpabs_set_bit(1,&pAdapter->tq_atm_task_running);
	
	if (pPci->State != PCI_PHY_STATE_OPERATIONAL){
		wpabs_debug_event("(PHY_REC): ERROR State not operational\n");
		wpabs_clear_bit(1,&pAdapter->tq_atm_task_running);
		wpabs_tasklet_end(pAdapter->tq_atm_task);
		return;
	}

	wpabs_debug_rx("%s: ADSL ATM task running...\n", pAdapter->devname);
	while (!IS_LIST_EMPTY(&(pPci->RxCompleteList))){
		phy_descr=(PHY_DESCR*)PHY_REMOVE_LIST(&(pPci->RxCompleteList));
		if (!phy_descr){
			wpabs_debug_event("(PHY_REC): ERROR Phy_descr invalid\n");
			break;
		}
	
		/* Handle an ATM Cell :) */
		atm_cell = (GP_CELL *)phy_descr->Buffer->Data;

#if 0
		if (oam_test == 0){
			unsigned char test_frame[]={
			0x00, 0x80, 0x02, 0x3A ,0x18 ,0x01, 0x00, 0x03, 0x00, 0x25, 
			0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
			0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
			0xFF, 0xFF, 0xFF, 0xFF, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 
			0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 
			0x00, 0x27 };
			oam_test=1;
			wpabs_memcpy((void*)atm_cell,test_frame,52);
		}
#endif
		
		num_of_cells=phy_descr->Buffer->Size/52;
	
		for (i=0; i<num_of_cells; i++){

			wpabs_debug_rx("RX: ATM HEADER %x %x %x %x  CFG: ATM HEADER %x %x %x %x\n",
					atm_cell->hdr[0],
					atm_cell->hdr[1],
					atm_cell->hdr[2],
					atm_cell->hdr[3],
					pAdapter->atm_header[0],
					pAdapter->atm_header[1],
					pAdapter->atm_header[2],
					pAdapter->atm_header[3]);

			if (is_idle_cell((unsigned int*)atm_cell)){
				/* Discard idle cells */
				++pAdapter->atm_stats.rx_empty;
				goto atm_cell_failure;
			}		
			
			if (adsl_tracing_enabled(pAdapter->trace_info) == 2){
				/* Capture cell for ATM Cell trace */
				capture_atm_trace_packet(pAdapter,	
					  	         (void*)atm_cell,
							 sizeof(GP_CELL),
					        	 TRC_INCOMING_FRM);
			}
			
			/* Test if the incoming cell is an ATM management packet.
			 * If it is run it through the ATM management handler */
			if (wpabs_test_bit(PT_ADMIN,(void*)&atm_cell->hdr[3])){
				handle_atm_admin_packet(pAdapter,(void*)atm_cell);
				wpabs_debug_tx("%s: Dropping Admin Packet PTI=0x%X\n",
						pAdapter->devname,(atm_cell->hdr[3]&0x0E)>>1);
				goto atm_cell_failure;
			}

			/* Clear the data congestion bit , we don't care */
			if (wpabs_test_bit(PT_CONGESTION,(void*)&atm_cell->hdr[3])){
				wpabs_clear_bit(PT_CONGESTION,(void*)&atm_cell->hdr[3]);
				++pAdapter->atm_stats.rx_congestion;
			}
			
			/* Clear the cell loss priority , we dont care */
			if (wpabs_test_bit(CLP_BIT,(void*)&atm_cell->hdr[3])){
				wpabs_clear_bit(CLP_BIT,(void*)&atm_cell->hdr[3]);
				++pAdapter->atm_stats.rx_clp;
			}
			
			/* PT bit not set: Start of the frame.
			 * PT bit set: Last data fragment */
			if (!wpabs_test_bit(PT_SDU1,(void*)&atm_cell->hdr[3])){

				wpabs_debug_rx("%s: RX: New frame\n", 
							pAdapter->devname);

				if (pAdapter->atm_autocfg != 0){

					pAdapter->atm_autocfg = 0;
					pAdapter->atm_header[0] = atm_cell->hdr[0];
					pAdapter->atm_header[1] = atm_cell->hdr[1];
					pAdapter->atm_header[2] = atm_cell->hdr[2];
					pAdapter->atm_header[3] = atm_cell->hdr[3];
				
					pAdapter->Vpi=WPVPI(pAdapter->atm_header);

					pAdapter->Vci=WPVCI(pAdapter->atm_header);
					
					wpabs_debug_event("%s: ATM AutoCfg: VPI=%d VCI=%d\n",
							pAdapter->devname,
							pAdapter->Vpi,
							pAdapter->Vci);

					if (pAdapter->auto_vcivpi_status == ADSL_AUTO_VCI_VPI_SEARCH){
						adsl_vcivpi_list[adsl_vcivpi_num].vci = pAdapter->Vci; 
						adsl_vcivpi_list[adsl_vcivpi_num].vpi = pAdapter->Vpi; 
						adsl_vcivpi_num++;
					}
					
				}

				if (wpabs_test_bit(0, &pAdapter->atm_autocfg_running)){
					wpabs_clear_bit(0, &pAdapter->atm_autocfg_running);
				}

				if (*(unsigned int*)atm_cell != *(unsigned int*)pAdapter->atm_header){
					
					if (wpabs_net_ratelimit()){
					wpabs_debug_event( 
						"%s: Rx ATM frame with invalid header: VPI=%d, VCI=%d : New=0x%08X\n : Orig=0x%08X\n",
							pAdapter->devname,
							WPVPI(atm_cell),WPVCI(atm_cell),
							*(unsigned int*)atm_cell,
							*(unsigned int*)pAdapter->atm_header);
					}
					++pAdapter->atm_stats.rx_invalid_atm_hdr;
				}

				
				if (wpabs_skb_len(rx_skb) + 48 > pAdapter->max_sdu_size){
					wpabs_debug_rx("%s: ATM Error: SDU0 Frame too big %d > %d !\n",
							pAdapter->devname,
							wpabs_skb_len(rx_skb) + 48,
							pAdapter->max_sdu_size);
					wpabs_skb_init(rx_skb, 16);
					wpabs_skb_trim(rx_skb, 0);
					++pAdapter->atm_stats.rx_atm_pdu_size;
					goto atm_cell_failure;
				}
	
				data_ptr=(unsigned char*)atm_cell->info;
				wpabs_skb_copyback(rx_skb, 
						 wpabs_skb_len(rx_skb), 
						 48, 
						 (unsigned long)data_ptr);
				++pAdapter->atm_stats.rx_valid;
			}else{
				wpabs_debug_rx("%s: RX: Last data fragment\n", 
						pAdapter->devname);

				info_len = *((unsigned short*)&atm_cell->info[42]);
				info_len = wpabs_htons(info_len);
#ifdef CALC_RX_CRC
				org_pdu_crc = *((volatile unsigned long*)&atm_cell->info[44]);
#endif
				
				if (wpabs_skb_len(rx_skb) + 48 > pAdapter->max_sdu_size){

					wpabs_debug_rx("%s: ATM Error: SDU1 Frame too big %d > %d !\n",
							pAdapter->devname,
							wpabs_skb_len(rx_skb) + 48,
							pAdapter->max_sdu_size);

					wpabs_skb_init(rx_skb, 16);
					wpabs_skb_trim(rx_skb, 0);
					++pAdapter->atm_stats.rx_atm_pdu_size;
					goto atm_cell_failure;
				}

				data_ptr=(GP_BYTE*)&atm_cell->info[0];
				wpabs_skb_copyback(rx_skb, 
						 wpabs_skb_len(rx_skb), 
						 48, 
						 (unsigned long)data_ptr);


#ifdef CALC_RX_CRC
				pdu_crc=INITIAL_FCS_VALUE;
				pdu_crc=update_crc(pdu_crc,wpabs_skb_data(rx_skb),wpabs_skb_len(rx_skb));
				if (pdu_crc != CRC_OK){
					wpabs_debug_rx("%s: Invalid Rx PDU CRC %X %X\n",
							pAdapter->devname,pdu_crc,org_pdu_crc);
					++pAdapter->atm_stats.rx_atm_pdu_size;
					wpabs_skb_init(rx_skb, 16);
					wpabs_skb_trim(rx_skb, 0);
					goto atm_cell_failure;
				}
#endif				
				if (wpabs_skb_len(rx_skb) > info_len){
					wpabs_skb_trim(rx_skb, info_len);
				}

				if (adsl_tracing_enabled(pAdapter->trace_info) >= 0){
					capture_trace_packet(
							pAdapter,	
							rx_skb,
							TRC_INCOMING_FRM);
				}

				if (parse_prot_header(pAdapter, rx_skb)){
					wpabs_skb_init(rx_skb, 16);
					wpabs_skb_trim(rx_skb, 0);
					++pAdapter->atm_stats.rx_invalid_prot_hdr;
					goto atm_cell_failure;
				}

				++pAdapter->atm_stats.rx_valid;
				wpabs_skb_pull(rx_skb, pAdapter->prot_header_size);

				if (pAdapter->config.interface == LAN_INTERFACE){	
					if (pLan->dev && wpabs_netif_dev_up(pLan->dev)){
						adsl_lan_rx(
							pLan->dev,
							NULL,	/*rx_skb->data,	//Header*/
							0,      /*1,*//*Header length*/
							wpabs_skb_data(rx_skb),
							wpabs_skb_len(rx_skb));
					}
				}
#ifdef GSI_WAN				
				else{
					wpabs_debug_rx("(DEBUG): WAN Rx got pkt\n");

					/*wpabs_debug_print_skb(rx_skb,0);*/
					GpWanRx(pAdapter,
						&pAdapter->wan.channel[0],
						(unsigned char*)wpabs_skb_data(rx_skb),
						wpabs_skb_len(rx_skb));
				}	
#endif
				wpabs_skb_init(rx_skb, 16);
				wpabs_skb_trim(rx_skb, 0);
			}
atm_cell_failure:

			atm_cell++;
		}/* for */

		phy_descr->Buffer->Size=0;
		phy_descr->Buffer->Data=NULL;

		PHY_ADD_LIST(&(pPci->RxFreeList),phy_descr);	
	}
	wpabs_clear_bit(1,&pAdapter->tq_atm_task_running);
	wpabs_tasklet_end(pAdapter->tq_atm_task);
	return;
#undef pLan
#undef pPci
#undef pAdapter
}

BOOLEAN GpatmisAtmUniInitialize (void)
{
	/* INITIALIZATION OK */
	return 1;
}

ATM_UNI_HANDLE
GpatmisAtmUniCreate(ATM_UNI_USER_HANDLE	UserHandle,
		    ATM_UNI_USER_LINK_STATUS_CHANGE	UserLinkStatusChange,
		    BOOLEAN				IndicatePackets,
		    ULONG				MediaSpecificInformationSize,
		    USHORT				MaxSduSize, 
		    USHORT				RxBufferCount, 
		    USHORT				TxBufferCount, 
		    NDIS_HANDLE				MiniportAdapterHandle,
		    ATM_PHY_BIND 			PhyBind,
		    ATM_PHY_DEVICE_HANDLE		PhyDeviceHandle,
		    PUCHAR				PhyUniqueId)
{
	adapter_t   *pAdapter= (adapter_t*)UserHandle;
	PCI_PHY *pPci = &pAdapter->pciPhy;
	PHY_DESCR *phy_descr;
	XFER_DATA_BUFFER *phy_buffer;	
	int i;

	switch (pAdapter->EncapMode){

		case RFC_MODE_BRIDGED_ETH_LLC:
			wpabs_debug_event("%s: ATM configured for Bridged LLC ETH/ATM\n",
					pAdapter->devname);
			pAdapter->prot_header[0]=0xAA;
			pAdapter->prot_header[1]=0xAA;
			pAdapter->prot_header[2]=0x03;
			pAdapter->prot_header[3]=0x00;
			pAdapter->prot_header[4]=0x80;
			pAdapter->prot_header[5]=0xC2;
			pAdapter->prot_header[6]=0x00;
			pAdapter->prot_header[7]=0x07;
			pAdapter->prot_header[8]=0x00;
			pAdapter->prot_header[9]=0x00;
			pAdapter->prot_header_size=10;	
			break;

		case RFC_MODE_BRIDGED_ETH_VC:
			wpabs_debug_event("%s: ATM configured for Bridged VC ETH/ATM\n",
					pAdapter->devname);
			pAdapter->prot_header[0]=0x00;
			pAdapter->prot_header[1]=0x00;
			pAdapter->prot_header_size=2;
			break;

		case RFC_MODE_ROUTED_IP_LLC:
			wpabs_debug_event("%s: ATM configured for Classical IP (LLC) over ATM\n",
					pAdapter->devname);
			pAdapter->prot_header[0]=0xAA;
			pAdapter->prot_header[1]=0xAA;
			pAdapter->prot_header[2]=0x03;
			pAdapter->prot_header[3]=0x00;
			pAdapter->prot_header[4]=0x00;
			pAdapter->prot_header[5]=0x00;
			pAdapter->prot_header[6]=0x08;
			pAdapter->prot_header[7]=0x00;
			pAdapter->prot_header_size=8;
			break;


		case RFC_MODE_ROUTED_IP_VC:
			wpabs_debug_event("%s: ATM configured for IP (VC) over ATM\n",
					pAdapter->devname);
			pAdapter->prot_header_size=0;
			break;
			
		case RFC_MODE_PPP_LLC:
			wpabs_debug_event("%s: ATM configured for PPP (LLC) over ATM\n",
					pAdapter->devname);
			pAdapter->prot_header[0]=0xFE;
			pAdapter->prot_header[1]=0xFE;
			pAdapter->prot_header[2]=0x03;
			pAdapter->prot_header[3]=0xCF;
			pAdapter->prot_header_size=4;
			break;

		case RFC_MODE_PPP_VC:
			wpabs_debug_event("%s: ATM configured for PPP (VC) over ATM\n",
					pAdapter->devname);
			pAdapter->prot_header_size=0;
			break;


		default:
			wpabs_debug_event("%s: ERROR: Invalid ATM Lan Protocol option %d!\n",
					pAdapter->devname,pAdapter->EncapMode);
			return NULL;
	}
	
	pAdapter->atm_header[0] = (pAdapter->Vpi &0xF0)>>4;	
	pAdapter->atm_header[1] = (pAdapter->Vpi &0x0F)<<4;	
	pAdapter->atm_header[1] |= (pAdapter->Vci&0xF000)>>12;
	pAdapter->atm_header[2] = (pAdapter->Vci &0x0FF0)>>4;
	pAdapter->atm_header[3] = (pAdapter->Vci &0x000F)<<4;
		
	wpabs_memcpy(&pAdapter->trailer[0],&g_trailer[0],sizeof(pAdapter->trailer));
	
	wpabs_debug_cfg("%s: ATM header = %x %x %x %x\n",
			pAdapter->devname,
			pAdapter->atm_header[0],pAdapter->atm_header[1],
			pAdapter->atm_header[2],pAdapter->atm_header[3]);
	
	pPci->AdapterHandle = pAdapter;

	INITIALIZE_LIST_HEAD(&(pPci->TxFreeList));
	INITIALIZE_LIST_HEAD(&(pPci->TxPendingList));
	INITIALIZE_LIST_HEAD(&(pPci->TxCompleteList));
	INITIALIZE_LIST_HEAD(&(pPci->RxFreeList));
	INITIALIZE_LIST_HEAD(&(pPci->RxCompleteList));

	/* Allocation for our mailboxes */
	pPci->RxBuffer.length = RX_DMA_BUFFER_LEN;
	pPci->Dma = wpabs_dma_alloc(pAdapter->card, RX_DMA_BUFFER_LEN);
	if (pPci->Dma == NULL){
		wpabs_debug_event("%s: ERROR: Failed allocate DMA memory!\n",
						pAdapter->devname);
		return NULL;
	}
	pPci->RxBuffer.vAddr = wpabs_dma_get_vaddr(pAdapter->card, pPci->Dma);
	pPci->RxBuffer.pAddr = wpabs_dma_get_paddr(pAdapter->card, pPci->Dma);
	wpabs_memset(pPci->RxBuffer.vAddr, 0, RX_DMA_BUFFER_LEN);
	
	if (!pPci->RxBuffer.pAddr){
		wpabs_debug_event("%s: ERROR: Failed to map virt !\n", 
					pAdapter->devname);
		goto atm_uni_create_exit;
	}
	
	/* Allocate Rx Free Buffers */
	for (i=0; i<8; i++){

		phy_descr = wpabs_malloc(sizeof(PHY_DESCR));
		if (!phy_descr){
			goto atm_uni_create_exit;
		}
		wpabs_memset(phy_descr,0,sizeof(PHY_DESCR));

		phy_buffer = wpabs_malloc(sizeof(XFER_DATA_BUFFER));
		if (!phy_buffer){
			wpabs_free(phy_descr);
			goto atm_uni_create_exit;
		}
		wpabs_memset(phy_buffer,0,sizeof(XFER_DATA_BUFFER));
		
		phy_descr->Buffer = phy_buffer;
		INITIALIZE_LIST_HEAD(&(phy_descr->Link));	
		
		PHY_ADD_LIST(&pPci->RxFreeList,phy_descr);
	}

	/* Allocate Tx Free Buffers */
	for (i=0;i<8;i++){
		phy_descr = wpabs_malloc(sizeof(PHY_DESCR));
		if (!phy_descr){
			wpabs_debug_event("%s: Failed allocate Tx phys descriptor!\n",
							pAdapter->devname);
			goto atm_uni_create_exit;
		}
		wpabs_memset(phy_descr,0,sizeof(PHY_DESCR));
	
		phy_buffer = wpabs_malloc(sizeof(XFER_DATA_BUFFER));
		if (!phy_buffer){
			wpabs_debug_event("%s: Failed allocate Tx phys buffer!\n",
							pAdapter->devname);
			wpabs_free(phy_descr);
			goto atm_uni_create_exit;
		}
		wpabs_memset(phy_buffer, 0, sizeof(XFER_DATA_BUFFER));
	
		phy_buffer->AllocatorContext = wpabs_malloc(sizeof(pkt_info_t));
		if (!phy_buffer->AllocatorContext){
			wpabs_debug_event("%s: Failed allocate Tx phys buffer!\n",
							pAdapter->devname);
			wpabs_free(phy_descr);
			wpabs_free(phy_buffer);
			goto atm_uni_create_exit;
		}
		
		/* Allocation for our mailboxes */
		phy_buffer->Size = pAdapter->max_sdu_size;
		phy_buffer->Dma = wpabs_dma_alloc(pAdapter->card, pAdapter->max_sdu_size);
		
		if (phy_buffer->Dma == NULL){
			wpabs_debug_event("%s: ERROR: Failed allocate DMA memory!\n",
							pAdapter->devname);
			return NULL;
		}
		phy_buffer->Data = wpabs_dma_get_vaddr(pAdapter->card, phy_buffer->Dma);
		if (!phy_buffer->Data){
			wpabs_debug_event("%s: Failed allocate Tx DMA buffer!\n",
							pAdapter->devname);
			wpabs_free(phy_descr);
			wpabs_free(phy_buffer);
			wpabs_free(phy_buffer->AllocatorContext);
			goto atm_uni_create_exit;
		}
	
		phy_descr->Buffer = phy_buffer;
		INITIALIZE_LIST_HEAD(&(phy_descr->Link));
		
		PHY_ADD_LIST(&(pPci->TxFreeList),phy_descr);		
	}
	
	pAdapter->rx_skb = 
		wpabs_skb_alloc(pAdapter->max_sdu_size+sizeof(GP_CELL));
	if (!pAdapter->rx_skb){
		wpabs_debug_event("%s: Failed allocate memory for RX packet (%d bytes)!\n",
				pAdapter->devname, pAdapter->max_sdu_size+sizeof(GP_CELL));
		goto atm_uni_create_exit;
	}

	wpabs_skb_trim(pAdapter->rx_skb,0);

	pPci->State = PCI_PHY_STATE_OPERATIONAL;

	wpabs_memset(pAdapter->pad_len_buf,PAD_CHAR,sizeof(pAdapter->pad_len_buf));

	gen_crc_table();
	gen_byte_crc10_table();

	wpabs_tasklet_init(pAdapter->tq_atm_task,
			  0,
			  (void*)&adsl_atm_tasklet,
			  (void*)pAdapter); 

	wpabs_tasklet_end(pAdapter->tq_atm_task);

	return UserHandle; 

atm_uni_create_exit:

	GpatmisAtmUniDestroy(pAdapter);
	
	return NULL;
}

static void 
Purge_List(adapter_t *pAdapter, LIST_NODE *list, unsigned char tx_buf)
{
	PHY_DESCR *phy_descr;

	while (!IS_LIST_EMPTY(list)){
		phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(list);
		if (phy_descr){
			if (tx_buf && phy_descr->Buffer->AllocatorContext){
				if (((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length){

					NdisMSendComplete(pAdapter,
				   		phy_descr->Buffer->AllocatorContext, 
				   		NDIS_STATUS_FAILURE);		
				
					((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length=0;
					((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->chan=NULL;
				}
				wpabs_free(phy_descr->Buffer->AllocatorContext);
				phy_descr->Buffer->AllocatorContext=NULL;
			}
			
			if (tx_buf && phy_descr->Buffer->Data){
				wpabs_dma_free(pAdapter->card, phy_descr->Buffer->Dma);
				phy_descr->Buffer->Data = NULL;
			}

			if (phy_descr->Buffer){
				phy_descr->Buffer->Data=NULL;
				wpabs_free(phy_descr->Buffer);
				phy_descr->Buffer=NULL;
			}

			wpabs_free(phy_descr);
		}
	}
}


void GpatmisAtmUniDestroy( ATM_UNI_HANDLE AtmUniHandle)
{
	adapter_t   *pAdapter= (adapter_t*)AtmUniHandle;
	PCI_PHY *pPci = &(pAdapter->pciPhy);
	unsigned long flags;


	pPci->State = PCI_PHY_STATE_HALTED;

	wpabs_tasklet_kill(pAdapter->tq_atm_task);

	adsl_card_lock_irq(pAdapter,&flags);
	
	Purge_List(pAdapter,&(pPci->TxFreeList),1);
	Purge_List(pAdapter,&(pPci->TxPendingList),1);
	Purge_List(pAdapter,&(pPci->TxCompleteList),1);

	Purge_List(pAdapter,&(pPci->RxFreeList),0);
	Purge_List(pAdapter,&(pPci->RxCompleteList),0);

	pPci->AdapterHandle = NULL;

	if (pPci->RxBuffer.vAddr){
		wpabs_debug_cfg("wanpipe: ATM dealocating DMA buffer %d!!!\n",
				pPci->RxBuffer.length);
		wpabs_dma_free(pAdapter->card, pPci->Dma);

		pPci->RxBuffer.vAddr  = NULL;
		pPci->RxBuffer.pAddr  = 0;
		pPci->RxBuffer.length = 0;
	}

	if (pAdapter->rx_skb){
		wpabs_skb_free(pAdapter->rx_skb);
		pAdapter->rx_skb = NULL;
	}

	adsl_card_unlock_irq(pAdapter,&flags);

	return;
}


/***************************************************************************/
/* 			RFC1577 DECLARATIONS				   */ 	
/***************************************************************************/



BOOLEAN GpatmisRfc1577Initialize(PATM_USB_INSTANCE Instance)
{
	return 1;
}

NDIS_STATUS GpatmisRfc1577Send (PATM_USB_INSTANCE pInstance, 
				void* tx_skb,
                                unsigned int Flag)
{
#define pAdapter ((adapter_t*)pInstance)
#define pPci	 ((PCI_PHY*)(&(pAdapter->pciPhy)))		
#define pLan	 ((gsi_lan_t*)&(pAdapter->lan))
	
	PHY_DESCR *phy_descr;
	unsigned char *src_data_ptr;
	unsigned int  src_data_size, src_payload_size;
	unsigned char *target_data_ptr;
	unsigned int  offset=0,pad=0;
	unsigned long crc = INITIAL_FCS_VALUE;
	unsigned long fin_crc;
	int i;
	unsigned long flags;

	/* If the incoming packet has length of zero 
	 * stop the tx procedure */
	if (wpabs_skb_len(tx_skb) == 0){
		return NDIS_STATUS_FAILURE;
	}

	wpabs_debug_tx("%s: Sending packet (%d bytes)...\n", 
				pAdapter->devname, wpabs_skb_len(tx_skb));

	
	src_data_ptr    = wpabs_skb_data(tx_skb);
        src_data_size   = wpabs_skb_len(tx_skb);

	if (src_data_ptr == NULL || src_data_size == 0){
		wpabs_debug_event("%s: src_data_ptr is NULL or src_data_size is 0!\n", 
						pAdapter->devname);
		return NDIS_STATUS_FAILURE;
	}


	/* Check that a Tx DMA buffer is available. If there
	 * are not buffers available, try to kickstart the
	 * tx process with gsi_dma_tx_start() command. */

	adsl_card_lock_irq(pInstance,&flags);

	if (IS_LIST_EMPTY(&(pPci->TxFreeList))){

		gsi_dma_tx_start(pAdapter);
		
		adsl_card_unlock_irq(pInstance,&flags);
		return NDIS_STATUS_PENDING;
	}

	phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(&(pPci->TxFreeList));
	if (!phy_descr){
		adsl_card_unlock_irq(pInstance,&flags);
		return NDIS_STATUS_FAILURE;
	}

	adsl_card_unlock_irq(pInstance,&flags);

	/* If the incoming packet is an ATMARP, we must change the
	 * default IPoATM PDU header to ATMARP header, just for
	 * this pakcet.  This value will be reset after the SAR
	 * is finished with this packet */
	if (pAdapter->EncapMode==RFC_MODE_ROUTED_IP_LLC &&
	    *(unsigned short*)&src_data_ptr[0]==ATMARP_HEADER){
		pAdapter->prot_header[7]=0x06;
	}
	
	target_data_ptr=(unsigned char *)phy_descr->Buffer->Data;

	/* Initialize SAR variables used to cut up the tx packet
	 * into ATM Cells */
	offset=0;
	src_payload_size = src_data_size + pAdapter->prot_header_size;
	*((unsigned short*)&pAdapter->trailer[2])=wpabs_htons(src_payload_size);
	*((unsigned short*)&pAdapter->pad_len_buf[47])=0x00;
	*((unsigned short*)&pAdapter->pad_len_buf[49])=wpabs_htons(src_payload_size);
	
	/* If we are in ATM auto configuration mode, use the temporary 
	 * VPI/VCI values.  Once we are finished the default values will
	 * be used. Each second the auto_vpi/auto_vci values will change
	 * untill the matching VPI/VCI set is found */
	if (wpabs_test_bit(0, &pAdapter->atm_autocfg_running)){	
		pAdapter->atm_header[0] = (pAdapter->auto_vpi & 0xF0)>>4;	
		pAdapter->atm_header[1] = (pAdapter->auto_vpi & 0x0F)<<4;	
		pAdapter->atm_header[1]|= (pAdapter->auto_vci & 0xF000)>>12;
		pAdapter->atm_header[2] = (pAdapter->auto_vci & 0x0FF0)>>4;
		pAdapter->atm_header[3] = (pAdapter->auto_vci & 0x000F)<<4;
	}else{
		pAdapter->atm_header[0] = (pAdapter->Vpi & 0xF0)>>4;	
		pAdapter->atm_header[1] = (pAdapter->Vpi & 0x0F)<<4;	
		pAdapter->atm_header[1]|= (pAdapter->Vci & 0xF000)>>12;
		pAdapter->atm_header[2] = (pAdapter->Vci & 0x0FF0)>>4;
		pAdapter->atm_header[3] = (pAdapter->Vci & 0x000F)<<4;
	}


	/* Begining of the SAR. 
	 * Start cutting up the tx frame into ATM 
	 * Cells.  Note: we do not calculate the HEC here. The HEC is
	 * done in hardware. Thus we only have to deal with 52 bytes
	 * frames */
	for (i=0;;){

		/* Each ATM cell starts with a 4 byte (i.e. HEC not included)
		 * ATM header which contains VPI/VCI/PT/CLP values */
		wpabs_memcpy((target_data_ptr+offset),
		             pAdapter->atm_header,
			     sizeof(pAdapter->atm_header));
		offset+=sizeof(pAdapter->atm_header);
	
		/* Check that a tx packet can fit into a single
		 * ATM cell which can accommodate 48 bytes of data */
		if ((i+48) <= src_payload_size){
		
			/* The packet cannot fit into a single cell */
			
			/* Check if this is a first cell of an ATM PDU */
			if (i==0){
				/* If this is a first cell of the ATM PDU
				 * we must append an ATM PDU header. ATM
				 * PDU header defines the above protocol
				 * that is being transported by the ATM
				 * network */
				wpabs_memcpy((target_data_ptr+offset),
				        pAdapter->prot_header,
					pAdapter->prot_header_size);
		
				offset+=pAdapter->prot_header_size;
			
				wpabs_memcpy((target_data_ptr+offset),
				        src_data_ptr,
				        (48-pAdapter->prot_header_size)); 
				src_data_ptr += (48-pAdapter->prot_header_size);
				offset += (48-pAdapter->prot_header_size);

			}else{
				/* Not a first cell, thus, just fill the 48 bytes
				 * of data and move to another cell */
				wpabs_memcpy((target_data_ptr+offset),src_data_ptr,48);
				src_data_ptr += 48;
				offset += 48;
			}
			++pAdapter->atm_stats.tx_valid;
		}else{
			
			/* Tx packet can fit into a single cell or 
			 * we have reached the last cell needed to
			 * tx the ATM PDU */
			
			++pAdapter->atm_stats.tx_valid;
			
			if (i==0){
				/* This is the first cell, which means
				 * that the ATM PDU can fit into a
				 * single cell i.e. less than 48 bytes.
				 *
				 * The Payload is smaller than 48 bytes,
				 * there are two scenarios here:
				 * 
				 * 1) Payload + Trailer = PDU fit into a
				 *    single cell. i.e <= 48
				 *    
				 * 2) Payload + Trailer > PDU do not fit
				 *    into a single cell i.e. > 48 thus 
				 *    we must create and pad the second cell
				 */
				
				/* Creating a first cell */
				wpabs_memcpy((target_data_ptr+offset),
				        pAdapter->prot_header,
				        pAdapter->prot_header_size);
				offset+=pAdapter->prot_header_size;
			
				wpabs_memcpy((target_data_ptr+offset),
				       src_data_ptr,
				       src_data_size); 
				src_data_ptr += src_data_size;
				offset += src_data_size;
			
			}else{
				/* Copy the last part of the tx frame
				 * into the ATM CELL */
				
				if ((src_payload_size - i) > 0){
					wpabs_memcpy((target_data_ptr+offset),
					       src_data_ptr,
					       (src_payload_size-i)); 
					src_data_ptr+=(src_payload_size-i);
					offset	   +=(src_payload_size-i);
				}
			}

			/* Since this is the last ATM CELL we must append a
			 * ATM PDU trailer to the CELL.  Check if the trailer
			 * will fit into the CELL.  If not we must create
			 * another cell and pad it */
			
			if ((src_payload_size+sizeof(pAdapter->trailer)) > (i+48)){
				
				/* We cannot fit the whole PDU frame
				 * into this cell. We need add another cell. */
				
				/* Pad to the end of the first cell because
				 * the trailer must reside at the end of the
				 * ATM CELL. Thus we'll put it at the end of
				 * the next cell */
				pad=((i+48)-src_payload_size);
				if (pad > 0){
					wpabs_memset((target_data_ptr+offset),PAD_CHAR,pad);
					offset+=pad;
				}

				/* Start the atm header on second cell */
				wpabs_memcpy((target_data_ptr+offset),
					pAdapter->atm_header,
					sizeof(pAdapter->atm_header));

				offset+=sizeof(pAdapter->atm_header);
			
				/* Set the END of FRAME bit in the PT section of
				 * the ATM header, this will indicate to the
				 * remote side that this CELL is the last */
				wpabs_set_bit(1,&((target_data_ptr+offset-1)[0]));

				/* Pad the second cell until trailer */
				wpabs_memset((target_data_ptr+offset),PAD_CHAR,40);
				offset+=40;
				pad+=40;
				
				/* Insert trailer as last 8 bytes. The
				 * trailer contains dummy data right now
				 * because we still have to calculate the CRC
				 * and the overall packet length */
				wpabs_memcpy((target_data_ptr+offset),
						pAdapter->trailer,
						sizeof(pAdapter->trailer));
				
				offset+=sizeof(pAdapter->trailer);
			}else{
				/* The whole PDU fits into this frame */
				
				/* PAD all the unused bytes of the CELL that reside
				 * between ATM PDU data and the trailer */
				pad=((i+48)-(src_payload_size+sizeof(pAdapter->trailer)));
				if (pad > 0){
					wpabs_memset((target_data_ptr+offset),PAD_CHAR,pad);
					offset+=pad;
				}
								
				/* Insert trailer as last 8 bytes. The
				 * trailer contains dummy data right now
				 * because we still have to calculate the CRC
				 * and the overall packet length */
				wpabs_memcpy((target_data_ptr+offset),
						pAdapter->trailer,
						sizeof(pAdapter->trailer));
				
				wpabs_memcpy((target_data_ptr+offset+4),&crc,sizeof(long));
				offset+=sizeof(pAdapter->trailer);

				/* Set the END of FRAME bit in the PT section of
				 * the ATM header of this CELL, 
				 * this will indicate to the remote side 
				 * that this CELL is the last */
				wpabs_set_bit(1,&((target_data_ptr+offset-49)[0]));
			}
			break;
		}
		i = i+48;
	}/* for */
	
	/* End of SAR:
	 * The tx packet / ATM PDU packet, has been cut up and all 
	 * ATM CELLS are located in target_data_ptr (Tx dma buffer). 
	 * We must now calculate the CRC and LENGTH of the 
	 * ATM PDU and store those values into the trailer of 
	 * the last ATM CELL */
	
	/* Set the size of the tx DMA buffer that contains all
	 * the ATM CELLS. The offset will be equal to 52*number
	 * of cells created */
	phy_descr->Buffer->Size = offset;

	/* Calculate the CRC of the ATM-PDU. 
	 * Starting with ATM-PDU protocol header, tx packet 
	 * and any pad bytes that were inserted to fill in 
	 * the ATM CELL up to the trailer */
	crc=INITIAL_FCS_VALUE;
	crc=update_crc(crc, pAdapter->prot_header, pAdapter->prot_header_size);
	crc=update_crc(crc, wpabs_skb_data(tx_skb), wpabs_skb_len(tx_skb));
	crc=update_crc(crc,
		       (pAdapter->pad_len_buf+(sizeof(pAdapter->pad_len_buf)-(pad+4))),
		       (pad+4));
	crc=~crc;
	FLIP_CRC(crc,fin_crc);

	/* Add the calculated CRC value into the trailer of the
	 * last ATM CELL */
	wpabs_memcpy((target_data_ptr+offset-4),&fin_crc,sizeof(long));

	/* If tracing is enabled store the packet for tracing */
	if (adsl_tracing_enabled(pAdapter->trace_info) >= 0){
		capture_trace_packet(pAdapter,	/*pLan->dev, */
				     tx_skb,
				     TRC_OUTGOING_FRM);
	}

	/* If the tx packet was an ATMARP, remember to reset
	 * the ATM-PDU header back to the IPoATM */
	if (pAdapter->EncapMode==RFC_MODE_ROUTED_IP_LLC &&
	    *((unsigned short *)wpabs_skb_data(tx_skb)) == ATMARP_HEADER){
		pAdapter->prot_header[7]=0x00;
	}

#if 0
	wpabs_debug_tx("ATM CELL TOTAL SiZE = %ld PAD=%d SBS=%d SPS=%d\n",
			phy_descr->Buffer->Size,
			/*ALEXphy_descr->Buffer->DmaData.length,*/
			pad, 
			src_data_size, 
			src_payload_size);
	wpabs_debug_tx("TX CELL 1: ");
	for (i=0; i < phy_descr->Buffer->Size; i++){
		if (i && !(i%52)){
			wpabs_debug_tx("\n");
			wpabs_debug_tx("\n");
			wpabs_debug_tx("TX CELL %03d:\n",(i/52)+1);
		}else{
			if (i && !(i%10)){
				wpabs_debug_tx("\n");
				wpabs_debug_tx("             ");
			}
		}
		wpabs_debug_tx("%02X ",*(target_data_ptr+i));
	}
	wpabs_debug_tx("\n");

#if 0
	wpabs_debug_tx("HOPEFULLY  CRC = %04lX ~CRC=%04lX\n",crc,~crc);
	

	crc=INITIAL_FCS_VALUE;
	crc = update_crc(crc,tmp_frame1,sizeof(tmp_frame1));
	wpabs_debug_event("ANOTHER  CRC = %04lX ~CRC=%04lX\n",crc,~crc);

	crc=INITIAL_FCS_VALUE;
	crc = update_crc(crc,pkt_data,(sizeof(pkt_data)-4));
	wpabs_debug_tx("ANOTHER KNOWN  CRC = %04lX ~CRC= %04lX\n",crc,~crc);
#endif
#endif

	/* Add packet statistics to the Tx DMA buffer, so we know
	 * how much actual data has been sent. Used by network
	 * device statistics (ifconfig) */
	((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length	= wpabs_skb_len(tx_skb);
	((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->chan	= NULL;


	/* If ATM CELL trace is enabled, trace all the ATM CELLS
	 * created in the TX DMA buffer */
	if (adsl_tracing_enabled(pAdapter->trace_info) == 2){
		capture_atm_trace_packet(pAdapter,	
					 (void*)target_data_ptr,
					 phy_descr->Buffer->Size,
			        	 TRC_OUTGOING_FRM);
	}


	/* Store the TX DMA buffer into the Tx Pending list 
	 * and start the TX DMA */
	adsl_card_lock_irq(pInstance,&flags);
	PHY_ADD_LIST(&(pPci->TxPendingList),phy_descr);	

	gsi_dma_tx_start(pAdapter);	

	adsl_card_unlock_irq(pInstance,&flags);


	pAdapter->tx_collisions=0;
	return NDIS_STATUS_SUCCESS;
#undef pLan
#undef pPci
#undef pAdapter
}


/***************************************************************************/
/* 			RFC2364 DECLARATIONS				   */ 	
/***************************************************************************/

BOOLEAN GpatmisRfc2364Initialize(
    PATM_USB_INSTANCE       Instance,
    ATM_PHY_BIND            PhyBind,
    ATM_PHY_DEVICE_HANDLE   PhyDeviceHandle
    )
{
	return 1;
}

void GpatmisRfc2364Shutdown(
    PATM_USB_INSTANCE       Instance
    )
{

	return;
}

NDIS_STATUS GpatmisRfc2364DeleteVc(
    PATM_USB_INSTANCE       Instance,
    UINT                    VPI,
    UINT                    VCI
    )
{
	return NDIS_STATUS_SUCCESS;
}

NDIS_STATUS GpatmisRfc2364CreateVc(
    PATM_USB_INSTANCE       Instance,
    UINT                    VPI,
    UINT                    VCI,
    NDIS_HANDLE		    NdisLinkContext
    )
{
	return NDIS_STATUS_SUCCESS;
}

/*------------------------------------------------------------------------------
//
// Function Declarations
//
//------------------------------------------------------------------------------
*/
BOOLEAN
GpatmisRfc1483Initialize(
    PATM_USB_INSTANCE       Instance,
    ATM_PHY_BIND            PhyBind,
    ATM_PHY_DEVICE_HANDLE   PhyDeviceHandle

)
{
	return 1;
}

void
GpatmisRfc1483Shutdown( PATM_USB_INSTANCE Instance)
{
	return;
}

BOOLEAN GpatmisIoctl(adapter_t *pAdapter, int cmd,
    struct gsi_req *arg, int *pResult)
{
	return 0;
}


void GpatmisStateDown(adapter_t *pAdapter)
{
	PCI_PHY *pPci = &(pAdapter->pciPhy);
	PHY_DESCR *phy_descr;
	unsigned long flags;


	ADSL_FUNC_DEBUG();
	
	if (pPci->State == PCI_PHY_STATE_HALTED){
		wpabs_debug_event("%s: GpatmisStateDown state already down!\n",
				pAdapter->devname);
		return;
	}

	adsl_card_lock_irq(pAdapter,&flags);
	
	if ((phy_descr=pPci->TxDescr) != NULL){
		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length=0;
		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->chan=NULL;
		phy_descr->Buffer->Size = 0;
	    	PHY_ADD_LIST(&(pPci->TxFreeList), phy_descr);
		
		pPci->TxDescr = NULL;
	}
	
	while (!IS_LIST_EMPTY(&pPci->TxCompleteList)){
		
		phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(&pPci->TxCompleteList);
		if (!phy_descr){
			continue;
		}
		
		NdisMSendComplete(pAdapter,
				  phy_descr->Buffer->AllocatorContext, 
				  NDIS_STATUS_SUCCESS);		

		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length=0;
		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->chan=NULL;
		phy_descr->Buffer->Size = 0;

		PHY_ADD_LIST(&(pPci->TxFreeList),phy_descr);

	}

	while (!IS_LIST_EMPTY(&pPci->TxPendingList)){
		
		phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(&pPci->TxPendingList);
		if (!phy_descr){
			continue;
		}

		NdisMSendComplete(pAdapter,
				  phy_descr->Buffer->AllocatorContext, 
				  NDIS_STATUS_FAILURE);		

		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->length=0;
		((pkt_info_t*)phy_descr->Buffer->AllocatorContext)->chan=NULL;
		phy_descr->Buffer->Size = 0;

		PHY_ADD_LIST(&(pPci->TxFreeList),phy_descr);

	}

	while (!IS_LIST_EMPTY(&pPci->RxCompleteList)){
		phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(&pPci->RxCompleteList);
		if (!phy_descr){
			continue;
		}
		
		phy_descr->Buffer->Data = NULL;
		phy_descr->Buffer->Size = 0;

		PHY_ADD_LIST(&(pPci->RxFreeList),phy_descr);		
	}


	adsl_card_unlock_irq(pAdapter,&flags);

}

#define MAX_ARP_SIZE  500
static int handle_atm_arp(adapter_t *pAdapter, void* rx_skb)
{		
	void*		tx_skb = NULL;
	char*		rx_data = wpabs_skb_data(rx_skb);
	atmarp_t*	atmarp = NULL;	
	atmarp_t	atmarp_reply;
	unsigned long 	local_ip;
	gsi_lan_t*	pLan = &(pAdapter->lan);


	if (pAdapter->config.interface == WAN_INTERFACE){
		return 0;
	}
	
	atmarp = (atmarp_t*)&rx_data[8];	
	if (atmarp->arphrd != ATMARP_HEADER){
		wpabs_debug_event("%s: Rx invalid arp pkt header 0x%X!\n",
				pAdapter->devname,atmarp->arphrd);
		return -EINVAL;
	}

	if (atmarp->arppro != ATMARP_PROT_IP){
		wpabs_debug_event("%s: Rx invalid arp pkt: protocol 0x%X not supported!\n",
				pAdapter->devname,atmarp->arppro);
		return -EINVAL;
	}

	switch (atmarp->arpop){

	case InARP_REQUEST:

		wpabs_debug_tx("%s: Rx InARP Request \n",
					pAdapter->devname);

		if (atmarp->arpshtl > sizeof(pAdapter->atm_addr)){
			wpabs_debug_event("%s: Rx invalid arp pkt: Source ATM address too big %d\n",
						pAdapter->devname,atmarp->arpshtl);
			return -EINVAL;
		}
		if (atmarp->arpsstl > sizeof(pAdapter->atm_addr)){
			wpabs_debug_event("%s: Rx invalid arp pkt: Source Sub ATM address too big %d\n",
						pAdapter->devname,atmarp->arpsstl);
			return -EINVAL;
		}

		if (atmarp->arpspln > 4){
			wpabs_debug_event("%s: Rx invalid arp pkt: Source IP ATM address too long %d\n",
						pAdapter->devname,atmarp->arpspln);
			return -EINVAL;
		}
			
		tx_skb = wpabs_skb_alloc(MAX_ARP_SIZE);
		if (!tx_skb){
			return -EINVAL;
		}
	
		atmarp_reply.arphrd 	= ATMARP_HEADER;
		atmarp_reply.arppro 	= ATMARP_PROT_IP;
		atmarp_reply.arpshtl	= sizeof(pAdapter->atm_addr);
		atmarp_reply.arpsstl	= 0;
		atmarp_reply.arpop  	= InARP_REPLY;
		atmarp_reply.arpspln	= 4;
		atmarp_reply.arpthtl	= atmarp->arpshtl;
		atmarp_reply.arptstl	= atmarp->arpsstl;
		atmarp_reply.arptpln	= atmarp->arpspln;
		wpabs_skb_copyback(tx_skb, 0, sizeof(atmarp_t), (unsigned long)&atmarp_reply);

		local_ip = wpabs_get_ip_addr(pLan->dev, WAN_LOCAL_IP);
		wpabs_debug_tx("Source ATM Len=%d, Sub Len=%d, IP Len=%d, %lx\n",
				atmarp->arpshtl, atmarp->arpsstl, atmarp->arpspln, local_ip);

		wpabs_skb_copyback(tx_skb, 
				 wpabs_skb_len(tx_skb), 
				 sizeof(pAdapter->atm_addr),
				 (unsigned long)pAdapter->atm_addr);

		wpabs_skb_copyback(tx_skb, 
				 wpabs_skb_len(tx_skb), 
				 sizeof(local_ip),
				 (unsigned long)&local_ip);

		if (atmarp->arpshtl){
			wpabs_skb_copyback(tx_skb, 
				 wpabs_skb_len(tx_skb), 
				 atmarp->arpshtl,
				 (unsigned long)(&rx_data[8]+sizeof(atmarp_t)));
		}

		if (atmarp->arpsstl){
			wpabs_skb_copyback(tx_skb, 
				 wpabs_skb_len(tx_skb), 
				 atmarp->arpsstl,
				 (unsigned long)(&rx_data[8]+sizeof(atmarp_t)+atmarp->arpshtl));
		}

		if (atmarp->arpspln){
			wpabs_skb_copyback(tx_skb, 
				 wpabs_skb_len(tx_skb), 
				 atmarp->arpshtl,
				 (unsigned long)(&rx_data[8]+sizeof(atmarp_t)+atmarp->arpshtl+atmarp->arpsstl));
		}

		/* Pad the outgoing ARP to 78 bytes */
		if (wpabs_skb_len(tx_skb) < 78){
			char* tx_data = wpabs_skb_put(tx_skb,78 - wpabs_skb_len(tx_skb));
			wpabs_memset(tx_data, 0, 78 - wpabs_skb_len(tx_skb));
		}	
		
		adsl_send(pAdapter, tx_skb, 0);

		wpabs_skb_free(tx_skb);	
		break;

	case InARP_REPLY:
	
		if (atmarp->arpspln != 0){
			unsigned long rmt_addr,remote_ip;
				
			rmt_addr= *(unsigned long*)(&rx_data[8]+sizeof(atmarp_t)+
				                 atmarp->arpshtl+atmarp->arpsstl);

			remote_ip = wpabs_get_ip_addr(pLan->dev, WAN_POINTOPOINT_IP);		

			if (rmt_addr != remote_ip){
				unsigned char ip1[25],ip2[25];
				wpabs_decode_ipaddr(rmt_addr,ip1);
				wpabs_decode_ipaddr(remote_ip,ip2);
				wpabs_debug_event("%s: Error Rx InARP Reply: Local P-to-P %s != Remote Src %s\n",
					pAdapter->devname,ip2,ip1);

				/* FIXME: Change the remote ip address automatically */
			}else{
				wpabs_debug_tx("%s: Rx InARP Reply OK\n",
					pAdapter->devname);
			}
		}else{
			wpabs_debug_event("%s: Error Rx InARP Reply: Remote Addr = 0.0.0.0\n",
					pAdapter->devname);
		}
		
		break;
	case ARP_NAK:
		wpabs_debug_event("%s: Rx ARP NAK\n",
					pAdapter->devname);
		break;

	case ARP_REQUEST:
		wpabs_debug_event("%s: Rx ARP Request \n",
					pAdapter->devname);
		break;
		
	case ARP_REPLY:
		wpabs_debug_event("%s: Rx ARP Reply \n",
					pAdapter->devname);
		break;

	default:
		wpabs_debug_event("%s: Rx Invalid arp pkt: Op Code 0x%x\n",
					pAdapter->devname,atmarp->arpop);
		return -EINVAL;
	}

	return 0;
}


static void* create_inarp_request(adapter_t *pAdapter)
{
	void*		tx_skb = NULL;
	atmarp_t	atmarp;	
	unsigned long 	local_ip;
	gsi_lan_t*	pLan = &(pAdapter->lan);
	unsigned int 	len;
	unsigned char*  tx_data;
	

	tx_skb = wpabs_skb_alloc(MAX_ARP_SIZE);
	if (!tx_skb){
		return NULL;
	}
	
	atmarp.arphrd 	= ATMARP_HEADER;
	atmarp.arppro 	= ATMARP_PROT_IP;
	atmarp.arpshtl	= sizeof(pAdapter->atm_addr);
	atmarp.arpsstl	= 0;
	atmarp.arpop  	= InARP_REQUEST;
	atmarp.arpspln	= 4;
	atmarp.arpthtl	= 0;
	atmarp.arptstl	= 0;
	atmarp.arptpln	= 0;
	
	wpabs_skb_copyback(tx_skb, 0, sizeof(atmarp_t), (unsigned long)&atmarp);

	local_ip = wpabs_get_ip_addr(pLan->dev, WAN_LOCAL_IP);

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 sizeof(pAdapter->atm_addr),
			 (unsigned long)pAdapter->atm_addr);

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 sizeof(local_ip),
			 (unsigned long)&local_ip);

	if ((len=wpabs_skb_len(tx_skb)) < 78){
		len=78-len;
		tx_data = wpabs_skb_put(tx_skb,len);
		wpabs_memset(tx_data, 0, len);
	}	


	return tx_skb;
}

#if 0
static void* create_ethernet_arp_request(adapter_t *pAdapter)
{
	void*		tx_skb = NULL;
	arphdr_t	arp;	
	unsigned long 	local_ip,broadcast_ip;
	gsi_lan_t*	pLan = &(pAdapter->lan);
	unsigned char*  tx_data;
	unsigned char   eth_dest[]={0xff,0xff,0xff,0xff,0xff};
	unsigned char   arp_type[]={0x08,0x06};

	tx_skb = wpabs_skb_alloc(MAX_ARP_SIZE);
	if (!tx_skb){
		return NULL;
	}
	
	arp.ar_hrd 	= 0x0001;
	arp.ar_pro 	= 0x0800;
	arp.ar_hln	= 6;
	arp.ar_pln	= 4;
	arp.ar_op  	= ARP_REQUEST;

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 6,
			 (unsigned long)&eth_dest[0]);

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 6,
			 (unsigned long)&pAdapter->macAddr[0]);

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 2,
			 (unsigned long)&arp_type[0]);
	
	wpabs_skb_copyback(tx_skb, wpabs_skb_len(tx_skb), 
			  sizeof(arphdr_t), (unsigned long)&arp);

	local_ip = wpabs_get_ip_addr(pLan->dev, WAN_LOCAL_IP);

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 6,
			 (unsigned long)&pAdapter->macAddr[0]);

	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 sizeof(local_ip),
			 (unsigned long)&local_ip);

	tx_data = wpabs_skb_put(tx_skb,6);
	wpabs_memset(tx_data, 0, 6);

	broadcast_ip = wpabs_get_ip_addr(pLan->dev, WAN_BROADCAST_IP);
	wpabs_skb_copyback(tx_skb, 
			 wpabs_skb_len(tx_skb), 
			 sizeof(local_ip),
			 (unsigned long)&broadcast_ip);

#if 0
	if ((len=wpabs_skb_len(tx_skb)) < 78){
		len=78-len;
		tx_data = wpabs_skb_put(tx_skb,len);
		wpabs_memset(tx_data, 0, len);
	}	
#endif

	return tx_skb;
}
#endif

/*===============================================================
 * adsl_arp_check
 * 
 * Called by GpMonitorTransceiver every 
 * GSI_CHECK_TRAIN_TIMEOUT seconds.  
 *
 * For Classical IP over ATM ONLY !!!
 * After 10 seconds we should send another
 * InARP request.
 * 
 * For all other protocols encapsulations
 * return and do nothing.
 *
 */
void adsl_arp_check (adapter_t *pAdapter)
{
	if (pAdapter->config.interface == WAN_INTERFACE){
		return;
	}

	if (wpabs_test_bit(0, &pAdapter->atm_autocfg_running)){
		return;
	}

	if (wpabs_get_state(pAdapter->card) != WAN_CONNECTED){
		pAdapter->arp_timeout=10;
		return;
	}
	
	if (pAdapter->EncapMode != RFC_MODE_ROUTED_IP_LLC){
		return;
	}
	
	pAdapter->arp_timeout ++;

	if ((pAdapter->arp_timeout*GSI_CHECK_TRAIN_TIMEOUT) >= 10){
		void *tx_skb=NULL;
		
		wpabs_debug_tx("%s: Sending out InARP Request \n",
				pAdapter->devname);	

		tx_skb=create_inarp_request(pAdapter);
		if (tx_skb){
			adsl_send(pAdapter, tx_skb, 0);
			wpabs_skb_free(tx_skb);
		}
		
		pAdapter->arp_timeout=0;
	}
	return; 
}



static int parse_prot_header(adapter_t *pAdapter, void* rx_skb)
{
	unsigned char* data = (unsigned char*)wpabs_skb_data(rx_skb);
	int len = wpabs_skb_len(rx_skb);
	int err=0;
	
	switch (pAdapter->EncapMode){
			
		case RFC_MODE_ROUTED_IP_LLC:
			if (data[6] == 0x08){
				if (data[7] == 0x06){
					wpabs_debug_rx("%s: RX ARP packet, sending reply...\n",
								pAdapter->devname);
					/*handle_atm_arp(pAdapter, rx_data, rx_len);	*/
					handle_atm_arp(pAdapter, rx_skb);	
					/* We don't want to send this rx packet 
					 * up the stack, since we just replied to the
					 * arp. We should kill this packet thus, we return -1 */
					return -1;
				}
			}else{
				char temp[200];

				err=wpabs_detect_prot_header(data, len, temp);
				if (err == 0){
					wpabs_debug_event("%s: Rx Pkt with invalid protocol header!\n",
							pAdapter->devname);
					wpabs_debug_event("%s: Not LLC IP/ATM: Detected as: %s!\n",
							pAdapter->devname, 
							temp);
				}
				return -EINVAL;
			}
			break;

		case RFC_MODE_ROUTED_IP_VC:
			if (data[0] != 0x45){
				char temp[200];

				err=wpabs_detect_prot_header(data, len, temp);
				if (err==0){
					wpabs_debug_event("%s: Rx Pkt with invalid protocol header!\n",
							pAdapter->devname);
					wpabs_debug_event("%s: Not VC IP/ATM: Detected as: %s!\n",
							pAdapter->devname, 
							temp);
				}
				return -EINVAL;
			}
			break;
			
		case RFC_MODE_BRIDGED_ETH_LLC:
			if (data[6] != 0x00 || data[7] != 0x07){
				char temp[200];
				err=wpabs_detect_prot_header(data, len, temp);
				if (err == 0){
					wpabs_debug_event("%s: Rx Pkt with invalid protocol header!\n",
							pAdapter->devname);
					wpabs_debug_event("%s: Not Bridged LLC/ATM: Detected as: %s\n",
							pAdapter->devname,
							temp);
				}
				return -EINVAL;
			}
			break;

		case RFC_MODE_BRIDGED_ETH_VC:
			err = wpabs_detect_prot_header(data, len, NULL);
			if (err == 0){
				char temp[200];
				err = wpabs_detect_prot_header(data, len, temp);
				wpabs_debug_event("%s: Rx Pkt with invalid protocol header!\n",
						pAdapter->devname);
				wpabs_debug_event("%s: Not Bridged VC/ATM: Detected as: %s\n",
						pAdapter->devname,
						temp);
			}
			break;

		case RFC_MODE_PPP_LLC:

			if (data[0] == 0xFE && data[1] == 0xFE){
				if (pAdapter->prot_header_size != 4){
					wpabs_debug_event("%s: PPP LLC Header Transition to 4 bytes\n",pAdapter->devname);
					pAdapter->prot_header[0]=0xFE;
					pAdapter->prot_header[1]=0xFE;
					pAdapter->prot_header[2]=0x03;
					pAdapter->prot_header[3]=0xCF;
					pAdapter->prot_header_size=4;
				}
	
			}else if (data[0] == 0xFE && data[1] == 0x03){
				if (pAdapter->prot_header_size != 3){
					wpabs_debug_event("%s: PPP LLC Header Transition to 3 bytes\n",pAdapter->devname);

					pAdapter->prot_header[0]=0xFE;
					pAdapter->prot_header[1]=0x03;
					pAdapter->prot_header[2]=0xCF;
					pAdapter->prot_header_size=3;
				}
				
			}else{
				char temp[200];
				err=wpabs_detect_prot_header(data, len, temp);
				if (err==0){
					wpabs_debug_event("%s: Rx Pkt with invalid protocol header!\n",
						pAdapter->devname);
					wpabs_debug_event("%s: Not LLC PPP/ATM: Detected as: %s!\n",
						pAdapter->devname, temp);
				}
				return -EINVAL;
			}
			break;

		case RFC_MODE_PPP_VC:
			if (data[0] == 0xC0 && data[1] == 0x21){
				return 0;
			}else if (data[0] == 0x00 && data[1] == 0x21){
				return 0;
			}else{
				err = wpabs_detect_prot_header(data, len, NULL);
				if (err == 0){
					char temp[200];
					err = wpabs_detect_prot_header(data, len, temp);
					wpabs_debug_event("%s: Rx Pkt with invalid protocol header!\n",
							pAdapter->devname);
					wpabs_debug_event("%s: Not VC PPP/ATM: Detected as: %s\n",
							pAdapter->devname,
							temp);
				}
			}
			break;

		default:
			/* This will never happen, just for completeness sake */
			wpabs_debug_event("%s:Rx Configuration error, unkown mode 0x%x\n",
					pAdapter->devname,pAdapter->EncapMode);
			return -EINVAL;
	}
	
	return 0;
}


static int 
capture_atm_trace_packet(
		adapter_t*	pAdapter,
		void 		*data,
		int		len,
		char		direction)
{
	int atm_packets=0;
	int i;
	wan_trace_pkt_t trc_el;		
	volatile GP_CELL *atm_cell_ptr=(GP_CELL*)data;
	void *new_skb=NULL;
	
	if (adsl_tracing_enabled(pAdapter->trace_info) != 2){
		return 0;
	}

	atm_packets = len/sizeof(GP_CELL);

	if (atm_packets <= 0){
		return -EINVAL;
	}
	
	for (i=0;i<atm_packets;i++){

		new_skb = wpabs_skb_alloc(sizeof(GP_CELL)+sizeof(wan_trace_pkt_t));
		if (new_skb == NULL) 
			return -ENOMEM;
		
		trc_el.status		= direction;
		trc_el.data_avail	= 1;
		trc_el.time_stamp	= (unsigned short)(wpabs_get_systemticks() % 0xFFFF);
		trc_el.real_length	= sizeof(GP_CELL);
	
		wpabs_skb_copyback(new_skb, 
				  wpabs_skb_len(new_skb), 
				  sizeof(wan_trace_pkt_t), 
				  (unsigned long)&trc_el);

		wpabs_skb_copyback(new_skb, 
				  wpabs_skb_len(new_skb), 
				  sizeof(GP_CELL),
				  (unsigned long)atm_cell_ptr);

		adsl_trace_enqueue(pAdapter->trace_info, new_skb);

		atm_cell_ptr++;
	}

	return 0;
}

static int 
capture_trace_packet(
		adapter_t*	pAdapter,
		void*		skb,
		char		direction)
{
	int		len = 0;
	void*		new_skb = NULL;
	wan_trace_pkt_t trc_el;	
	int		flag = 0;
	
	if ((flag = adsl_tracing_enabled(pAdapter->trace_info)) >= 0){

		if (flag > 1){
			return 0;
		}
			
		/* Allocate a header mbuf */
		len = 	wpabs_skb_len(skb) +  
			sizeof(wan_trace_pkt_t);

		if (!flag && direction == TRC_INCOMING_FRM){
			if ((wpabs_skb_len(skb) - pAdapter->prot_header_size) <= 0){
				return -EINVAL;
			}
			len -= pAdapter->prot_header_size;
		}

		new_skb = wpabs_skb_alloc(len+pAdapter->prot_header_size);
		if (new_skb == NULL) return -ENOMEM;

		trc_el.status		= direction;
		trc_el.data_avail	= 1;
		trc_el.time_stamp	= (unsigned short)(wpabs_get_systemticks() % 0xFFFF);
		trc_el.real_length	= wpabs_skb_len(skb);
		
		if (direction == TRC_OUTGOING_FRM){
			if (!flag){

				wpabs_skb_copyback(new_skb, 
					  wpabs_skb_len(new_skb), 
				   	  sizeof(wan_trace_pkt_t), 
					  (unsigned long)&trc_el);
	
				wpabs_skb_copyback(new_skb, 
					  wpabs_skb_len(new_skb), 
					  wpabs_skb_len(skb),
					  (unsigned long)wpabs_skb_data(skb));
			}else{
				trc_el.real_length += pAdapter->prot_header_size;

				wpabs_skb_copyback(new_skb, 
				  	wpabs_skb_len(new_skb), 
			   	  	sizeof(wan_trace_pkt_t), 
				  	(unsigned long)&trc_el);

				
				if (pAdapter->prot_header_size){
					wpabs_skb_copyback(new_skb, 
						wpabs_skb_len(new_skb), 
					  	pAdapter->prot_header_size,
					  	(unsigned long)pAdapter->prot_header);
				}
				
				wpabs_skb_copyback(new_skb, 
					  	  wpabs_skb_len(new_skb), 
					  	  wpabs_skb_len(skb),
					  	  (unsigned long)wpabs_skb_data(skb));
			}
		}else{
			if (!flag){
				trc_el.real_length -= pAdapter->prot_header_size;

				wpabs_skb_copyback(new_skb, 
					  wpabs_skb_len(new_skb), 
				   	  sizeof(wan_trace_pkt_t), 
					  (unsigned long)&trc_el);

				wpabs_skb_copyback(new_skb, 
					  wpabs_skb_len(new_skb), 
					  wpabs_skb_len(skb)-pAdapter->prot_header_size,
					  (unsigned long)wpabs_skb_data(skb)+pAdapter->prot_header_size);
			}else{
			
				wpabs_skb_copyback(new_skb, 
					  wpabs_skb_len(new_skb), 
				   	  sizeof(wan_trace_pkt_t), 
					  (unsigned long)&trc_el);

				
				wpabs_skb_copyback(new_skb, 
					  wpabs_skb_len(new_skb), 
					  wpabs_skb_len(skb),
					  (unsigned long)wpabs_skb_data(skb));
			}
		}
		
		adsl_trace_enqueue(pAdapter->trace_info, new_skb);
	}

	return 0;
}

#define OAM_F5_END_TO_END_CELL 	0x05
#define OAM_F5_SEGMENT 		0x04

/* OAM Types */
#define OAM_FAULT_MGMT		0x01
#define OAM_PERF_MGMT		0x02
#define OAM_ACT_DEACT		0x80

/* OAM Function Types */
#define OAM_FAULT_FUNC_ALARM_INDIC	0x00
#define OAM_FAULT_FUNC_FERF		0x01
#define OAM_FAULT_FUNC_CELL_LOOPBACK	0x08
#define OAM_FAULT_FUNC_CONTINUITY	0x04

#define OAM_PERF_FUNC_FW_MONITOR	0x00
#define OAM_PERF_FUNC_BW_REPORT		0x01
#define OAM_PERF_FUNC_MON_REPORT	0x02

#define OAM_AD_FUNC_PERF_MONITOR	0x00
#define OAM_AD_FUNC_CONTINUITY		0x01

#define OAM_CELL_LOOPBACK 		0x18
#define OAM_LOOPBACK_INDICATION 	0x01
#define ATM_PAYLOAD_SZ 			48

void handle_atm_admin_packet(adapter_t *pAdapter, void *data)
{
	volatile GP_CELL *atm_cell_ptr=(GP_CELL*)data;
	unsigned char oam_type, oam_func;
	unsigned char pt = (atm_cell_ptr->hdr[3] >> 1) & 0x07;
	
	unsigned short vpi=((atm_cell_ptr->hdr[0]<<4)|
		            ((atm_cell_ptr->hdr[1]&0xF0)>>4));

 	unsigned short vci=(((atm_cell_ptr->hdr[1]&0x0F)<<12)|
	 		    (atm_cell_ptr->hdr[2]<<4)|
			    ((atm_cell_ptr->hdr[3]&0xF0)>>4));

	if (pAdapter->Vpi != vpi){
		wpabs_debug_event("%s: Rx invalid ATM Mgmt Cell: Vpi Mismatch Cfg Vpi=%d In Vpi=%d\n",
				pAdapter->devname,pAdapter->Vpi,vpi);
#if 0
		{
			int i;
			unsigned char *pkt=(unsigned char*)data;
			
			for (i=0;i<sizeof(GP_CELL);i++){
				wpabs_debug_event("%02x ",pkt[i]);
			}

			wpabs_debug_event("\n");
		}
#endif
		return;
	}

	if ((pt == OAM_F5_END_TO_END_CELL || pt == OAM_F5_SEGMENT) && pAdapter->Vci == vci){
		goto oam_f5_packet;
		
	}else if (pAdapter->Vci == 3 || pAdapter->Vci == 4){
		goto oam_f4_packet;

	}else{
		wpabs_debug_event("%s: Rx invalid ATM Mgmt Cell: Vpi=%d Vci=%d Pt=0x%x\n",
				pAdapter->devname,vpi,vci,pt);
		return;
	}

oam_f4_packet:
oam_f5_packet:

	oam_type = (atm_cell_ptr->info[0] >> 4) & 0x0F;
	oam_func = atm_cell_ptr->info[0] & 0x0F;

	switch (oam_type){

	case OAM_FAULT_MGMT:

		switch (oam_func){
			
			case OAM_FAULT_FUNC_CELL_LOOPBACK:
				handle_oam_cell_loopback(pAdapter,(void*)atm_cell_ptr);
				break;
				
			case OAM_FAULT_FUNC_ALARM_INDIC:
			case OAM_FAULT_FUNC_FERF:	
			case OAM_FAULT_FUNC_CONTINUITY:
			default:
				wpabs_debug_event("%s: Rx Invalid ATM OAM Fault Mgmt Cell: Type=0x%x Func=0x%x\n",
						pAdapter->devname,oam_type,oam_func);
				break;
		}
		break;	
	
	case OAM_PERF_MGMT:
		wpabs_debug_event("%s: Rx unsupported ATM OAM Perf Mgmt Cell: Type=0x%x Func=0x%x\n",
						pAdapter->devname,oam_type,oam_func);
		break;

	case OAM_ACT_DEACT:
		wpabs_debug_event("%s: Rx unsupported ATM OAM Act/Deact Cell: Type=0x%x Func=0x%x\n",
						pAdapter->devname,oam_type,oam_func);
		break;
		
	default:
		wpabs_debug_event("%s: Rx unsupported ATM OAM Cell: Type=0x%x Func=0x%x\n",
						pAdapter->devname,oam_type,oam_func);
		
		break;
	}
	
}


void handle_oam_cell_loopback(adapter_t *pAdapter, void *data)
{
	int i;
	volatile GP_CELL *atm_cell_ptr=(GP_CELL*)data;
	PCI_PHY *pPci = &(pAdapter->pciPhy);
	PHY_DESCR *phy_descr;
	unsigned char *tx_data_ptr;
	volatile unsigned short crc10_accum=0;
	unsigned long flags;


	if (atm_cell_ptr->info[1] != OAM_LOOPBACK_INDICATION){

		/* Got the OAM Loopback Reply */
		wpabs_debug_tx("%s: Rx Invalid ATM OAM Loopback Cell: Not Loobpack Request 0x%x\n",
				pAdapter->devname,atm_cell_ptr->info[1]);

		/* Is this a reply to the send OAM Request,
		 * if it is then process the watchdog logic */
		if (pAdapter->atm_check){

			/* Received a single OAM Loopback reply. This means
			 * that the remote side supports OAM loopbacks. Thus
			 * enable watchdog :) */
			if (pAdapter->atm_watchdog == 0){
				pAdapter->atm_watchdog=1;
			}

			/* Clear the atm watchdog check counter. 
			 * If this counter goes over the limit, the
			 * line will be retrained */
			pAdapter->atm_check=0;
		}
		return;
	}
	
	/* Clear the OAM F5 Loopback request, thus
	 * indicating a reply */
	atm_cell_ptr->info[1]=0x00;

	if (IS_LIST_EMPTY(&(pPci->TxFreeList))){
		/* If tx list is empty, silently discart the
		 * received packet, and wait for another one */
		return;
	}
	
	phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(&(pPci->TxFreeList));
	if (!phy_descr){
		/* If tx list is empty, silently discart the
		 * received packet, and wait for another one */
		return;
	}

	phy_descr->Buffer->Size=sizeof(GP_CELL);
	tx_data_ptr=(unsigned char *)phy_descr->Buffer->Data;
	wpabs_memcpy(tx_data_ptr,(unsigned char*)atm_cell_ptr,sizeof(GP_CELL));

	/* Clear the old CRC values */
	tx_data_ptr[4+ATM_PAYLOAD_SZ-2]=0;
	tx_data_ptr[4+ATM_PAYLOAD_SZ-1]=0;

	for ( i = 0;  i < ATM_PAYLOAD_SZ; i++ ){
        	crc10_accum = ((crc10_accum << 8) & 0x3ff)
                	       ^ byte_crc10_table[( crc10_accum >> 2) & 0xff]
                               ^ *((unsigned char *)(tx_data_ptr+4+i));
    	}

	tx_data_ptr[4+ATM_PAYLOAD_SZ-2] = (crc10_accum >> 8);
	tx_data_ptr[4+ATM_PAYLOAD_SZ-1] = (crc10_accum & 0xff);

	if (adsl_tracing_enabled(pAdapter->trace_info) == 2){
		capture_atm_trace_packet(pAdapter,	
					 (void*)tx_data_ptr,
					 phy_descr->Buffer->Size,
			        	 TRC_OUTGOING_FRM);
	}

	adsl_card_lock_irq(pAdapter,&flags);

	PHY_ADD_LIST(&(pPci->TxPendingList),phy_descr);	
	gsi_dma_tx_start(pAdapter);	

	adsl_card_unlock_irq(pAdapter,&flags);
	
}

/*===============================================================
 * adsl_tx_oam_loopback_packet
 * 
 * Called by GpMonitorTransceiver every 
 * GSI_CHECK_TRAIN_TIMEOUT seconds.  
 *
 * For Classical IP over ATM ONLY !!!
 * After 10 seconds we should send another
 * InARP request.
 * 
 * For all other protocols encapsulations
 * return and do nothing.
 *
 */

int adsl_tx_oam_loopback_packet(adapter_t *pAdapter)
{
	PCI_PHY *pPci = &(pAdapter->pciPhy);
	PHY_DESCR *phy_descr;
	unsigned char *tx_data_ptr;
	volatile unsigned short crc10_accum=0;
	int i;
	unsigned long flags;

	if (pAdapter->atm_autocfg){
		return 1;
	}	
	
	pAdapter->atm_timeout++;
	
	if ((pAdapter->atm_timeout*GSI_CHECK_TRAIN_TIMEOUT) < 10){
		return 1;
	}

	wpabs_debug_tx("%s: Sending out OAM Loopback %d\n",
			pAdapter->devname,pAdapter->atm_timeout);

			
	phy_descr= (PHY_DESCR*)PHY_REMOVE_LIST(&(pPci->TxFreeList));
	if (!phy_descr){
		/* If tx list is empty, silently discart the
		 * received packet, and wait for another one */
		return -1;
	}

	phy_descr->Buffer->Size=sizeof(GP_CELL);
	tx_data_ptr=(unsigned char *)phy_descr->Buffer->Data;
	wpabs_memcpy(tx_data_ptr,(unsigned char*)atm_oam_req,sizeof(GP_CELL));
	wpabs_memcpy(tx_data_ptr,pAdapter->atm_header,sizeof(pAdapter->atm_header));

	tx_data_ptr[3] |= 0x0A;
	
	/* Clear the old CRC values */
	tx_data_ptr[4+ATM_PAYLOAD_SZ-2]=0;
	tx_data_ptr[4+ATM_PAYLOAD_SZ-1]=0;

	for (i = 0;  i<ATM_PAYLOAD_SZ; i++){
        	crc10_accum = ((crc10_accum << 8) & 0x3ff)
                	       ^ byte_crc10_table[(crc10_accum >> 2) & 0xff]
                               ^ tx_data_ptr[4+i];
    	}

	tx_data_ptr[4+ATM_PAYLOAD_SZ-2] = (crc10_accum >> 8);
	tx_data_ptr[4+ATM_PAYLOAD_SZ-1] = (crc10_accum & 0xff);

	if (adsl_tracing_enabled(pAdapter->trace_info) == 2){
		capture_atm_trace_packet(pAdapter,	
					 (void*)tx_data_ptr,
					 phy_descr->Buffer->Size,
			        	 TRC_OUTGOING_FRM);
	}

	adsl_card_lock_irq(pAdapter,&flags);

	PHY_ADD_LIST(&(pPci->TxPendingList),phy_descr);	

	gsi_dma_tx_start(pAdapter);	

	adsl_card_unlock_irq(pAdapter,&flags);

	
	pAdapter->atm_timeout=0;
	pAdapter->atm_check++;

	return 0;
}

