#!/bin/sh

HOME=`pwd`
ARCH_LIST="i686 i586 i486 i386"

eval "gcc --version | grep \"^2\" > /dev/null"
if [ $? -eq 0 ]; then
	gcc_ver=2;
else
	gcc_ver=3;
fi

cd adsl
if [ -d adsl_bin ]; then
	rm -rf adsl_bin/*.o
else
	mkdir adsl_bin
fi


for arch in $ARCH_LIST; do
	echo "Compiling ADSL on gcc$gcc_ver for $arch"
	make clean > /dev/null
	make ARCH=$arch > /dev/null
	mv wanpipe_adsl.o adsl_bin/wanpipe_adsl.gcc$gcc_ver.$arch.o
done


