
#ifndef __AFT_LOG_H
# define __AFT_LOG_H

/*
******************************************************************************
**			INCLUDES	FILES				
******************************************************************************
*/



/*
******************************************************************************
**			DEFINES/MACROS				
*****************************************************************************
*/
#define AFT_VERBOSE_NONE	0x00
#define AFT_VERBOSE_SCRIPT	0x01
#define AFT_VERBOSE_SOCKET	0x02
#define AFT_VERBOSE_HWPROBE	0x04
#define AFT_VERBOSE_PROC	0x08
#define AFT_VERBOSE_TEST	0x10
#define AFT_VERBOSE_FLASH	0x20

#define AFT_LOG_INFO	1
#define AFT_LOG_ERR	2
#define AFT_LOG_FILE	3

#define aft_script_log	if (verbose & AFT_VERBOSE_SCRIPT) aft_log
#define aft_socket_log	if (verbose & AFT_VERBOSE_SOCKET) aft_log
#define aft_hwprobe_log	if (verbose & AFT_VERBOSE_HWPROBE) aft_log
#define aft_proc_log	if (verbose & AFT_VERBOSE_PROC) aft_log
#define aft_test_log	if (verbose & AFT_VERBOSE_TEST) aft_log
#define aft_flash_log	if (verbose & AFT_VERBOSE_FLASH) aft_log

/*
******************************************************************************
**			VARIABLES				
*****************************************************************************
*/

/*
******************************************************************************
**			FUNCTION PROTOTYPES				
*****************************************************************************
*/


extern int aft_log_init(char*);
extern void aft_log(int type, const char * fmt, ...);



#endif  /* __AFT_LOG_H */
