#!/bin/sh

HOME=`pwd`
ARCH_LIST="i686 i586 i486 i386"

eval "gcc --version | grep \"^2\" > /dev/null"
if [ $? -eq 0 ]; then
	gcc_ver=2;
else
	gcc_ver=3;
fi

cd fr
if [ -d fr_bin ]; then
	rm -rf fr_bin/*.o
else
	mkdir fr_bin
fi



for arch in $ARCH_LIST; do
	echo "Compiling fr on gcc$gcc_ver for $arch"
	make clean > /dev/null
	make ARCH=$arch #> /dev/null
	mv wanpipe_fr.o fr_bin/wanpipe_fr.gcc$gcc_ver.$arch.o
done

echo "Done"
