#!/bin/sh


create_link()
{
	local linkto=$MAKEFILE.${KERNEL_NAME}

	cd $1
	if [ -f $MAKEFILE ]; then
		\rm -rf $MAKEFILE
	fi
	if [ ! -f $linkto ]; then
		if [ "$KERNEL_NAME" = "FreeBSD" -o "$KERNEL_NAME" = "OpenBSD" ]; then
			if [ -f ${MAKEFILE}.BSD ]; then
				linkto=${MAKEFILE}.BSD
			elif [ -f ${MAKEFILE}${OSYSTEM_MAJOR_VER}.${KERNEL_NAME} ]; then
				linkto=${MAKEFILE}${OSYSTEM_MAJOR_VER}.${KERNEL_NAME}
			else
				echo "Can't create link in $1 directory!"
				exit 1
			fi
			
		fi
	fi
	ln -s $linkto $MAKEFILE
	cd ${HOME_DIR}
}


HOME_DIR=`pwd`
KERNEL_NAME=`uname -s`
MAKEFILE=Makefile
GENERIC_UTIL_DIR=util
OSYSTEM_VER=`uname -m`
OSYSTEM_MAJOR_VER=${OSYSTEM_VER%%.*}

echo -n "Creating Makefile links...."

create_link .
create_link ${GENERIC_UTIL_DIR}
create_link ${GENERIC_UTIL_DIR}/wanhdlc
create_link ${GENERIC_UTIL_DIR}/wanutil
create_link ${GENERIC_UTIL_DIR}/sdladump

echo "DONE!"
