// statvar.c


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>


unsigned long filesize (FILE* file)
{
	unsigned long size = 0;
	unsigned long cur_pos;

	cur_pos = ftell(file);
	if ((cur_pos != -1L) && !fseek(file, 0, SEEK_END)) {
		size = ftell(file);
		fseek(file, cur_pos, SEEK_SET);
	}
	return size;
}

int main(int argc, char *argv[])
{
	unsigned long i, fsize;
	FILE *fin, *fout;
	unsigned char c;
	
	if (argc != 4) {
		printf("usage: statvar <bin_in_file> <c_out_file> <var_name>\n");
		printf("i.g. : statvar code.502 cod502.c z80_code\n");
		exit(0);
	}
	fin = fopen(argv[1], "r");
	fsize = filesize(fin);
	//handle = open(argv[1], O_RDONLY | O_BINARY);
	fout = fopen(argv[2], "w");
	if (fin == NULL || fout == NULL) {
		printf("file(s) could not be opened.\n");
		exit(0);
	}
	fprintf(fout, "\nunsigned char %s[] = {", argv[3]);
	i=0;
	while (!feof(fin)) {
		if (fread(&c, 1, 1, fin)){
			if (i > 0) fprintf(fout, ", ");
			if ((i%8)==0) fprintf(fout, "\n");
			fprintf(fout, "0x%02X", c);
			i++;
		}
	}
	fprintf(fout, "\n};\n");
	fprintf(fout, "\nunsigned %s_len = %ld;\n", 
			argv[3], fsize);
	printf("statvar: %ld bytes imported.\n", fsize);
	fclose(fout);
	fclose(fin);
	return 0;
}

