/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Wed Feb 25 16:17:53 EST 2004
    copyright            : (C) 2004 by David Rokhvarg
    email                : davidr@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define DBG_WANCFG_MAIN 1

#include "wancfg.h"
#include "input_box_active_channels.h"
#include "menu_base.h"
#include "dialog_yes_no.h"
#include "text_box.h"
#include "text_box_yes_no.h"

#include "menu_main_configuration_options.h"
#include "text_box_help.h"

#include "conf_file_reader.h"

#include "list_element_chan_def.h"
#include "objects_list.h"

#include "conf_file_writer.h"
extern key_word_t common_conftab[];

//globals
char * lxdialog_path = "/usr/sbin/wanpipe_lxdialog";
char * wanpipe_cfg_dir = "/etc/wanpipe/";
char * wancfg_cfg_dir = "/etc/wanpipe/wancfg_templates/";
char * start_stop_scripts_dir = "scripts";

char * interfaces_cfg_dir = "/etc/wanpipe/interfaces/";

////////////////////////////////////////////////////////////
//help messages
//indicates error.
char* invalid_help_str =
"Invalid Selection!!!\n"
"--------------------\n";

char* option_not_implemented_yet_help_str =
"Selected option not implemented yet.\n";


//Frame Relay
char* fr_cir_help_str =
"  Frame Relay: Committed Information Rate (CIR)\n"
"  ---------------------------------------------\n"
"  \n"
"  Enable or Disable Committed Information Rate\n"
"  on the board.\n"
"  Valid values: 1 - 512 kbps.\n"
"  \n"
"  Default: Disabled";


////////////////////////////////////////////////
//globals from wanconfig.c
char prognamed[20] =	"wancfg";//"wanconfig";
char progname_sp[] = 	"         ";
char def_conf_file[] =	"/etc/wanpipe/wanpipe1.conf";	/* default name */
char def_adsl_file[] =	"/etc/wanpipe/wan_adsl.list";	/* default name */
char tmp_adsl_file[] =	"/etc/wanpipe/wan_adsl.tmp";	/* default name */
#if defined(__LINUX__)
char router_dir[] =	"/proc/net/wanrouter";	/* location of WAN devices */
#else
char router_dir[] =	"/var/lock/wanrouter";	/* location of WAN devices */
#endif

char banner[] =		"WAN Router Configurator"
			"(c) 1995-2003 Sangoma Technologies Inc."
;

char *krnl_log_file = "/var/log/messages";
char *verbose_log = "/var/log/wanrouter";
///////////////////////////////////////////////

int active_channels_str_invalid_characters_check(char* active_ch_str);

///////////////////////////////////////////////

//convert int definition of a protocol to string
char * get_protocol_string(int protocol)
{
  volatile static char protocol_name[MAX_PATH_LENGTH];

  switch(protocol)
  {
  case PROTOCOL_NOT_SET:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Not Set");
    break;

  case NO_PROTOCOL_NEEDED:
    //special case, when no protocol name actually needed
    protocol_name[0] = '\0';
    break;

  case WANCONFIG_X25:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "X25");
    break;

  case WANCONFIG_FR:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Frame Relay");
    break;

  case WANCONFIG_PPP:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "PPP");
    break;

  case WANCONFIG_CHDLC:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "CHDLC");
    break;

  case WANCONFIG_BSC:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "BiSync Streaming");
    break;

  case WANCONFIG_HDLC:
    //used with CHDLC firmware
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "HDLC Streaming");
    break;

  case WANCONFIG_MPPP://and WANCONFIG_MPROT too
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Multi Port PPP");
    break;

  case WANCONFIG_BITSTRM:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Bit Stream");
    break;

  case WANCONFIG_EDUKIT:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Educational Kit");
    break;

  case WANCONFIG_SS7:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "SS7");
    break;

  case WANCONFIG_BSCSTRM:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Bisync Streaming Nasdaq");
    break;

  case WANCONFIG_MFR:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Multi-Port Frame Relay");
    break;

  case WANCONFIG_ADSL:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "LLC Ethernet Support (ADSL)");
    break;

  case WANCONFIG_SDLC:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "SDLC");
    break;

  case WANCONFIG_ATM:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "ATM");
    break;

  case WANCONFIG_POS:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Point-of-Sale");
    break;

  case WANCONFIG_AFT:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "AFT");
    break;

  case WANCONFIG_DEBUG:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Real Time Debugging");
    break;

  case WANCONFIG_ADCCP:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Special HDLC LAPB");
    break;

  case WANCONFIG_MLINK_PPP:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Multi-Link PPP");
    break;

  case WANCONFIG_GENERIC:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "WANPIPE Generic driver");
    break;

  case WANCONFIG_MPCHDLC:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, "Multi-Port CHDLC");
    break;

  default:
    snprintf((char*)protocol_name, MAX_PATH_LENGTH, INVALID_PROTOCOL);
    break;
  }

  return (char*)protocol_name;
}

int check_file_exist(char * file_name, FILE ** file)
{
  int rc;

  *file = fopen(file_name, "r+");

  if(*file == NULL){
    Debug(DBG_WANCFG_MAIN, ("File '%s' does not exist.\n", file_name));
    rc = NO;
  }else{
    Debug(DBG_WANCFG_MAIN, ("File '%s' exist.\n", file_name));
    rc = YES;
    fclose(*file);
  }
  return rc;
}

char * get_card_type_string(int card_type)
{
  static char card_type_name[MAX_PATH_LENGTH];

  switch(card_type)
  {
  case NOT_SET:
    snprintf(card_type_name, MAX_PATH_LENGTH, "Undefined");
    break;
  case WANOPT_S50X:
    snprintf(card_type_name, MAX_PATH_LENGTH, "S508");
    break;
  case WANOPT_S51X:
    snprintf(card_type_name, MAX_PATH_LENGTH, "S514X");
    break;
  case WANOPT_ADSL:
    snprintf(card_type_name, MAX_PATH_LENGTH, "S518");
    break;
  case WANOPT_AFT:
    snprintf(card_type_name, MAX_PATH_LENGTH, "A101/2");
    //snprintf(card_type_name, MAX_PATH_LENGTH, "AFT");
    break;
  default:
    snprintf(card_type_name, MAX_PATH_LENGTH, "Invalid Card Type!");
  }
  return card_type_name;
}

//////////////////////////////////////////////////////////
//all types of S514 can be devided on 4
//real types
char* get_S514_card_version_string(char card_version)
{
  switch(card_version)
  {
    case S5141_ADPTR_1_CPU_SERIAL:
      return "S514 - Serial";
      break;

    case S5143_ADPTR_1_CPU_FT1:
      return "S514 - FT1";
      break;

    case S5144_ADPTR_1_CPU_T1E1:
      return "S514 - T1/E1";
      break;

    case S5145_ADPTR_1_CPU_56K:
      return "S514 - 56K DDS";
      break;

    default:
      return NULL;
      break;
  }
}

//////////////////////////////////////////////////////////

char check_wanpipe_start_script_exist(char* wanpipe_name)
{
  char file_path[MAX_PATH_LENGTH];
  FILE* f;

  snprintf(file_path, MAX_PATH_LENGTH, "%s%s/%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  return check_file_exist(file_path, &f);
}

char check_wanpipe_stop_script_exist(char* wanpipe_name)
{
  char file_path[MAX_PATH_LENGTH];
  FILE* f;

  snprintf(file_path, MAX_PATH_LENGTH, "%s%s/%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  return check_file_exist(file_path, &f);
}

void remove_wanpipe_start_script(char* wanpipe_name)
{
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "rm -rf ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  Debug(DBG_WANCFG_MAIN, ("remove_wanpipe_start_script(): command line: %s\n",
    command_line));

  system(command_line);
}

void remove_wanpipe_stop_script(char* wanpipe_name)
{
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "rm -rf ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  Debug(DBG_WANCFG_MAIN, ("remove_wanpipe_stop_script(): command line: %s\n",
    command_line));

  system(command_line);
}

int create_wanpipe_start_script(char* wanpipe_name)
{
  char temp_str[MAX_PATH_LENGTH];
  string wanpipe_script_str;

char wanpipe_start_script_part1[] = {
"#!/bin/sh\n"
"#\n"
};

char wanpipe_start_script_part2[] = {
"#\n"
"# Description:\n"
"# 	This script is called by /usr/sbin/wanrouter\n"
"#       after the device has been started.\n"
"#\n"
"#       Use this script to add extra routes or start\n"
"#       services that relate directly to this\n"
"#       particular device.\n"
"#\n"
"# Arguments:\n"
};

  ////////////////////////////////////////////////////////////////////////////
  wanpipe_script_str = wanpipe_start_script_part1;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "# WANPIPE Device (%s) Start Script\n",
    wanpipe_name);
  wanpipe_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  wanpipe_script_str += wanpipe_start_script_part2;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#\t%s = wanpipe device name\n",
    wanpipe_name);
  wanpipe_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  //create full file path
  snprintf(temp_str, MAX_PATH_LENGTH, "%s%s/%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  return write_string_to_file(temp_str, (char*)wanpipe_script_str.c_str());
}

/////////////////////////////////////////////////////////////////////////////

int create_wanpipe_stop_script(char* wanpipe_name)
{
  char temp_str[MAX_PATH_LENGTH];
  string wanpipe_script_str;

char wanpipe_stop_script_part1[] = {
"#!/bin/sh\n"
"#\n"
};

char wanpipe_stop_script_part2[] = {
"#\n"
"# Description:\n"
"# 	This script is called by /usr/sbin/wanrouter\n"
"#       after the device has been stopped.\n"
"#\n"
"#       Use this script to remove extra routes or stop\n"
"#       services that relate directly to this\n"
"#       particular device.\n"
"#\n"
"# Arguments:\n"
};

  ////////////////////////////////////////////////////////////////////////////
  wanpipe_script_str = wanpipe_stop_script_part1;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "# WANPIPE Device (%s) Stop Script\n",
    wanpipe_name);
  wanpipe_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  wanpipe_script_str += wanpipe_stop_script_part2;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#\t%s = wanpipe device name\n",
    wanpipe_name);
  wanpipe_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  //create full file path
  snprintf(temp_str, MAX_PATH_LENGTH, "%s%s/%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  return write_string_to_file(temp_str, (char*)wanpipe_script_str.c_str());
}

/////////////////////////////////////////////////////////////////////////////

char check_net_interface_start_script_exist(char* wanpipe_name, char* if_name)
{
  char file_path[MAX_PATH_LENGTH];
  FILE* f;

  snprintf(file_path, MAX_PATH_LENGTH, "%s%s/%s-%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  return check_file_exist(file_path, &f);
}

char check_net_interface_stop_script_exist(char* wanpipe_name, char* if_name)
{
  char file_path[MAX_PATH_LENGTH];
  FILE* f;

  snprintf(file_path, MAX_PATH_LENGTH, "%s%s/%s-%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  return check_file_exist(file_path, &f);
}

//////////////////////////////////////////////////////////////////////////////

void remove_net_interface_start_script(char* wanpipe_name, char* if_name)
{
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "rm -rf ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  Debug(DBG_WANCFG_MAIN, ("remove file command line: %s\n", command_line));

  system(command_line);
}

//////////////////////////////////////////////////////////////////////////////

int edit_wanpipe_start_script(char* wanpipe_name)
{
  int sytem_call_status;
  int vi_exit_status;
  int rc = YES;
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "vi ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  sytem_call_status = system(command_line);

  if(WIFEXITED(sytem_call_status)){

    vi_exit_status = WEXITSTATUS(sytem_call_status);

    Debug(DBG_WANCFG_MAIN, ("vi_exit_status: %d\n", vi_exit_status));

    if(vi_exit_status != 0){
      rc = NO;
      ERR_DBG_OUT(("Failed to start Text Editor (vi)!!\n"));
    }

  }else{
    //Text Editor (vi) crashed or killed
    ERR_DBG_OUT(("Text Editor (vi) exited abnormally (sytem_call_status: %d).\n",
            sytem_call_status));
    rc = NO;
  }

  return rc;
}

//////////////////////////////////////////////////////////////////////////////

int edit_wanpipe_stop_script(char* wanpipe_name)
{
  int sytem_call_status;
  int vi_exit_status;
  int rc = YES;
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "vi ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name);

  sytem_call_status = system(command_line);

  if(WIFEXITED(sytem_call_status)){

    vi_exit_status = WEXITSTATUS(sytem_call_status);

    Debug(DBG_WANCFG_MAIN, ("vi_exit_status: %d\n", vi_exit_status));

    if(vi_exit_status != 0){
      rc = NO;
      ERR_DBG_OUT(("Failed to start Text Editor (vi)!!\n"));
    }

  }else{
    //Text Editor (vi) crashed or killed
    ERR_DBG_OUT(("Text Editor (vi) exited abnormally (sytem_call_status: %d).\n",
            sytem_call_status));
    rc = NO;
  }

  return rc;
}

//////////////////////////////////////////////////////////////////////////////

void remove_net_interface_stop_script(char* wanpipe_name, char* if_name)
{
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "rm -rf ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  Debug(DBG_WANCFG_MAIN, ("remove file command line: %s\n", command_line));

  system(command_line);
}

//////////////////////////////////////////////////////////

int edit_net_interface_start_script(char* wanpipe_name, char* if_name)
{
  int sytem_call_status;
  int vi_exit_status;
  int rc = YES;
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "vi ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  sytem_call_status = system(command_line);

  if(WIFEXITED(sytem_call_status)){

    vi_exit_status = WEXITSTATUS(sytem_call_status);

    Debug(DBG_WANCFG_MAIN, ("vi_exit_status: %d\n", vi_exit_status));

    if(vi_exit_status != 0){
      rc = NO;
      ERR_DBG_OUT(("Failed to start Text Editor (vi)!!\n"));
    }

  }else{
    //Text Editor (vi) crashed or killed
    ERR_DBG_OUT(("Text Editor (vi) exited abnormally (sytem_call_status: %d).\n",
            sytem_call_status));
    rc = NO;
  }

  return rc;
}

//////////////////////////////////////////////////////////

int edit_net_interface_stop_script(char* wanpipe_name, char* if_name)
{
  int sytem_call_status;
  int vi_exit_status;
  int rc = YES;
  char command_line[MAX_PATH_LENGTH];

  snprintf(command_line, MAX_PATH_LENGTH, "vi ");

  snprintf(&command_line[strlen(command_line)], MAX_PATH_LENGTH, "%s%s/%s-%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  sytem_call_status = system(command_line);

  if(WIFEXITED(sytem_call_status)){

    vi_exit_status = WEXITSTATUS(sytem_call_status);

    Debug(DBG_WANCFG_MAIN, ("vi_exit_status: %d\n", vi_exit_status));

    if(vi_exit_status != 0){
      rc = NO;
      ERR_DBG_OUT(("Failed to start Text Editor (vi)!!\n"));
    }

  }else{
    //Text Editor (vi) crashed or killed
    ERR_DBG_OUT(("Text Editor (vi) exited abnormally (sytem_call_status: %d).\n",
            sytem_call_status));
    rc = NO;
  }

  return rc;
}

//////////////////////////////////////////////////////////

int create_new_net_interface_start_script(char* wanpipe_name, char* if_name)
{
  char temp_str[MAX_PATH_LENGTH];
  string net_start_script_str;

char net_if_start_script_part1[] = {
"#!/bin/sh\n"
"#\n"
};

//"#WANPIPE Interface (wp2fr16) Start Script\n"
char net_if_start_script_part2[] = {
"#\n"
"# Description:\n"
"# 	This script is called by /usr/sbin/wanrouter\n"
"#       after the interface has been started using\n"
"#       ifconfig.\n"
"#\n"
"#       Use this script to add extra routes or start\n"
"#       services that relate directly to this\n"
"#       particular interafce.\n"
"#\n"
"# Arguments:\n"
};

//#       wanpipe2 = wanpipe device name    (wanpipe1)
//#       wp2fr16 = wanpipe interface name (wan0)
char net_if_start_script_part3[] = {
"#\n"
"# Dynamic Mode:\n"
"#       This script will be called by the\n"
"#       wanpipe kernel driver any time the\n"
"#       state of the interface changes.\n"
"#\n"
"#       Eg: If interface goes up and down,\n"
"#           or changes IP addresses.\n"
"#\n"
"#       Wanpipe Syncppp Driver will call this\n"
"#       script when IPCP negotiates new IP\n"
"#       addresses\n"
"#\n"
"# Dynamic Environment Variables:\n"
"#       These variables are available only when\n"
"#       the script is called via wanpipe kernel\n"
"#       driver.\n"
"#\n"
"#\n"
};

  ////////////////////////////////////////////////////////////////////////////
  net_start_script_str = net_if_start_script_part1;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#WANPIPE Interface (%s) Start Script\n",
    if_name);
  net_start_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  net_start_script_str += net_if_start_script_part2;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#\t%s = wanpipe device name\n",
    wanpipe_name);
  net_start_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#\t%s = wanpipe interface name\n",
    if_name);
  net_start_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////
  net_start_script_str += net_if_start_script_part3;

  //create full file path
  snprintf(temp_str, MAX_PATH_LENGTH, "%s%s/%s-%s-start",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  return write_string_to_file(temp_str, (char*)net_start_script_str.c_str());
}

//////////////////////////////////////////////////////////

int create_new_net_interface_stop_script(char* wanpipe_name, char* if_name)
{
  char temp_str[MAX_PATH_LENGTH];
  string net_stop_script_str;

char net_if_stop_script_part1[] = {
"#!/bin/sh\n"
"#\n"
};

//# WANPIPE Interface (wp2fr16) Stop Script
char net_if_stop_script_part2[] = {
"#\n"
"# Description:\n"
"# 	This script is called by /usr/sbin/wanrouter\n"
"#       after the interface has been stopped using\n"
"#       ifconfig.\n"
"#\n"
"#       Use this script to remove routes or stop\n"
"#       services that relate directly to this\n"
"#       particular interafce.\n"
"#\n"
"# Arguments:\n"
};

  ////////////////////////////////////////////////////////////////////////////
  net_stop_script_str = net_if_stop_script_part1;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#WANPIPE Interface (%s) Stop Script\n",
    if_name);
  net_stop_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  net_stop_script_str += net_if_stop_script_part2;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#\t%s = wanpipe device name\n",
    wanpipe_name);
  net_stop_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  snprintf(temp_str, MAX_PATH_LENGTH, "#\t%s = wanpipe interface name\n",
    if_name);
  net_stop_script_str += temp_str;
  ////////////////////////////////////////////////////////////////////////////

  //create full file path
  snprintf(temp_str, MAX_PATH_LENGTH, "%s%s/%s-%s-stop",
    wanpipe_cfg_dir,
    start_stop_scripts_dir,
    wanpipe_name,
    if_name);

  return write_string_to_file(temp_str, (char*)net_stop_script_str.c_str());
}

//////////////////////////////////////////////////////////

int write_string_to_file(char * full_file_path, char* string)
{
  FILE * file;

  Debug(DBG_WANCFG_MAIN, ("write_string_to_file():\n path: %s\n str: %s\n",
    full_file_path, string));

  file = fopen(full_file_path, "w");
  if(file == NULL){
    ERR_DBG_OUT(("Failed to open %s file for writing!\n", full_file_path));
    return NO;
  }

  fputs(string, file);
  fclose(file);
  return YES;
}

//////////////////////////////////////////////////////////

//function used for printing errors in the release version.
void err_printf(char* format, ...)
{
  char dbg_tmp_buff[LEN_OF_DBG_BUFF];
	va_list ap;

	va_start(ap, format);
  vsnprintf(dbg_tmp_buff, LEN_OF_DBG_BUFF, format, ap);
	va_end(ap);

  printf(dbg_tmp_buff);
  printf("\n");
}

/*
//caller must be sure 'input' string is actually an integer.
char* remove_spaces_in_int_string(char* input)
{
  static char output [LEN_OF_DBG_BUFF];

  //remove spaces and zero terminate.
  snprintf(output, LEN_OF_DBG_BUFF, "%d", atoi(input));
  return output;
}
*/

//caller must be sure 'input' string is actually an integer.
char* remove_spaces_in_int_string(char* input)
{
  char output [LEN_OF_DBG_BUFF];

  //remove spaces and zero terminate.
  snprintf(output, LEN_OF_DBG_BUFF, "%d", atoi(input));
  //copy back to caller's buffer
  strcpy(input, output);

  return input;
}

int yes_no_question(  OUT int* selection_index,
                      IN char * lxdialog_path,
                      IN int protocol,
                      IN char* format, ...)
{
  FILE * yes_no_question_file;
  char yes_no_question_buff[LEN_OF_DBG_BUFF];
	va_list ap;
  char* yes_no_question_file_name = "wancfg_yes_no_question_file_name";
  //char* remove_yes_no_question_file = "rm -rf wancfg_yes_no_question_file_name";
  int rc = YES;
  char file_path[MAX_PATH_LENGTH];
  char remove_tmp_file[MAX_PATH_LENGTH];

  text_box_yes_no yn_tb;

  snprintf(file_path, MAX_PATH_LENGTH, "%s%s", wancfg_cfg_dir,
                                               yes_no_question_file_name);

  snprintf(remove_tmp_file, MAX_PATH_LENGTH, "rm -rf %s", file_path);

	va_start(ap, format);
  vsnprintf(yes_no_question_buff, LEN_OF_DBG_BUFF, format, ap);
	va_end(ap);

  //open temporary file
  yes_no_question_file = fopen(file_path, "w");
  if(yes_no_question_file == NULL){
    ERR_DBG_OUT(("Failed to open 'yes_no_question_file' %s file for writing!\n",
      file_path));
    return NO;
  }

  fputs(yes_no_question_buff, yes_no_question_file);
  fclose(yes_no_question_file);

  if(yn_tb.set_configuration( lxdialog_path,
                              protocol,
                              yes_no_question_file_name) == NO){
    rc = NO;
    goto cleanup;
  }

  if(yn_tb.show(selection_index) == NO){
    rc = NO;
    goto cleanup;
  }

cleanup:
  //remove the temporary file
  system(remove_tmp_file);

  return rc;
}

//
//input : Configuration file name of type: wanpipe??.conf
//output: 0 - if error occured. (0 is invalid Wanpipe number too)
//        positive value (wanpipe number) if successful.
//
int get_wanpipe_number_from_conf_file_name(char* conf_file_name)
{
  char* digit_ptr = NULL;
  int wanpipe_number = 0;

  if(strlen(WANPIPE_TOKEN) >= strlen(conf_file_name)){
    ERR_DBG_OUT(("Invalid 'conf' file name: %s\n", conf_file_name));
    return 0;
  }

  digit_ptr = conf_file_name + strlen(WANPIPE_TOKEN);

  //atoi() - returns 0 if failes.
  wanpipe_number = atoi(digit_ptr);

  if(wanpipe_number > MAX_NUMBER_OF_WANPIPES){
    ERR_DBG_OUT(("Invalid wanpipe number: %d\n", wanpipe_number));
    return 0;
  }
  Debug(DBG_WANCFG_MAIN, ("wanpipe number: %d\n", wanpipe_number));

  return wanpipe_number;
}

//converts all characters in the string to lower case.
void str_tolower(char * str)
{
  unsigned int i;

  //Debug(DBG_WANCFG_MAIN, "str before str_tolower: %s\n", str);

  for(i = 0; i < strlen(str); i++){
    str[i] = (char)tolower(str[i]);
  }

  //Debug(DBG_WANCFG_MAIN, "str after str_tolower: %s\n", str);
}

//converts all characters in the string to upper case.
void str_toupper(char * str)
{
  unsigned int i;

  //Debug(DBG_WANCFG_MAIN, "str before str_toupper: %s\n", str);

  for(i = 0; i < strlen(str); i++){
    str[i] = (char)toupper(str[i]);
  }

  //Debug(DBG_WANCFG_MAIN, "str after str_toupper: %s\n", str);
}

int get_used_by_integer_value(char* used_by_str)
{
  if(strcmp(used_by_str, "WANPIPE") == 0){
    return WANPIPE;
  }else if(strcmp(used_by_str, "API") == 0){
    return API;
  }else if(strcmp(used_by_str, "BRIDGE") == 0){
    return BRIDGE;
  }else if(strcmp(used_by_str, "BRIDGE_NODE") == 0){
    return BRIDGE_NODE;
  }else if(strcmp(used_by_str, "SWITCH") == 0){
    return SWITCH;
  }else if(strcmp(used_by_str, "STACK") == 0){
    return STACK;
  }else if(strcmp(used_by_str, "ANNEXG") == 0){
    return ANNEXG;
  }else if(strcmp(used_by_str, "VoIP") == 0){
    return VoIP;
  }else{
    return -1;
  }
}

char* get_used_by_string(int used_by)
{
  switch(used_by)
  {
  case WANPIPE:
    return "WANPIPE";

  case API:
    return "API";

  case BRIDGE:
    return "BRIDGE";

  case BRIDGE_NODE:
    return "BRIDGE_NODE";

  case SWITCH:
    return "SWITCH";

  case STACK:
    return "STACK";

  case ANNEXG:
    return "ANNEXG";

  case VoIP:
    return "VoIP";

  case PPPoE:
    return "PPPoE";

  default:
    return "Unknown Operation Mode";
  }
}

char* replace_new_line_with_zero_term(char* str)
{
  unsigned int i;

  for(i = 0; i < strlen(str); i++){
    if(str[i] == '\n'){
      str[i] = '\0';
    }
  }
  return str;
}

char* replace_new_line_with_space(char* str)
{
  unsigned int i;

  for(i = 0; i < strlen(str); i++){
    if(str[i] == '\n'){
      str[i] = ' ';
    }
  }
  return str;
}

void tokenize_string(char* input_buff, char* delimeter_str, char* output_buff, int buff_length)
{
  char* p = strtok(input_buff, delimeter_str);

  output_buff[0] = '\0';

  while(p != NULL){
    //printf(p);
    snprintf(&output_buff[strlen(output_buff)], buff_length - strlen(output_buff), p);
    p = strtok(NULL, delimeter_str);
  }
  printf("\ntokenized str: %s\n", output_buff);
}

char* replace_char_with_other_char_in_str(char* str, char old_char, char new_char)
{
  unsigned int i;

  for(i = 0; i < strlen(str); i++){
    if(str[i] == old_char){
      str[i] = new_char;
    }
  }
  return str;
}

//////////////////////////////////////////////////////////
char* get_date_and_time()
{
  int system_exit_status;
  static char date_and_time_str[MAX_PATH_LENGTH];
  char command_line[MAX_PATH_LENGTH];
  char* date_and_time_file_name = "date_and_time_file.tmp";
  FILE* date_and_time_file;

  snprintf(command_line, MAX_PATH_LENGTH, "date > %s", date_and_time_file_name);
  Debug(DBG_WANCFG_MAIN, ("get_date_and_time() command line: %s\n", command_line));

  system_exit_status = system(command_line);
  system_exit_status = WEXITSTATUS(system_exit_status);

  if(system_exit_status != 0){
    ERR_DBG_OUT(("The following command failed: %s\n", command_line));
    return "Unknown";
  }

  date_and_time_file = fopen(date_and_time_file_name, "r+");
  if(date_and_time_file == NULL){
    ERR_DBG_OUT(("Failed to open the file '%s' for reading!\n",
      date_and_time_file_name));
    return "Unknown";
  }

  do{
    fgets(date_and_time_str, MAX_PATH_LENGTH, date_and_time_file);

    if(!feof(date_and_time_file)){
      Debug(DBG_WANCFG_MAIN, ("date_and_time_str: %s\n", date_and_time_str));
    }//if()
  }while(!feof(date_and_time_file));

  return date_and_time_str;
}


/*============================================================================
 * TE1
 * Parse active channel string.
 *
 * Return ULONG value, that include 1 in position `i` if channels i is active.
 */
unsigned long parse_active_channel(char* val, unsigned char media_type)
{
#define SINGLE_CHANNEL	0x2
#define RANGE_CHANNEL	  0x1
	int channel_flag = 0;
	char* ptr = val;
	int channel = 0, start_channel = 0;
	unsigned long tmp = 0;

  Debug(DBG_WANCFG_MAIN, ("parse_active_channel(): input: %s, media_type: %d\n", val, media_type));

	if (strcmp(val,"ALL") == 0)
		return ENABLE_ALL_CHANNELS;

  if(active_channels_str_invalid_characters_check(val) == NO){
    return 0;
  }

	while(*ptr != '\0') {
		if (isdigit(*ptr)) {
			channel = strtoul(ptr, &ptr, 10);
			channel_flag |= SINGLE_CHANNEL;
		} else {
			if (*ptr == '-') {
				channel_flag |= RANGE_CHANNEL;
				start_channel = channel;
			} else {
				tmp |= get_active_channels(channel_flag, start_channel, channel, media_type);
				channel_flag = 0;
			}
			ptr++;
		}
	}
	if (channel_flag){
		tmp |= get_active_channels(channel_flag, start_channel, channel, media_type);
	}

  if(check_channels(channel_flag, start_channel, channel, media_type) == NO){
    tmp = 0;
  }
	return tmp;
}

int active_channels_str_invalid_characters_check(char* active_ch_str)
{
	char* ptr = active_ch_str;

	while(*ptr != '\0') {
		if (isdigit(*ptr)) {
      ;//ok
		} else {
			if(*ptr == '-' || *ptr == '.') {
        ;//ok
			}else{
        //invalid char
        printf("Found invalid character '%c' in active channels string!!", *ptr);
        return NO;
			}
		}
	  ptr++;
	}//while()
  return YES;
}

/*============================================================================
 * TE1
 */
unsigned long get_active_channels(int channel_flag, int start_channel,
                                  int stop_channel,  unsigned char media_type)
{
	int i = 0;
	unsigned long tmp = 0, mask = 0;

	if ((channel_flag & (SINGLE_CHANNEL | RANGE_CHANNEL)) == 0)
		return tmp;
	if (channel_flag & RANGE_CHANNEL) { /* Range of channels */
		for(i = start_channel; i <= stop_channel; i++) {
			mask = 1 << (i - 1);
			tmp |=mask;
		}
	} else { /* Single channel */
		mask = 1 << (stop_channel - 1);
		tmp |= mask;
	}
	return tmp;
}

int check_channels(int channel_flag, unsigned int start_channel,
                   unsigned int stop_channel, unsigned char media_type)
{
  Debug(DBG_WANCFG_MAIN, ("check_channels(): media_type: %d, start_channel: %d, stop_channel: %d\n",
    media_type, start_channel, stop_channel));

	if ((channel_flag & 0x03) == 0)
		return NO;
	if ((channel_flag & RANGE_CHANNEL) && (start_channel > stop_channel))
		return NO;
	if (!(channel_flag & RANGE_CHANNEL))
		start_channel = stop_channel;
	if ( media_type == WANOPT_MEDIA_T1){

		if( (start_channel < 1) || (stop_channel > NUM_OF_T1_CHANNELS) )
			return NO;
	}else if(media_type == WANOPT_MEDIA_E1){

		if( (start_channel < 1) || (stop_channel > NUM_OF_E1_TIMESLOTS) )
			return NO;
	}
	return YES;
}

//returns:  NULL - if string is valid
//          pointer to err explanation if string is invalid
char* validate_ipv4_address_string(char* str)
{
  char* token;
  char seps[] = ".";
  int field_counter = 0;
  static char err_buf[MAX_PATH_LENGTH];

#define MAX_IPV4_LEN_STR  3*4+4
#define MIN_IPV4_LEN_STR  3*1+4

  if(strlen(str) > MAX_IPV4_LEN_STR){
    snprintf(err_buf, MAX_PATH_LENGTH,
      "Number of characters in IP string is greater than %d!\n", MAX_IPV4_LEN_STR);
    return err_buf;
  }
  if(strlen(str) < MIN_IPV4_LEN_STR){
    snprintf(err_buf, MAX_PATH_LENGTH,
      "Number of characters in IP string is less than %d!\n", MIN_IPV4_LEN_STR);
    return err_buf;
  }

  token = strtok((char*)str, seps);
  while(token != NULL){
    printf("token: %s\n", token);

    if(strlen(token) > 3){
      snprintf(err_buf, MAX_PATH_LENGTH,
        "Invalid number of characters in IP string field (%s).\n", token);
      return err_buf;
    }

    for(unsigned int i = 0; i < strlen(token); i++){
      if(isdigit(token[i]) == 0){
        snprintf(err_buf, MAX_PATH_LENGTH,
          "Invalid characters in IP string field (%s).\n", token);
        return err_buf;
      }
    }

    field_counter++;
    token = strtok(NULL, seps);
  }

  if(field_counter != 4){
    snprintf(err_buf, MAX_PATH_LENGTH,
      "Invalid number of \".\" separated fields in IP string.\n");
    return err_buf;
  }
  return NULL;
}

char* validate_authentication_string(char* str, int max_length)
{
  static char err_buf[MAX_PATH_LENGTH];

  Debug(DBG_WANCFG_MAIN, ("validate_authentication_string(): str: %s\n", str));

  if(strlen(str) > (unsigned)max_length){
    snprintf(err_buf, MAX_PATH_LENGTH,
      "Number of characters in authentication\nstring is greater than %d!\n",
      max_length);
    return err_buf;
  }

  if(strlen(str) < 1){
    snprintf(err_buf, MAX_PATH_LENGTH,
      "Number of characters in authentication\nstring is less than 1!\n");
    return err_buf;
  }
/*
  for(unsigned int i = 0; i < strlen(str); i++){

    Debug(DBG_WANCFG_MAIN, ("validating char: %c\n", str[i]));
    if(isalnum(str[i]) == 0){
      snprintf(err_buf, MAX_PATH_LENGTH,
        "Invalid character (%c) found in authentication string!\n", str[i]);
      return err_buf;
    }
  }
*/
  for(unsigned int i = 0; i < strlen(str); i++){

    Debug(DBG_WANCFG_MAIN, ("validating char: %c\n", str[i]));
    if(isspace(str[i]) != 0){
      snprintf(err_buf, MAX_PATH_LENGTH,
        "Invalid character 'blank space' found\nin authentication string!\n");
      return err_buf;
    }
  }

  //validation passed
  return NULL;
}

/*
int main(int argc, char *argv[])
{
  int  selection_index;

  Debug(DBG_WANCFG_MAIN, ("main()\n"));

  input_box_active_channels * act_channels_ip = new input_box_active_channels();

  if(act_channels_ip->show( lxdialog_path, WANCONFIG_BITSTRM,
                            "hello", &selection_index) == NO){
    goto cleanup;
  }

  if(selection_index == INPUT_BOX_BUTTON_OK){
    printf("main(): lxdialog output str: %s\n", act_channels_ip->get_lxdialog_output_string());
  }

cleanup:

  delete act_channels_ip;
  return EXIT_SUCCESS;
}
*/
/*
int main(int argc, char *argv[])
{
  int selection_index;
  int rc;

  Debug(DBG_WANCFG_MAIN, ("main()\n"));

  menu_base * mb = new menu_base();

  rc =
#if 1
    mb->set_configuration(MENU_BOX_SELECT, lxdialog_path, "the title", "the backtitle",
                          "the explanation text",
                          MENU_HEIGTH, MENU_WIDTH, 2,
                          "tag1", "item 1", "tag2", "item 2", END_OF_PARAMS_LIST);
#endif

#if 0
    mb->set_configuration(MENU_BOX_BACK, lxdialog_path, "the title", "the backtitle",
                          "the explanation text",
                          MENU_HEIGTH, MENU_WIDTH, 2,
                          "tag1", "item 1", "tag2", "item 2", END_OF_PARAMS_LIST);
#endif
  if(rc == NO){
    goto cleanup;
  }

  mb->show(&selection_index);
  if(selection_index == MENU_BOX_BUTTON_SELECT){
    printf("main(): lxdialog output str: %s\n", mb->get_lxdialog_output_string());
  }

cleanup:

  delete mb;
  return EXIT_SUCCESS;
}
*/
/*
int main(int argc, char *argv[])
{
  int selection_index;
  int rc;

  Debug(DBG_WANCFG_MAIN, ("main()\n"));

  dialog_yes_no * ynd = new dialog_yes_no();

  rc = ynd->set_configuration(lxdialog_path, "the title", "the backtitle",
                          "the explanation text");
  if(rc == NO){
    goto cleanup;
  }

  if(ynd->show(&selection_index) == YES){
    printf("main(): selection_index: %d\n", selection_index);
  }

cleanup:

  delete ynd;
  return EXIT_SUCCESS;
}
*/
/*
int main(int argc, char *argv[])
{
  Debug(DBG_WANCFG_MAIN, ("main()\n"));

  text_box * tb = new text_box();

  if(tb->set_configuration( lxdialog_path,
                            WANCONFIG_BITSTRM,
                            "lxdialog_command_lines.txt") == NO){
    goto cleanup;
  }

  tb->show();

cleanup:

  delete tb;
  return EXIT_SUCCESS;
}
*/

/*
int main(int argc, char *argv[])
{
  int selection_index;

  Debug(DBG_WANCFG_MAIN, ("main()\n"));

  text_box_yes_no * yn_tb = new text_box_yes_no();

  if(yn_tb->set_configuration(  lxdialog_path,
                                WANCONFIG_BITSTRM,
                                "lxdialog_command_lines.txt") == NO){
    goto cleanup;
  }

  if(yn_tb->show(&selection_index) == YES){
    printf("main(): selection_index: %d\n", selection_index);
  }

cleanup:

  delete yn_tb;
  return EXIT_SUCCESS;
}
*/
/*
int main(int argc, char *argv[])
{
  int selection_index;

  Debug(DBG_WANCFG_MAIN, ("main()\n"));

  yes_no_question( &selection_index,
                   lxdialog_path,
                   WANCONFIG_FR,
                   "ARE U TIRED?");
  printf("answer: %s\n", (selection_index == YES_NO_TEXT_BOX_BUTTON_YES ? "YES" : "NO"));

  return EXIT_SUCCESS;
}
*/

/*
int main(int argc, char *argv[])
{
  conf_file_reader cfr(2);
  cfr.read_conf_file();

  Debug(DBG_WANCFG_MAIN, ("main() - end\n"));
  return 0;
}
*/

#if 0

int main(int argc, char *argv[])
{
  list_element_chan_def el16;
  list_element_chan_def el20;
  list_element_chan_def el32;
  list_element_chan_def el48;
  objects_list ol;
  list_element_chan_def* tmp;

  el16.set_comparator("16");
  el20.set_comparator("20");
  el32.set_comparator("32");
  el48.set_comparator("48");


  ol.insert(&el16);
//  ol.insert(&el20);
  ol.insert(&el32);
//  ol.insert(&el48);

/*
  ol.remove_element("16");
  el16.set_comparator("20");
  ol.insert(&el16);
  //ol.insert(&el20);
*/
  ol.remove_element("32");
  el32.set_comparator("48");
  ol.insert(&el32);

/*
  ol.insert(&el16);
  ol.insert(&el20);
  ol.insert(&el32);
*/
  printf("-------------------------------------------\n");
/*
  printf("removing all from head:\n");
  while((tmp = (list_element_chan_def*)ol.remove_from_head()) != NULL){
    printf("comparator: %s\n", tmp->get_comparator());
  }
*/
  printf("-------------------------------------------\n");

  tmp = (list_element_chan_def*)ol.get_last();
  while(tmp != NULL){
    printf("comparator: %s\n", tmp->get_comparator());
    tmp = (list_element_chan_def*)ol.get_previous_element(tmp);
  }
  printf("-------------------------------------------\n");

/*
  printf("removing all from tail:\n");
  while((tmp = ol.remove_from_tail()) != NULL){
    printf("comparator: %s\n", tmp->get_comparator());
  }

  printf("-------------------------------------------\n");

  el16.next = el16.previous = NULL;
  el20.next = el20.previous = NULL;
  el32.next = el32.previous = NULL;
  el48.next = el48.previous = NULL;

  ol.insert(&el16);
  ol.insert(&el20);
  ol.insert(&el32);
  ol.insert(&el48);

  printf("-------------------------------------------\n");

  printf("removing all from head:\n");
  while((tmp = ol.remove_from_head()) != NULL){
    printf("comparator: %s\n", tmp->get_comparator());
  }

  printf("-------------------------------------------\n");
*/
/*
  ol.remove_element("20");
  ol.remove_element("20");
*/
  tmp = (list_element_chan_def*)ol.get_first();
  while(tmp != NULL){
    printf("comparator: %s\n", tmp->get_comparator());
    tmp = (list_element_chan_def*)ol.get_next_element(tmp);
  }
  printf("-------------------------------------------\n");

  return 0;
}

#endif

#if 1

int main(int argc, char *argv[])
{
  int selection_index;
  menu_main_configuration_options main_menu_box(lxdialog_path);

  Debug(DBG_WANCFG_MAIN, ("%s: main()\n", WANCFG_PROGRAM_NAME));

again:

  /////////////////////////////////////////////////////////////////////////////////
  if(main_menu_box.run(&selection_index) == NO){
    Debug(DBG_WANCFG_MAIN, ("main(): main_menu_box.run() - failed!!\n"));
    goto cleanup;
  }

  switch(selection_index)
  {
  case MENU_BOX_BUTTON_SELECT:
  case MENU_BOX_BUTTON_HELP:
    goto again;
    break;

  case MENU_BOX_BUTTON_EXIT:
    //exit the program
    break;

  default:
    ERR_DBG_OUT(("Unknown selection_index: %d\n", selection_index));
    goto cleanup;
  }

cleanup:
  return EXIT_SUCCESS;
}
#endif

#if 0
int main(int argc, char *argv[])
{
  conf_file_writer cf_writer(NULL);

  cf_writer.get_keyword_from_key_word_t_table(common_conftab, 0);
}
#endif


#if 0
int main(int argc, char *argv[])
{

  char tmp[100];

  snprintf(tmp, 100, "200.109.102.103.900");

  validate_ipv4_address_string(tmp);
  return 1;
}
#endif

//STATIONCPESIGNALLINGANSI1

#if 0
int main(int argc, char *argv[])
{
  char tmp[100];
  wan_fr_conf_t fr;

  snprintf(tmp, 100, "STATIONCPESIGNALLINGANSI1");

  validate_ipv4_address_string(tmp);
  return 1;
}
#endif
