/***************************************************************************
                          menu_hdlc_streaming_connection_type.cpp  -  description
                             -------------------
    begin                : Mon May 3 2004
    copyright            : (C) 2004 by David Rokhvarg
    email                : davidr@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "menu_hdlc_streaming_connection_type.h"
#include "text_box.h"

#define DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE 1

menu_hdlc_streaming_connection_type::menu_hdlc_streaming_connection_type(
                                                              IN char * lxdialog_path,
                                                              IN conf_file_reader* cfr)
{
  Debug(DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE,
    ("menu_hdlc_streaming_connection_type::menu_hdlc_streaming_connection_type()\n"));

  snprintf(this->lxdialog_path, MAX_PATH_LENGTH, "%s", lxdialog_path);
  this->cfr = cfr;
}

menu_hdlc_streaming_connection_type::~menu_hdlc_streaming_connection_type()
{
  Debug(DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE,
    ("menu_hdlc_streaming_connection_type::~menu_hdlc_streaming_connection_type()\n"));
}

int menu_hdlc_streaming_connection_type::run(OUT int * selection_index)
{
  string menu_str;
  int rc;
  char tmp_buff[MAX_PATH_LENGTH];
  char exit_dialog;
  int number_of_items;
  unsigned char old_media;

  //help text box
  text_box tb;

  link_def_t * link_def;
  wandev_conf_t *linkconf;

  Debug(DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE, ("menu_hdlc_streaming_connection_type::run()\n"));

again:

  link_def = cfr->link_defs;
  linkconf = cfr->link_defs->linkconf;

  Debug(DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE, ("cfr->link_defs->name: %s\n", link_def->name));

  rc = YES;
  exit_dialog = NO;
  old_media = linkconf->te_cfg.media;

  menu_str = " ";

  Debug(DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE, ("linkconf->card_type: DEC:%d, HEX: 0x%X\n",
    linkconf->card_type, linkconf->card_type));

  number_of_items = 2;

  menu_str.sprintf(" \"%d\" ", WANOPT_PERMANENT);
  menu_str += " \"Permanent\" ";

  snprintf(tmp_buff, MAX_PATH_LENGTH, " \"%d\" ", WANOPT_SWITCHED);
  menu_str += tmp_buff;
  menu_str += " \"Switched RTS\" ";

  //////////////////////////////////////////////////////////////////////////////////////
  //create the explanation text for the menu
  snprintf(tmp_buff, MAX_PATH_LENGTH,
"\n------------------------------------------\
\nSelect Connection Type for Wan Device: %s", link_def->name);

  if(set_configuration(   YES,//indicates to call V2 of the function
                          MENU_BOX_BACK,//MENU_BOX_SELECT,
                          lxdialog_path,
                          "SELECT CONNECTION TYPE",
                          WANCFG_PROGRAM_NAME,
                          tmp_buff,
                          MENU_HEIGTH, MENU_WIDTH,
                          number_of_items,
                          (char*)menu_str.c_str()
                          ) == NO){
    rc = NO;
    goto cleanup;
  }

  if(show(selection_index) == NO){
    rc = NO;
    goto cleanup;
  }
  //////////////////////////////////////////////////////////////////////////////////////

  exit_dialog = NO;
  switch(*selection_index)
  {
  case MENU_BOX_BUTTON_SELECT:
    Debug(DBG_MENU_HDLC_STREAMING_CONNECTION_TYPE,
      ("connection type: option selected for editing: %s\n", get_lxdialog_output_string()));

    linkconf->connection = atoi(get_lxdialog_output_string());
    exit_dialog = YES;
    break;

  case MENU_BOX_BUTTON_HELP:

    switch(atoi(get_lxdialog_output_string()))
    {
    default:
      tb.show_help_message(lxdialog_path, NO_PROTOCOL_NEEDED,
        option_not_implemented_yet_help_str);
      break;
    }
    break;

  case MENU_BOX_BUTTON_EXIT:
    exit_dialog = YES;
    break;
  }//switch(*selection_index)

  if(exit_dialog == NO){
    goto again;
  }

cleanup:
  return rc;
}
