/***************************************************************************
                          menu_select_and_configure_protocol.cpp  -  description
                             -------------------
    begin                : Tue Mar 16 2004
    copyright            : (C) 2004 by David Rokhvarg
    email                : davidr@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "menu_select_and_configure_protocol.h"

#include "menu_list_existing_wanpipes.h"//for static functions

#include "wancfg.h"
#include "text_box.h"
#include "text_box_yes_no.h"
#include "menu_protocol_mode_select.h"
#include "menu_frame_relay_basic_cfg.h"
#include "menu_chdlc_basic_cfg.h"
#include "menu_hdlc_streaming_configuration.h"
#include "menu_chdlc_basic_cfg.h"
#include "menu_ppp_basic_cfg.h"

enum SELECT_AND_CONFIG_PROTOCOL{
  CURRENT_PROTOCOL,
  CONFIGURE_CURRENT_PROTOCOL,
  SELECT_NEW_PROTOCOL
};

menu_select_and_configure_protocol::menu_select_and_configure_protocol( IN char * lxdialog_path,
                                                                        IN conf_file_reader** ptr_cfr)
{
  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("menu_select_and_configure_protocol::menu_select_and_configure_protocol()\n"));

  snprintf(this->lxdialog_path, MAX_PATH_LENGTH, "%s", lxdialog_path);
  this->ptr_cfr = ptr_cfr;
  cfr = *ptr_cfr;
}

menu_select_and_configure_protocol::~menu_select_and_configure_protocol()
{
  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("menu_select_and_configure_protocol::~menu_select_and_configure_protocol()\n"));
}

int menu_select_and_configure_protocol::run(OUT int * selected_option)
{
  string menu_str;
  int rc;
  char tmp_buff[MAX_PATH_LENGTH];
  int selection_index;
  //help text box
  text_box tb;

//  link_def_t * link_def = cfr->link_defs;
  wandev_conf_t *linkconf;

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("menu_select_and_configure_protocol::run()\n"));

again:
  rc = YES;
  menu_str = " ";
  linkconf = cfr->link_defs->linkconf;

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("linkconf->config_id: %d\n", linkconf->config_id));
  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("linkconf->card_type: %d\n", linkconf->card_type));

  if(linkconf->config_id == PROTOCOL_NOT_SET){
/*
    if(linkconf->card_type == WANOPT_AFT){

      menu_aft_select_protocol aft_select_protocol(lxdialog_path, cfr, logical_ch_cfg);

      if(aft_select_protocol.run(selection_index) == NO){
        rc = NO;
      }
    }
*/
    if(linkconf->card_type == WANOPT_AFT){
      //if AFT card and protocol not set - it is new configuration of AFT card
      //since there is no protocol selection for the AFT card,
      //read the the template file and return.

      //read AFT template file - raw HDLC
      if(handle_protocol_change(WANCONFIG_AFT) == NO){
        return NO;
      }else{
       *selected_option = MENU_BOX_BUTTON_SELECT;
       return YES;
      }
    }else{

      //do not make the user to answer the same question twice,
      //go directly to protocol selection.
      goto select_protocol_label;
    }
  }

  //////////////////////////////////////////////////////////////////////
  snprintf(tmp_buff, MAX_PATH_LENGTH, " \"%d\" ", CURRENT_PROTOCOL);
  menu_str += tmp_buff;
  snprintf(tmp_buff, MAX_PATH_LENGTH, " \"Selected Protocol : %s\" ",
    get_protocol_string(linkconf->config_id));
  menu_str += tmp_buff;

  //////////////////////////////////////////////////////////////////////
  if( strcmp(get_protocol_string(linkconf->config_id), INVALID_PROTOCOL) &&
      linkconf->config_id != PROTOCOL_NOT_SET     ){
    //check that protocol is set, before showing the 'configure' options.
    //////////////////////////////////////////////////////////////////////
    snprintf(tmp_buff, MAX_PATH_LENGTH, " \"%d\" ", CONFIGURE_CURRENT_PROTOCOL);
    menu_str += tmp_buff;
    snprintf(tmp_buff, MAX_PATH_LENGTH, " \"Configure Selected Protocol\" ");
    menu_str += tmp_buff;
  }

  snprintf(tmp_buff, MAX_PATH_LENGTH, " \"%d\" ", SELECT_NEW_PROTOCOL);
  menu_str += tmp_buff;
  snprintf(tmp_buff, MAX_PATH_LENGTH, " \"Change Protocol\" ");
  menu_str += tmp_buff;

  snprintf(tmp_buff, MAX_PATH_LENGTH,
    "Select and/or configure a Protocol for Wan Device: %s", cfr->link_defs->name);
  //snprintf(&tmp_buff[strlen(tmp_buff)], MAX_PATH_LENGTH, "%s", MENUINSTR_EXIT);

  if(set_configuration(   YES,//indicates to call V2 of the function
                          MENU_BOX_BACK,
                          lxdialog_path,
                          "PROTOCOL SELECTION/CONFIGURATION",
                          WANCFG_PROGRAM_NAME,
                          tmp_buff,
                          MENU_HEIGTH, MENU_WIDTH,
                          3,//number of items in the menu
                          (char*)menu_str.c_str()
                          ) == NO){
    rc = NO;
    goto cleanup;
  }

  if(show(&selection_index) == NO){
    rc = NO;
    goto cleanup;
  }

  switch(selection_index)
  {
  case MENU_BOX_BUTTON_SELECT:
    Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
     ("option selected: %s\n", get_lxdialog_output_string()));

    *selected_option = atoi(get_lxdialog_output_string());

    switch(*selected_option)
    {
    case CURRENT_PROTOCOL:
      //do nothing here
      goto again;
      break;

    case SELECT_NEW_PROTOCOL:

select_protocol_label:
      rc = handle_protocol_mode_selection();

      Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
        ("handle_protocol_mode_selection() rc: %d\n", rc));

      if(rc == YES){
        goto again;
      }
      break;

    case CONFIGURE_CURRENT_PROTOCOL:
      //display configuration of the protocol
      if(display_protocol_cfg(linkconf->config_id) == YES){
        goto again;
      }
      break;

    default:
      ERR_DBG_OUT(("Invalid option selected for editing!! selection: %s\n",
        get_lxdialog_output_string()));
      rc = NO;
    }
    break;

  case MENU_BOX_BUTTON_HELP:

    switch(atoi(get_lxdialog_output_string()))
    {
    case CURRENT_PROTOCOL:
      //do nothing
      break;

    case CONFIGURE_CURRENT_PROTOCOL:
      tb.show_help_message(lxdialog_path, NO_PROTOCOL_NEEDED,
        "Display/Change Protocol configuration.");
      break;

    case SELECT_NEW_PROTOCOL:
      tb.show_help_message(lxdialog_path, NO_PROTOCOL_NEEDED,
        "Change Communications Protocol.");
      break;

    default:
      tb.show_help_message(lxdialog_path, NO_PROTOCOL_NEEDED, option_not_implemented_yet_help_str);
    }
    goto again;
    break;

  case MENU_BOX_BUTTON_EXIT:
    //exit the dialog
    if(linkconf->config_id == PROTOCOL_NOT_SET){
      tb.show_error_message(lxdialog_path, NO_PROTOCOL_NEEDED,
        "Protocol is NOT selected!!");
      goto again;
    }
    break;
  }

cleanup:
  return rc;
}

int menu_select_and_configure_protocol::handle_protocol_mode_selection()
{
  unsigned int protocol_selected;
  int selection_index;
  wandev_conf_t *linkconf = cfr->link_defs->linkconf;

  //initialize new protocol to the current value.
  protocol_selected = linkconf->config_id;

  menu_protocol_mode_select prot_mode_select(lxdialog_path, cfr);
  if(prot_mode_select.run((int*)&protocol_selected) == NO){
    ERR_DBG_OUT(("Failed to run 'Protocol Select dialog!\n"));
    return NO;
  }

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("old prot: %s\n",
    get_protocol_string(linkconf->config_id) ));

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("new prot: %s\n",
    get_protocol_string(protocol_selected) ));

  //check selected protocol is valid
  if(strcmp(INVALID_PROTOCOL, get_protocol_string(protocol_selected)) == 0){
    ERR_DBG_OUT(("Invalid new protocol selected!!\n"));
    return NO;
  }

  if(protocol_selected == linkconf->config_id){

    //if got here protocol was not changed. do nothing if so.
    Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("Protocol was not changed.\n"));

  }else{

    //if protocol is not set do not ask for confirmation
    if(linkconf->config_id == PROTOCOL_NOT_SET){

      selection_index = YES_NO_TEXT_BOX_BUTTON_YES;

    }else{
      //ask if user *really* want to change the protocol.
      if(yes_no_question(   &selection_index,
                            lxdialog_path,
                            NO_PROTOCOL_NEEDED,
                            "Are you sure you want to change the Protocol/Mode?") == NO){
        //error displaying dialog
        return NO;
      }
    }

    switch(selection_index)
    {
    case YES_NO_TEXT_BOX_BUTTON_YES:

      //read new protocol template file.
      if(handle_protocol_change(protocol_selected) == NO){
        return NO;
      }
      break;

    case YES_NO_TEXT_BOX_BUTTON_NO:
      //not an error, but don't change the Protocol
      return YES;
      break;

    default:
      return NO;
    }
    //FIXME:
    //protocol changed, read the "template" file for the protocol.
    //
    linkconf->config_id = protocol_selected;
  }

  return YES;
}

int menu_select_and_configure_protocol::display_protocol_cfg(IN int protocol)
{
  int rc = YES;
  int selection_index;

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("display_protocol_cfg(): %d\n", protocol));
  switch(protocol)
  {
  case NO_PROTOCOL_NEEDED:
    break;

  case WANCONFIG_X25:
    break;

  case WANCONFIG_FR:
    {
      menu_frame_relay_basic_cfg fr_basic_cfg(lxdialog_path, cfr);
      fr_basic_cfg.run(&selection_index, NULL);
    }
    break;

  case WANCONFIG_PPP:
    {
      menu_ppp_basic_cfg ppp_basic_cfg(lxdialog_path, cfr);
      ppp_basic_cfg.run(&selection_index);
    }
    break;

  case WANCONFIG_CHDLC:
    {
      menu_chdlc_basic_cfg chdlc_basic_cfg(lxdialog_path, cfr);
      chdlc_basic_cfg.run(&selection_index);
    }
    break;

  case WANCONFIG_HDLC:
    {
      menu_hdlc_streaming_configuration hdlc_streaming_configuration(lxdialog_path, cfr);
      hdlc_streaming_configuration.run(&selection_index);
    }
    break;

  case WANCONFIG_BSC:

    break;

  case WANCONFIG_BITSTRM:

    break;

  case WANCONFIG_EDUKIT:

    break;

  case WANCONFIG_SS7:

    break;

  case WANCONFIG_BSCSTRM:

    break;

  case WANCONFIG_ADSL:

    break;

  case WANCONFIG_SDLC:

    break;

  case WANCONFIG_ATM:

    break;

  case WANCONFIG_POS:

    break;

  case WANCONFIG_DEBUG:

    break;

  case WANCONFIG_ADCCP:

    break;

  case WANCONFIG_GENERIC:

    break;

  default:
/*
  case WANCONFIG_AFT:
  case WANCONFIG_MPPP://and WANCONFIG_MPROT too
  case WANCONFIG_MFR:
  case WANCONFIG_MLINK_PPP:
  case WANCONFIG_MPCHDLC:

*/
/*
    {
      menu_frame_relay_basic_cfg fr_basic_cfg(lxdialog_path, cfr);
      //fr_basic_cfg.run_aft_mp_fr_cfg(&selection_index);
      fr_basic_cfg.run(&selection_index);
    }
    break;
*/

    rc = NO;
    break;
  }

  return rc;
}

/*
int menu_select_and_configure_protocol::handle_protocol_change(unsigned int protocol_selected)
{
  int rc = YES;
  //help text box
  text_box tb;

  //1.  read the template file
  //2.  copy everything what has to do with card type and location into
  //    the new 'file_reader' object
  //3.  update wanpipe name to the real one
  //4.  update each interface name to the real one
  cfr_tmp = new conf_file_reader(get_template_file_path(protocol_selected));

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("handle_protocol_change(): 0x%X\n", cfr_tmp));

  //STEP1:
  //read the template file.
  if(cfr_tmp->read_conf_file() != 0){
    tb.show_error_message(lxdialog_path, NO_PROTOCOL_NEEDED,
      "Failed to parse '%s' file!!",
      get_template_file_path(protocol_selected));
    rc = NO;
  }

  //STEP2:
  cfr_tmp->wanpipe_number = cfr->wanpipe_number;
  link_def_t * old_link_def = cfr->link_defs;
  link_def_t * new_link_def = cfr_tmp->link_defs;

  wandev_conf_t * old_linkconf = cfr->link_defs->linkconf;
  wandev_conf_t * new_linkconf = cfr_tmp->link_defs->linkconf;

  new_linkconf->card_type = old_linkconf->card_type;
  new_link_def->card_version = old_link_def->card_version;

  new_linkconf->auto_pci_cfg = old_linkconf->auto_pci_cfg;
  new_linkconf->PCI_slot_no = old_linkconf->PCI_slot_no;
  new_linkconf->pci_bus_no = old_linkconf->pci_bus_no;
  new_linkconf->S514_CPU_no[0] = old_linkconf->S514_CPU_no[0];

  new_linkconf->interface = old_linkconf->interface;
  new_linkconf->bps = old_linkconf->bps;
  memcpy(&new_linkconf->te_cfg, &old_linkconf->te_cfg, sizeof(sdla_te_cfg_t));

  //STEP3:
  //update wanpipe name
  snprintf(new_link_def->name, WAN_DRVNAME_SZ, "%s", old_link_def->name);
  //update default names of each interface
  list_element_chan_def* list_el_chan_def;

  ///////////////////////////////
  //STEP4:
  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("cfr_tmp->wanpipe_number: %d\n", cfr_tmp->wanpipe_number));

  objects_list* obj_list = cfr_tmp->obj_list;
  list_el_chan_def = (list_element_chan_def*)obj_list->get_first();

  /////////////////////////////////////////////////////////////////////////////////
  //FIXIT: AFT only code!!
  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("AFT: protocol : %d\n", list_el_chan_def->data.chanconf->protocol));

  if(list_el_chan_def->data.chanconf->protocol == WANCONFIG_MFR){

    conf_file_reader* local_cfr = (conf_file_reader*)list_el_chan_def->conf_file_reader;
    if(local_cfr != NULL){

      list_element_chan_def* local_list_el_chan_def =
        (list_element_chan_def*)local_cfr->obj_list->get_first();

      if(list_el_chan_def != NULL){
        strcpy(list_el_chan_def->data.aft_dlci_number, local_list_el_chan_def->data.addr);
      }else{
        ERR_DBG_OUT(("Failed to initialize 'aft_dlci_number'(2)!!"));
        return NO;
      }
    }else{
      ERR_DBG_OUT(("Uninitialized per-AFT-logical channel 'conf_file_reader' pointer!!"));
      return NO;
    }
  }//if(list_el_chan_def->data.chanconf->protocol == WANCONFIG_MFR)
  /////////////////////////////////////////////////////////////////////////////////

  //interface counter starting from 0. usage dependes on protocol.
  int if_counter = 0;
  while(list_el_chan_def != NULL){

    if(update_interface_name( list_el_chan_def,
                              new_link_def->config_id,
                              cfr_tmp->wanpipe_number) == NO){
      rc = NO;
      break;
    }

    list_el_chan_def = (list_element_chan_def*)obj_list->get_next_element(list_el_chan_def);

    if_counter++;
  }//while()
  //////////////////////////////

  //delete the old configuration
  delete cfr;

  //replace with the new pointer
  *ptr_cfr = cfr_tmp;
  cfr = cfr_tmp;
  return rc;
}
*/

int menu_select_and_configure_protocol::handle_protocol_change(unsigned int protocol_selected)
{
  int rc = YES;
  //help text box
  text_box tb;
  objects_list* obj_list;
  list_element_chan_def* list_el_chan_def;

  ////////////////////////////////////////////////////////////////////////////////////////
  //1.  read the template file
  //2.  copy everything what has to do with card type and location into
  //    the new 'file_reader' object
  //3.  update wanpipe name to the real one
  //4.  update each interface name to the real one
  cfr_tmp = new conf_file_reader(get_template_file_path(protocol_selected));

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("handle_protocol_change(): 0x%X\n", cfr_tmp));

  //STEP1:
  //read the template file.
  if(cfr_tmp->read_conf_file() != 0){
    tb.show_error_message(lxdialog_path, NO_PROTOCOL_NEEDED,
      "Failed to parse '%s' file!!",
      get_template_file_path(protocol_selected));
    rc = NO;
  }
  ////////////////////////////////////////////////////////////////////////////////////////
  //STEP2:
  cfr_tmp->wanpipe_number = cfr->wanpipe_number;
  link_def_t * old_link_def = cfr->link_defs;
  link_def_t * new_link_def = cfr_tmp->link_defs;

  wandev_conf_t * old_linkconf = cfr->link_defs->linkconf;
  wandev_conf_t * new_linkconf = cfr_tmp->link_defs->linkconf;

  new_linkconf->card_type = old_linkconf->card_type;
  new_link_def->card_version = old_link_def->card_version;

  //????
  //new_link_def->config_id = protocol_selected;

  new_linkconf->auto_pci_cfg = old_linkconf->auto_pci_cfg;
  new_linkconf->PCI_slot_no = old_linkconf->PCI_slot_no;
  new_linkconf->pci_bus_no = old_linkconf->pci_bus_no;
  new_linkconf->S514_CPU_no[0] = old_linkconf->S514_CPU_no[0];

  new_linkconf->comm_port = old_linkconf->comm_port;

  //S508
  new_linkconf->ioport = old_linkconf->ioport;
  new_linkconf->irq = old_linkconf->irq;
  new_linkconf->maddr = old_linkconf->maddr;

  new_linkconf->interface = old_linkconf->interface;
  new_linkconf->bps = old_linkconf->bps;
  memcpy(&new_linkconf->te_cfg, &old_linkconf->te_cfg, sizeof(sdla_te_cfg_t));

  //STEP3:
  //update wanpipe name
  snprintf(new_link_def->name, WAN_DRVNAME_SZ, "%s", old_link_def->name);
  //update default names of each interface

  ////////////////////////////////////////////////////////////////////////////////////////
  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL,
    ("cfr->link_defs->config_id: %d\n",  cfr->link_defs->config_id));
  obj_list = cfr_tmp->obj_list;

  //DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL
  if(cfr_tmp->link_defs->config_id == WANCONFIG_AFT){
  //check for LIP layer

pointer_not_valid_anymore:
    list_el_chan_def = (list_element_chan_def*)obj_list->get_first();
    while(list_el_chan_def != NULL){

      if(menu_list_existing_wanpipes::check_for_LIP_layer(list_el_chan_def, obj_list) == YES){
        goto pointer_not_valid_anymore;
      }else{
        list_el_chan_def = (list_element_chan_def*)obj_list->get_next_element(list_el_chan_def);
      }
    }//while()

    ///////////////
    //print channels obj_list
    Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("objects in the list: \n"));

    list_el_chan_def = (list_element_chan_def*)obj_list->get_first();
    while(list_el_chan_def != NULL){
      Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("list_el_chan_def->data.name: %s\n",  list_el_chan_def->data.name));

      {
        if(list_el_chan_def->conf_file_reader == NULL){
          list_el_chan_def = (list_element_chan_def*)obj_list->get_next_element(list_el_chan_def);
          continue;
        }

        objects_list* sub_obj_list =
          ((conf_file_reader*)list_el_chan_def->conf_file_reader)->obj_list;

        if(sub_obj_list == NULL){
          Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("sub_obj_list == NULL !!!\n"));
          list_el_chan_def = (list_element_chan_def*)obj_list->get_next_element(list_el_chan_def);
          continue;
        }

        list_element_chan_def* sub_list_el_chan_def =
          (list_element_chan_def*)sub_obj_list->get_first();

        Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("sublist:\n"));

        while(sub_list_el_chan_def != NULL){
          Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("sub_list_el_chan_def->data.name: %s\n",
            sub_list_el_chan_def->data.name));

          sub_list_el_chan_def =
            (list_element_chan_def*)sub_obj_list->get_next_element(sub_list_el_chan_def);
        }
      }

      list_el_chan_def = (list_element_chan_def*)obj_list->get_next_element(list_el_chan_def);
    }//while()
    //////////////

    menu_list_existing_wanpipes::reduce_aft_channel_groups_numbers(cfr_tmp);
  }//if()

  /////////////////////////////////////////////////////////////////////////////////
  list_el_chan_def = (list_element_chan_def*)obj_list->get_first();

//  if(cfr_tmp->link_defs->config_id != WANCONFIG_AFT){
  //interface counter starting from 0. usage dependes on protocol.
  int if_counter = 0;
  while(list_el_chan_def != NULL){

    Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("new_link_def->config_id: %d\n",
      new_link_def->config_id));

    if(update_interface_name( list_el_chan_def,
                              new_link_def->config_id,
                              cfr_tmp->wanpipe_number) == NO){
      rc = NO;
      break;
    }

    list_el_chan_def = (list_element_chan_def*)obj_list->get_next_element(list_el_chan_def);

    if_counter++;
  }//while()
//  }//if()

  Debug(DBG_MENU_SELECT_AND_CONFIGURE_PROTOCOL, ("cfr_tmp->link_defs->config_id: %d\n",
    cfr_tmp->link_defs->config_id));

  if(cfr_tmp->link_defs->config_id == WANCONFIG_AFT ){

    menu_list_existing_wanpipes::update_per_group_of_channels_iformation(cfr_tmp);
  }

  /////////////////////////////////////////////////////////////////////////////////
  //delete the old configuration
  delete cfr;

  //replace with the new pointer
  *ptr_cfr = cfr_tmp;
  cfr = cfr_tmp;
  return rc;
}
