#ifndef __XILINX_CPLD_H
# define __XILINX_CPLD_H


#define MEMORY_TYPE_SRAM	0x00
#define MEMORY_TYPE_FLASH	0x01
#define MASK_MEMORY_TYPE_SRAM	0x10
#define MASK_MEMORY_TYPE_FLASH	0x20

#define DEF_SECTOR_FLASH	0x00
#define USER_SECTOR_FLASH	0x01
#define MASK_DEF_SECTOR_FLASH	0x00
#define MASK_USER_SECTOR_FLASH	0x04

unsigned int write_cpld(unsigned short cpld_off,unsigned short cpld_data);
unsigned int read_cpld(unsigned short cpld_off);
unsigned char read_flash(int, int, unsigned long);
unsigned int write_flash(int, int, unsigned long,unsigned char);
int led_test(void);
int reset_flash(void);
int update(int, int, char*);
int check_flash_id(int, int, int*);
int prg_flash_byte(int sector_type, unsigned long off32, unsigned char data);
int erase_sector_flash(int sector_type, int);
int chip_erase(int, int);
int update_man(int memory_type, char* filename);
int verify(int sector_type, int memory_type, char* filename);
#endif
