/* $Header: /usr/local/cvsroot/wanpipe_linux/code/include/annexg/wanpipe_x25.h,v 1.9 2004/02/11 17:53:02 sangoma Exp $ */

#ifndef _WANPIPE_X25_HEADER_
#define _WANPIPE_X25_HEADER_

#ifdef __KERNEL__

#include <linux/wanpipe_cfg.h>
#include <linux/wanpipe_debug.h>
#include <linux/wanpipe_defines.h>
#include <linux/wanpipe_common.h>
#include <linux/wanpipe_snmp.h>
#include <linux/wanproc.h>
#include <linux/wanpipe_x25_kernel.h>
#include <linux/wanpipe_lapb_kernel.h>

/*
 ***********************************************************************************
 *																			                          *
 * X25HDR.C is the 'C' header file for the Sangoma X.25 code for the S508 adapter. *
 *																				                       *
 ***********************************************************************************
*/

#define X25_OK  0
#define TX_TIMEOUT 45
#define TCPIP 0 
#define API   1

#define MAX_CALL_REQ_ASYNC_PKT 512

#define NON_D_OPT 3
#define D_OPT 2

#define FLOW_CONTROL_MASK  0x1F

#define ONE_BYTE 1
#define MAX_TOKENS 31

#define IS_PVC(x25_lcn) test_bit(LCN_CONFIG_PVC,&x25_lcn->lcn_config)

/* BH flags */
enum{
	BH_RUNNING,
	RX_FSM_RUNNING,
	SMP_CONFLICT,
	BH_AWAITING_KICK,
	LINK_TIMER_EXPIRED,
	MORE_LCN_TX,
	LINK_DOWN
};


/* LCN Critical */
enum {
	TX_WINDOW_CLOSED,
	IF_SEND_AWAITING_KICK,
	LCN_TIMER_EXPIRED,
	LCN_DOWN,
	LCN_UNREGISTER,
	LCN_RX,
	IOCTL_SMP,
	LCN_SENDING
};

#define MAX_RX_FACIL_CODE 30

#define BH_DEBUG 0

#define SOFT_INIT 0
#define HARD_INIT 1

/*
 * $Log: wanpipe_x25.h,v $
 * Revision 1.9  2004/02/11 17:53:02  sangoma
 * *** empty log message ***
 *
 * Revision 1.8  2003/12/16 17:17:54  sangoma
 * *** empty log message ***
 *
 * Revision 1.7  2003/10/30 16:18:51  sangoma
 * *** empty log message ***
 *
 * Revision 1.6  2003/10/08 20:55:37  sangoma
 * *** empty log message ***
 *
 * Revision 1.5  2003/09/04 17:50:43  sangoma
 * *** empty log message ***
 *
 * Revision 1.4  2003/07/18 22:05:23  sangoma
 * *** empty log message ***
 *
 * Revision 1.3  2003/07/17 17:06:18  sangoma
 * *** empty log message ***
 *
 * Revision 1.2  2003/05/26 10:51:49  ncorbic
 * *** empty log message ***
 *
 * Revision 1.1  2003/03/27 06:33:47  ncorbic
 * *** empty log message ***
 *
 * Revision 1.14  2002/12/06 02:43:37  ncorbic
 * *** empty log message ***
 *
 * Revision 1.13  2002/03/12 22:08:48  ncorbic
 * *** empty log message ***
 *
 * Revision 1.12  2002/02/06 15:43:16  ncorbic
 * *** empty log message ***
 *
 * Revision 1.11  2001/10/22 09:30:18  ncorbic
 * *** empty log message ***
 *
 * Revision 1.10  2001/10/18 05:28:20  ncorbic
 * *** empty log message ***
 *
 * Revision 1.9  2001/10/16 07:21:02  ncorbic
 * *** empty log message ***
 *
 * Revision 1.8  2001/10/16 05:18:32  ncorbic
 * *** empty log message ***
 *
 * Revision 1.7  2001/10/15 04:52:19  ncorbic
 * *** empty log message ***
 *
 * Revision 1.6  2001/10/15 02:39:45  ncorbic
 * *** empty log message ***
 *
 * Revision 1.5  2001/09/13 08:13:21  ncorbic
 * *** empty log message ***
 *
 * Revision 1.4  2001/09/05 02:58:54  ncorbic
 * *** empty log message ***
 *
 * Revision 1.3  2001/08/31 02:58:58  ncorbic
 * *** empty log message ***
 *
 * Revision 1.2  2001/08/24 09:54:03  ncorbic
 * *** empty log message ***
 *
 * Revision 1.1.1.1  2001/08/08 06:54:09  ncorbic
 * Creating Annexg
 *
 * Revision 1.22  2001/08/01 08:25:18  ncorbic
 * *** empty log message ***
 *
 * Revision 1.21  2001/07/17 06:09:30  ncorbic
 * *** empty log message ***
 *
 * Revision 1.20  2001/07/16 10:46:51  ncorbic
 * *** empty log message ***
 *
 * Revision 1.19  2001/07/06 22:29:45  ncorbic
 * *** empty log message ***
 *
 * Revision 1.18  2001/07/06 20:16:38  ncorbic
 * *** empty log message ***
 *
 * Revision 1.17  2001/07/05 21:51:51  ncorbic
 * *** empty log message ***
 *
 * Revision 1.16  2001/07/04 21:08:52  ncorbic
 * *** empty log message ***
 *
 * Revision 1.15  2001/07/04 18:47:13  ncorbic
 * *** empty log message ***
 *
 * Revision 1.14  2001/06/28 22:23:42  ncorbic
 *
 *
 * The x25_link was being inserted multiple times, causing a link list
 * loop.  Luckily it didn't crash :)  It is not fixed.
 *
 * Revision 1.13  2001/06/28 15:59:11  ncorbic
 *
 *
 *
 * Shutdown bug fix: On unregister, the initialize_lcn funciton
 * did not stop the timers because NOT_IN_ABM state was higher
 * than the RESET state, for which the timers should not
 * be turned off for.
 *
 * Revision 1.12  2001/06/26 21:22:57  ncorbic
 * *** empty log message ***
 *
 * Revision 1.11  2001/06/26 00:00:11  ncorbic
 * *** empty log message ***
 *
 * Revision 1.10  2001/06/25 18:42:18  ncorbic
 * *** empty log message ***
 *
 * Revision 1.9  2001/06/25 18:30:39  ncorbic
 * *** empty log message ***
 *
 * Revision 1.8  2001/06/22 17:47:36  ncorbic
 * *** empty log message ***
 *
 * Revision 1.7  2001/06/22 15:01:54  ncorbic
 * *** empty log message ***
 *
 * Revision 1.6  2001/06/21 21:20:08  ncorbic
 * *** empty log message ***
 *
 * Revision 1.5  2001/06/20 17:55:16  ncorbic
 * *** empty log message ***
 *
 * Revision 1.4  2001/06/20 16:24:50  ncorbic
 * *** empty log message ***
 *
 * Revision 1.3  2001/06/19 23:06:24  ncorbic
 *
 *
 *
 * API Started to work, I can receive data now.
 *
 * Revision 1.2  2001/06/18 18:33:34  ncorbic
 * *** empty log message ***
 *
 * 
 * 
 * 
 */

/*
 * X25 Frame Header
 */
typedef struct x25_frame{
	unsigned char gfi;
	unsigned int  lcn;
	unsigned long type;
	unsigned char cause;
	unsigned char diag;
	unsigned int len;
	unsigned char Ps_count;
	unsigned char Pr_count;
	unsigned char mbit;
} x25_frame_t;


struct x25_prot_stats{
	unsigned int rx_call_req;
	unsigned int rx_call_acpt;
	unsigned int rx_clear_req;
	unsigned int rx_clear_conf;
	unsigned int rx_data_pkt;
	unsigned int rx_rr;
	unsigned int rx_rnr;
	unsigned int rx_rej;
	unsigned int rx_intr_req;
	unsigned int rx_intr_conf;
	unsigned int rx_reset_req;
	unsigned int rx_reset_conf;
	unsigned int rx_restrt_req;
	unsigned int rx_restrt_conf;
	unsigned int rx_diag;
	unsigned int rx_reg_req;
	unsigned int rx_reg_conf;
	unsigned int rx_total;
	unsigned int rx_ill;
	
	unsigned int tx_call_req;
	unsigned int tx_call_acpt;
	unsigned int tx_clear_req;
	unsigned int tx_clear_conf;
	unsigned int tx_data_pkt;
	unsigned int tx_rr;
	unsigned int tx_rnr;
	unsigned int tx_rej;
	unsigned int tx_intr_req;
	unsigned int tx_intr_conf;
	unsigned int tx_reset_req;
	unsigned int tx_reset_conf;
	unsigned int tx_restrt_req;
	unsigned int tx_restrt_conf;
	unsigned int tx_diag;
	unsigned int tx_reg_req;
	unsigned int tx_reg_conf;
	unsigned int tx_total;
	unsigned int tx_ill;
};


/*
 * Physical X25 Link
 * Each Link can support multiple logical
 * channels (svc).
 */
#define MAX_LCN 255
#define MAX_DECODE_BUF_SZ 1000
#define MAX_PROC_NAME 10

#ifndef MAX_PROC_EVENTS
#define MAX_PROC_EVENTS 20
#endif
#define MAX_PROC_EVENT_SIZE X25_CALL_STR_SZ+200+1

#undef X25_PUT_HOLD_DEBUG
#ifndef X25_PUT_HOLD_DEBUG
#define X25_HOLD(x25)  atomic_inc(&(x25)->refcnt)
#define X25_PUT(x25)   atomic_dec(&(x25)->refcnt)
#else
#define X25_HOLD(x25)  {atomic_inc(&(x25)->refcnt);\
			printk(KERN_INFO "%s: %i : HOLD %i\n",__FILE__,__LINE__,atomic_read(&(x25)->refcnt)); }

#define X25_PUT(x25)   {atomic_dec(&(x25)->refcnt); \
			printk(KERN_INFO "%s: %i : PUT %i\n",__FILE__,__LINE__,atomic_read(&(x25)->refcnt)); }
#endif
			
typedef struct x25_link{
	
	struct x25_link *next;

	struct net_device *master;
	struct net_device *dev_list;

	unsigned int dev_cnt;
	
	struct x25_parms_struct cfg;
	unsigned char state;
	unsigned char incoming_call_handling;

	/* Internal control information */
	struct sk_buff_head async_queue;
	struct sk_buff_head rx_queue;
	
	/* Restart Request Retx timer */
	struct timer_list T10_T20_timer;
	unsigned int T10_T20_timer_cnt;
	
	/* Registration Request Retx timer*/
	struct timer_list T28_timer;
	unsigned int T28_timer_cnt;
	
	struct tasklet_struct x25_rx_task;
	struct tasklet_struct x25_task;
	unsigned long tq_working;
	
	rwlock_t map_lock;	
	rwlock_t dev_list_lock; 
	spinlock_t bh_lock;

	struct net_device *tx_dev;

	void *api_sk_id;
	void *dsp_sk_id;

	unsigned int no_diff_facilty_codes_received;
	unsigned int non_X25_facilities_received;
	unsigned char list_received_facilty_codes[MAX_RX_FACIL_CODE];
	
	/* Proc file enteries for each x25 link */
	struct proc_dir_entry *proc_dir;
	unsigned char name [MAX_PROC_NAME];

	/* Interface and protocol statistics */
	struct x25_prot_stats x25stats;

	unsigned int kick_cnt;

	struct net_device *lcn_to_dev_map[MAX_LCN];

	/* X.25 switching */
	unsigned char virtual_addr[WAN_ADDRESS_SZ+1];
	unsigned char real_addr[WAN_ADDRESS_SZ+1];

	unsigned char *proc_event_log [MAX_PROC_EVENTS];
	atomic_t  proc_event_offset;
	
	long link_num;
	atomic_t bh_time;
	atomic_t bh_time_max;
	atomic_t refcnt;
} x25_link_t;


/* 
 * The logical channel status and configuration structure 
 * 
 * Note - when working with this structure, we must be very careful. 
 * 	This is because we have written some of the 
 * 	structure references in assembler and so the offsets of the 
 * 	various	variables within this structure must be constant.
 *
 * 	the 'config' byte is formatted as follows: 
 *
 *		bits 3, 2, 1 and 0 denote the channel configuration as follows:
 *			0  0  0  0  (0x00) -> not allocated  (bit 0 reset)
 *			0  0  0  1  (0x01) -> PVC (bit 1 set)
 *			0  0  1  1  (0x03) -> incoming  --
 *			0  1  1  1  (0x07) -> two-way	----| (bit 2 set denotes an SVC)
 *			1  0  1  1  (0x0B) -> outgoing  --
 *
 *		bit 5 denotes the D-bit pragmatics for the SVC:
 *		  if set, then D-bit usage has been negotiated in call setup
 *
 *		bits 7, 6 denote the Fast Select permissions for the LCN as follows:
 *		  0  0 -> Fast Select not requested
 *		  0  1 -> Fast Select not requested
 *		  1  0 -> Fast Select requested with no restriction on response
 *		  1  1 -> Fast Select requested with restriction on response
 *
 *	Both the 'Rx_win_pkt_size' and the 'Tx_win_pkt_size' 
 *	variables are set as follows:
 * 
 *		bits 0, 1, 2, 3 -> packet window (0 to 7)
 *		bits 4, 5, 6, 7 -> packet size as per ISO 8208:
 *		 0x04 -> 16
 *		 0x05 -> 32
 *		 0x06 -> 64
 *		 0x07 -> 128
 *		 0x08 -> 256
 *		 0x09 -> 512
 *		 0x0A -> 1024
 *		 0x0B -> 2048
 *		 0x0C -> 4096
 *
 *		 These two bytes must be kept in this order for window 
 *		 and packet negotiation.
 *	
 */
typedef struct {

	unsigned char lcn_config;
	unsigned char dbit_config;
	unsigned char fastselect_config;

	unsigned char state;		
	
	/* P(R) variables - the high 4 bits are used for Pr_ack and the */
	/* low 4 bits are used for Pr_count */
	unsigned char Pr_ack;
	unsigned char Pr_count;
	
	/* P(S) variables - the high 4 bits are used for Ps_ack and the */
	/* low 4 bits are used for Ps_count */
	unsigned char Ps_ack;
	unsigned char Ps_count;

	unsigned char rx_window_size;
	unsigned char rx_pkt_size;
		
	unsigned char tx_window_size;
	unsigned char tx_pkt_size;
		
	/* a bit mapping for recording which transmitted Data packets */
	/* have been acknowledged */
	unsigned char misc_status_bits;
	unsigned short LCN;

} LCN_CFG_STATUS_STRUCT;

#define CALL_REQUEST_INFO_SZ 512


/*
 *	The per X25 connection control structure.
 */
typedef struct {
	
	struct net_device 	*next;
	
	unsigned long		critical;
	
	/* Internal control information */
	struct sk_buff_head	write_queue;
	struct sk_buff_head	async_queue;

	/* X25 Modulo mode 1=8 or 2=128 */
	unsigned char mode;
	unsigned char usedby;
	
	/* LCN Configuration 
	 * 	the 'config' byte is formatted as follows: 
 	 *
 	 *	bits 3, 2, 1 and 0 denote the channel configuration as follows:
 	 *		0  0  0  0  (0x00) -> not allocated  (bit 0 reset)
 	 *		0  0  0  1  (0x01) -> PVC (bit 1 set)
 	 *		0  0  1  1  (0x03) -> incoming  --
 	 *		0  1  1  1  (0x07) -> two-way	----| (bit 2 set denotes an SVC)
 	 *		1  0  1  1  (0x0B) -> outgoing  --
 	 *
 	 *	bit 5 denotes the D-bit pragmatics for the SVC:
	 *	  if set, then D-bit usage has been negotiated in call setup
 	 *
 	 *	bits 7, 6 denote the Fast Select permissions for the LCN as follows:
 	 *	  0  0 -> Fast Select not requested
 	 *	  0  1 -> Fast Select not requested
 	 *	  1  0 -> Fast Select requested with no restriction on response
 	 *	  1  1 -> Fast Select requested with restriction on response
	 *
	 *	bit 8 indicates that window/packet facilites were 
	 *	      subscribed by the incoming call.
	 */	  

	unsigned int config;
	unsigned char state;		
	
	/* P(R) variables - the high 4 bits are used for Pr_ack and the */
	/* low 4 bits are used for Pr_count */
	volatile unsigned char Pr_ack;
	volatile unsigned char Pr_count;
	
	/* P(S) variables - the high 4 bits are used for Ps_ack and the */
	/* low 4 bits are used for Ps_count */
	volatile unsigned char Ps_ack;
	volatile unsigned char Ps_count;

	unsigned char rx_window_size;
	unsigned int rx_pkt_size;
		
	unsigned char tx_window_size;
	unsigned int tx_pkt_size;
	
	/* a bit mapping for recording which transmitted Data packets */
	/* have been acknowledged */
	unsigned char misc_status_bits;
	atomic_t lcn;

	struct timer_list T11_T21_timer;
	struct timer_list T12_T22_timer;
	struct timer_list T13_T23_timer;	
 	struct timer_list T16_T26_timer;	
	
 	unsigned int R12_R22;			
 	unsigned int R13_R23;
	unsigned int R15_R25;
	unsigned int R17_R27;

	unsigned int T11_T21_timer_cnt;
	unsigned int T12_T22_timer_cnt;
	unsigned int T13_T23_timer_cnt;	
 	unsigned int T16_T26_timer_cnt;	
	
	/* FRMR control information */
	struct x25_frame	frmr_data;
	unsigned char		frmr_type;
	
	/* Current device */
	struct net_device	*dev;

	/* The link we are part of */
	x25_link_t 		*x25_link;
	
	/* Transmit device */
	struct net_device 	*tx_dev;

	void *sk_id;
	unsigned long api_state;

	x25api_t x25_api_event;
	x25api_hdr_t x25_api_cmd_hdr;
	x25api_hdr_t x25_api_tx_hdr;

	unsigned char call_string   [X25_CALL_STR_SZ+1];	
	
	/* Accept Call Information */
	unsigned char accept_called [WAN_ADDRESS_SZ+1];
	unsigned char accept_calling[WAN_ADDRESS_SZ+1];
	unsigned char accept_facil  [WAN_ADDRESS_SZ+1];
	unsigned char accept_udata  [WAN_ADDRESS_SZ+1];

	unsigned char label  [WAN_IF_LABEL_SZ+1];
	unsigned char dlabel  [WAN_IF_LABEL_SZ+1];

	unsigned char rr_data_toggle;
	struct proc_dir_entry *dent;

	struct net_device_stats ifstats;

	/* DSP_20 */
	void* dsp_id;

	unsigned long call_backoff;
	unsigned int  call_backoff_timeout;

	/* X25_SW X.25 switching */
	void* x25_sw_lcn;
	volatile unsigned char 	sw_Pr_count;

	spinlock_t lcn_lock;
	unsigned long used;

	atomic_t  refcnt;
	pid_t	  pid;

	/* PVC or SVC */
	unsigned long lcn_config;
} x25_lcn_t;



/* =================================================
 * logical channel configuration 
 * denoted in the low 4 bits of the 'lcn_config' byte 
 * =================================================
 */

/* the LCN is not configured */
#define LCN_NOT_CONFIGURED			0x00
/* the LCN is configured (bit 0 set) */
#define LCN_CONFIGURED				0x01		
/* the LCN is configured as a PVC */
#define LCN_CONFIG_PVC				0x01		
/* the LCN is configured as a SVC (all SVC's have bit 1 set) */
#define LCN_CONFIG_SVC				0x02

/* the LCN is configured as a one-way incoming SVC */
#define LCN_CONFIG_INCOMING_ONLY		0x03

/* the LCN is configured as a two-way SVC */
#define LCN_CONFIG_TWO_WAY			0x07		
/* the LCN is configured as a one-way outgoing SVC */
#define LCN_CONFIG_OUTGOING_ONLY 		0x0B
/* the LCN is configured as a two-way or outgoing SVC */
#define LCN_CONFIG_TWO_WAY_OR_OUTGOING 		0x0C
/* a bit mask to only include the LCN configuration bits */
#define LCN_CONFIG_BITS_MASK			0x0F		

/* ==========================================
 * 'dbit_config' byte 
 * ==========================================
 */

/* a bit set if D-bit pragmatics are supported for an SVC */
#define D_BIT_PRAGMATICS_FOR_SVC		0x01

/* ==========================================
 * 'fastselect_config' byte 
 * ==========================================
 */

/* a bit set if fast select has been initiated */
#define FAST_SEL_REQUESTED			0x01		
/* bit setting if fast select (no restriction on response) has 
 * been initiated */
#define FAST_SEL_NO_RESTR_ON_RESP		0x01									
/* bit setting if fast select (restriction on response) has been 
 * initiated*/
#define FAST_SEL_WITH_RESTR_ON_RESP		0x02		
/* a bit set if fast select (restriction on response) has been
 * initiated */
#define FAST_SEL_RESTR_ON_RESP_BIT_SET		0x04		


#define INCOMING_PKT_WIN_FACILS			0x100


/* =============================================
 * bit settings in the 'Tx_win_pkt_size'  and 
 * 'Rx_win_pkt_size' byte 
 * =============================================
 */

/* a mask to include the packet size */
#define TX_RX_PKT_SIZE_MASK			0x0F
/* mask for the packet window size */
#define WINDOW_SIZE_DEFINITION_MASK		0x07
/* mask for the packet size */
#define PACKET_SIZE_DEFINITION_MASK		0xF0		



/* ================================================
 * bit settings for the 'misc_status_bits' byte 
 * NB - we must not define a value with the high bit 
 *      set, as this will conflict with the logic 
 *      used in the procedure 
 *
 * 'set_LCN_misc_status_bits()'
 * =============================================
 */

/* the network is down */
#define NETWORK_DOWN				0x01
/* an RNR has been received on the LCN */
#define RNR_RX_ON_LCN				0x02
/* a D-bit packet has been received */
#define D_BIT_DATA_PKT_RX			0x04
/* a D-bit packet has been transmitted */
#define D_BIT_DATA_PKT_TX			0x08		


/* ======================================================
 * definitions for receiving X.25 Data packets 
 * 
 * Note - we have an incoming Data packet storage area 
 *        of 12288 bytes. If, for example, we defined a 
 *        maximum packet size of 128 bytes, we could 
 *        store 96 Data packets. However, we limit 
 *        ourselves to fewer receive buffers to save on
 *	  linked list space.
 * ======================================================	  
 */

/* ========================================
 * X.25 states used by the state machine 
 * ========================================
 */

/* state r1 */
#define X25_ST_PKT_LVL_RDY_R1			1

/* state r2 */
#define X25_ST_RESTART_REQ_SNT_R2		2
/* state r3 */
#define X25_ST_RESTART_REQ_REC_R3		3

/* state p1 */
#define X25_ST_PKT_LVL_RDY_P1		        4	


/* state p2 */
#define X25_ST_CALL_REQ_SNT_P2			5	
/* state p3 */
#define X25_ST_CALL_REQ_REC_P3			6

/* state p4 (given value 0x00 for speed through state machines) */
#define X25_ST_DATA_TRANSFER_P4			0		

/* state p5 */
#define X25_ST_CALL_COLLISION_P5		7
/* state p6 */
#define X25_ST_CLEAR_REQ_SNT_P6			8
/* state p7 */
#define X25_ST_CLEAR_REQ_REC_P7			9

/* state d1 */
#define X25_ST_PKT_LVL_RDY_D1			X25_ST_DATA_TRANSFER_P4
/* state d2 */
#define X25_ST_RESET_REQ_SNT_D2			11
/* state d3 */
#define X25_ST_RESET_REQ_REC_D3			12

/* state i1 */
#define X25_ST_PKT_LVL_RDY_I1			X25_ST_DATA_TRANSFER_P4
/* state i2 */
#define X25_ST_INTERRUPT_SNT_I2			14
/* state i3 */
#define X25_ST_INTERRUPT_REC_I3			15

/* state for an out of order PVC */
#define X25_ST_PVC_OUT_OF_ORDER			0xFD
/* state for all LCNs when the HDLC link is not in the ABM */
#define X25_ST_HDLC_NOT_IN_ABM			0xFE
/* state for an unused LCN structure */
#define X25_ST_FOR_UNUSED_LCN_STR		0xFF	




/* X.25 packet errors */
#define PKT_TYPE_SHORT_LCN_0		0
#define PKT_TYPE_SHORT_LCN_X		1
#define PKT_TYPE_UNDEF_LCN_0    	2
#define PKT_TYPE_UNDEF_LCN_X		3



/* we define an X25 packet type which is not a 
 * valid packet, but is used in checking received 
 * packet lengths */
#define NO_SPECIFIC_PKT_TYPE 			0x33		


/* ==========================================================================
 * X.25 states when transmitting/receiving packets 
 * NB - some of these values must be bit mapped to the 
 * 	'response options' variable. This is done so as to easily
 * 	decide whether or not an automatic response to an incoming 
 * 	frame should be generated in the 'handle_auto_resp_prot_vio_TO()' 
 * 	procedure. Also, we also use three constants (SENDING_CLEAR_REQUEST,
 * 	SENDING_RESET_REQUEST and SENDING_RESTART_REQUEST) as the 
 * 	'X25_packet_type' when reporting protocol violations.
 * =========================================================================	
*/
#define SENDING_CLEAR_CONF			0x02
#define SENDING_RESET_CONF			0x04
#define SENDING_RESTART_CONF			0x08
#define SENDING_INTERRUPT_CONF			0x10
#define SENDING_REGISTRATION_CONF		0x20
#define SENDING_CALL_REQUEST			0x30
#define SENDING_CALL_ACCEPT			0x31
#define SENDING_CLEAR_REQUEST			0x32
#define SENDING_RESET_REQUEST			0x33
#define SENDING_RESTART_REQUEST			0x34
#define SENDING_INTERRUPT			0x35
#define SENDING_REGISTRATION_REQUEST	 	0x36
#define SENDING_DIAGNOSTIC			0x37
/* awaiting an incoming packet */
#define AWAIT_INCOMING_PKT			0x80

#define X25_HEADER_LEN				0x03	
#define LGTH_X25_PACKET_HEADER			0x03	/* the length of the X.25 packet header */
#define LGTH_X25_PKT_HDR_CSE_DIAG_FLDS		0x05	/* the length of the X.25 packet header 
							   plus the cause and */

/* the length of the X.25 packet header plus 
 * the cause and diagnostic fields */
#define LGTH_X25_PKT_HDR_CSE_DIAG_FLDS		0x05

/* the offset of the data area within an X.25 packet */
#define OFF_DATA_AREA_IN_X25_DATA_PKT		0x03		

/* mask to read the M-bit */
#define M_BIT_SET_IN_DATA_PKT		  	0x10		

/* a mask to remove the GFI bits from the LCN high nibble */
#define MASK_GFI_FROM_LCN_ID_HIGH_BITS 		0x0F

/* a mask to remove the high four bits from the LCN */
#define MASK_OUT_HIGH_4_BITS_FROM_LCN		0x00FF	

/* the offset of the diagnostic field within the packet data area */
#define OFF_DIAG_FLD_IN_PKT_DATA_AREA 		0x01

#define MOD8_CONFIG				0x01

/* a GFI for a MOD 8 packet */
#define GFI_MOD_8_BIT_SET			0x01		
#define GFI_FOR_MOD_8				0x01
#define MOD8_MODULUS				8

/* a GFI for a MOD 128 packet */
#define GFI_MOD_128_BIT_SET			0x02
#define GFI_FOR_MOD_128				0x02	
#define MOD128_MODULUS				128

#define QOFF_DOFF				0x00
#define QBIT_SET				0x02
#define DBIT_SET				0x01

#define GFI_WITH_Q_BIT_SET			0x08	/* a GFI with the Q-bit set */
#define GFI_WITH_D_BIT_SET			0x04	/* a GFI with the D-bit set */

#define Q_D_BITS_SET_IN_GFI			0x0C	/* a GFI with the Q and D-bits set */

#define GFI_Q_D_MOD_128_BITS 			0x0E	/* a MOD 128 GFI with the Q and D-bits set */


#define OFF_CAUSE_FLD_X25_PKT			0x03	/* the offset of the cause field within 
							   an X.25 packet */
#define OFF_DIAG_FLD_X25_PKT			0x04	/* the offset of the diagnostic field 
							   within an X.25 packet */
#define OFF_DIAG_CODE_IN_DIAG_PKT		0x00	/* the offset of the diagnostic code 
							   within a dignostic packet */
#define OFF_DIAG_EXPL_IN_DIAG_PKT		0x01	/* the offset of the diagnostic explanation 
							   field within a dignostic packet */
#define LGTH_DIAG_EXPL_FIELD			0x03	/* the length of the diagnostic 
							   explanation field */
#define LGTH_DIAG_DATA_FIELD			0x04	/* the total length of the data field 
							   in a diagnostic packet */
#define OFF_CALLING_LGTH_IN_ASY_PKT		0x00	/* the offset of the calling address length */
#define OFF_CALLED_LGTH_IN_ASY_PKT		0x01	/* the offset of the called address length */
#define MAX_CALL_ADDR_LGTH_SEMI_OCT		15	/* the maximum permitted address length 
							   (semi octets) */
#define MASK_CALLING_ADDR_LGTH_BITS		0xF0	/* examine the calling address bits */
#define MASK_CALLED_ADDR_LGTH_BITS		0x0F	/* examine the called address bits */
#define MAX_ASY_PKT_FACILS_LGTH 		109	/* the maximum permitted facilities length */
#define MAX_ASY_PKT_DLGTH_X_2			32	/* twice the maximum data length 
							   (non fast select) */
#define MAX_ASY_PKT_FST_SEL_DLGTH_X_2 		256	/* twice the maximum data length (fast select) */
#define MAX_FLGTH_X_2_CCITT_1980		126	/* twice the maximum facilities length 
							   (1980 compatibility) */
#define MAX_FLGTH_X_2_CCITT_1984_88		218	/* twice the maximum facilities length 
							   (1984/88 compatibility) */
#define SHOW_FACIL_NOT_ALWD_IN_TX_PKT 		0xFFFF 	/* an internal facility length used to indicate 
							   that the facility is not permitted in the 
							   outgoing packet */
#define MASK_PRIVATE_NW_CAUSE_BIT		0x7F  	/* mask for bit 8 (private network) for 
							   incoming cause fields */
#define X25_PKT_TYPE_FOR_LCN_ZERO		0x80	/* an asynchronous packet with the high 
							   bit set has a LCN of zero */
#define OFF_UT_BFR_ASY_PKT_DECODING		512	/* the offset within the utility buffer 
							   where the asynchronous packets are decoded */

#define UTIL_BFR_IN_USE_BY_ASY_PKT 		1 	/* the utility buffer is in use by 
							   an asynchronous packet */

/* the size definition for the X.25 packet processing buffer 
 * 
 * Note: that is buffer size must be greater than 
 * 	 MAX_LGTH_CLEAR_REQ_PKT, which is the 
 * 	 longest asynchronous packet */
#define SIZEOF_X25_PKT_PROC_BFR		((END_ADDR_X25_PKT_PROC_BFR - BASE_ADDR_X25_PKT_PROC_BFR) + ONE_BYTE)



/* minimum and maximum permitted lengths of the various packet types */
#define MIN_LGTH_CALL_REQ_PKT			6	/* the minimum length of a Call Request packet */
#define MAX_LGTH_CALL_REQ_PKT			259	/* the maximum length of a Call Request packet */
#define MIN_LGTH_CALLAC_NO_ADDR_FACILS 		3   	/* the minimum length of a Call Accept packet 
							   (no address or facilities length fields) */
#define MIN_LGTH_CALLAC_ADDR_FACILS 		5 	/* the minimum length of a Call Request 
							   packet (with address and facilities length fields) */
#define MAX_LGTH_CALL_ACCEPT_PKT		259	/* the maximum length of a Call Accept packet */
#define MIN_LGTH_CLEAR_REQ_PKT_NO_DIAG		4  	/* the minimum length of a Clear Request packet 
							   (no diagnostic field included) */

#define MIN_LGTH_CLRRQ_PKT_WITH_DIAG		5 	/* the minimum length of a Clear Request 
							   packet (including a diagnostic field) */

#define MAX_LGTH_CLEAR_REQ_PKT			261	/* the maximum length of a Clear Request pkt */
#define MIN_LGTH_CLEAR_CONF_PKT			3	/* the minimum length of a Clear 
							   Confirmation packet */
#define MAX_LGTH_CLEAR_CONF_PKT			131	/* the maximum length of a Clear 
							   Confirmation packet */
#define MIN_LGTH_RESET_REQ_PKT_NO_DIAG		4   	/* the minimum length of a Reset Request 
							   packet (no diagnostic field included) */
#define MIN_LGTH_RESET_REQ_PKT_DIAG		5	/* the minimum length of a Reset Request packet 
							   (including a diagnostic field) */
#define MAX_LGTH_RESET_REQ_PKT			5	/* the maximum length of a Reset Request packet */
#define MIN_LGTH_RESET_CONF_PKT			3	/* the minimum length of a Reset Request packet */
#define MAX_LGTH_RESET_CONF_PKT			3	/* the maximum length of a Reset Confirmation packet */
#define MIN_LGTH_INTERRUPT_PKT			4	/* the minimum length of an Interrupt packet */
#define MAX_LGTH_INT_PKT_CCITT_1980		4	/* the maximum length of an Interrupt packet 
							   (1980 compatibility) */
#define MAX_LGTH_INT_PKT_CCITT_1984_88		35	/* the maximum length of an Interrupt packet 
							   (1984/1988 compatibility) */
#define MAX_LGTH_INT_DATA_CCITT_1980		1	/* the maximum length of Interrupt data 
							   (1980 compatibility) */
#define MAX_LGTH_INT_DATA_CCITT_1984_88		32	/* the maximum length of an Interrupt packet 
							   (1984/1988 compatibility) */
#define MIN_LGTH_INTERRUPT_CONF_PKT		3	/* the minimum length of an Interrupt 
							   Confirmation packet */
#define MAX_LGTH_INTERRUPT_CONF_PKT		3	/* the maximum length of an Interrupt 
							   Confirmation packet */
#define MIN_LGTH_DIAGNOSTIC_PKT			5  	/* the minimum length of a Diagnostic packet */
#define MAX_LGTH_DIAGNOSTIC_PKT			7  	/* the maximum length of a Diagnostic packet */
#define MIN_LGTH_REGISTR_REQ_PKT		6  	/* the minimum length of a Registration 
							   Request packet */
#define MAX_LGTH_REGISTR_REQ_PKT		114  	/* the maximum length of a Registration 
							   Request packet */
#define MIN_LGTH_REGISTR_CONF_PKT		7  	/* the minimum length of a Registration 
							   Confirmation packet */
#define MAX_LGTH_REGISTR_CONF_PKT		116  	/* the maxnimum length of a Registration 
							   Confirmation packet */
#define MIN_LGTH_DATA_PKT			4  	/* the minimum length of a Data packet */
#define MIN_LGTH_SUP_PKT			3  	/* the minimum length of a Supervisory packet */
#define MAX_LGTH_SUP_PKT			3  	/* the maximum length of a Supervisory packet */



/* X.25 cause field codes */
#define DTE_ORIGINATED 				0x00
#define RESTART_LOCAL_PROC_ERR 			0x01
#define RESTART_NETWORK_OPERATIONAL 		0x07
#define RESET_OUT_OF_ORDER 			0x01
#define RESET_LOCAL_PROC_ERR 			0x05
#define RESET_REMOTE_DTE_OPERATIONAL 		0x09
#define RESET_NETWORK_OPERATIONAL 		0x0F
#define RESET_NETWORK_OUT_OF_ORDER 		0x1D
#define CLEAR_LOCAL_PROC_ERR 			0x13
#define CLEAR_NOT_OBTAINABLE			0x0D



/* X.25 diagnostic field codes */
#define INVALID_Ps_COUNT	  		1
#define INVALID_Pr_COUNT			2
#define PKT_TYPE_INVALID_STATE_r1		17
#define PKT_TYPE_INVALID_STATE_r2		18
#define PKT_TYPE_INVALID_STATE_r3		19
#define PKT_TYPE_INVALID_STATE_p1		20
#define PKT_TYPE_INVALID_STATE_p2		21
#define PKT_TYPE_INVALID_STATE_p3		22
#define PKT_TYPE_INVALID_STATE_p4		23
#define PKT_TYPE_INVALID_STATE_p5		24
#define PKT_TYPE_INVALID_STATE_p6		25
#define PKT_TYPE_INVALID_STATE_p7		26
#define PKT_TYPE_INVALID_STATE_d1		27
#define PKT_TYPE_INVALID_STATE_d2		28
#define PKT_TYPE_INVALID_STATE_d3		29
#define PKT_NOT_ALLOWED				32
#define UNIDENTIFIABLE_PKT			33
#define CALL_ON_ONE_WAY_LCN			34
#define INVALID_PKT_ON_PVC			35
#define PKT_NOT_ALLOWED_UNASSIGNED_LCN		36
#define REJ_NOT_SUBSCRIBED_TO			37
#define PKT_TOO_SHORT				38
#define PKT_TOO_LONG				39
#define INVALID_GFI				40
#define RESTRT_REGISTR_DIAG_LCN_DEFINED 	41
#define PKT_TYPE_NOT_COMPAT_WITH_FACIL 		42
#define UNAUTH_INTERRUPT_CONF			43
#define UNAUTH_INTERRUPT			44
#define TIMER_EXPIRED_CALL_REQ			49
#define TIMER_EXPIRED_CLEAR_REQ	  		50
#define TIMER_EXPIRED_RESET_REQ	  		51
#define RE_TX_COUNT_EXPIRED_RESET_REQ		51
#define TIMER_EXPIRED_RESTART_REQ		52
#define CALL_SETUP_CLEAR_OR_REGSTR_PROB 	64
#define FACIL_REGSTR_CODE_NOT_ALLOWED 		65
#define FACILITY_PARM_NOT_ALLOWED		66
#define INVALID_CALLED_DTE_ADDRESS		67
#define INVALID_CALLING_DTE_ADDRESS		68
#define INVALID_FACILITY_REGSTR_LGTH	 	69
#define INCOMING_CALL_BARRED			70
#define DUPLICATE_FACILITY_REQUESTED	 	73
#define NONZERO_ADDRESS_LGTH			74
#define TIMER_EXPIRED_INTERRUPT			145
#define FAST_SELECT_NOT_SUBSCRIBED		164
#define INVALID_PART_FULL_DATA_PKT 		165
#define D_BIT_PROCEDURE_NOT_SUPPORTED		166
#define OSI_NETWORK_PROBLEM_PERMANENT_DISC      226



/* parameters for handling facility fields in asynchronous packets */
/* facility codes */
#define PKT_SIZE_NEGOTIATION_FACIL		0x42	/* packet size negotiation */
#define WIN_SIZE_NEGOTIATION_FACIL		0x43	/* window size negotiation */
#define THROUGHPUT_CLASS_NEG_FACIL 		0x02	/* throughput class negotiation */
#define CUG_SELECT_BASIC_FACIL			0x03	/* closed user group selection - basic format */
#define CUG_SELECT_EXT_FACIL			0x47	/* closed user group selection - extended format */
#define CUG_OUT_SELECT_BASIC_FACIL 		0x09	/* closed user group with outgoing access - 
							   basic format */
#define CUG_OUT_SELECT_EXT_FACIL 		0x48	/* closed user group with outgoing access - 
							   extended format */
#define BI_CUG_SELECT_FACIL			0x41	/* bilateral closed user group selection */
#define REV_CHRG_FAST_SELECT_FACIL		0x01	/* reverse charging / fast select */
#define NUI_SELECTION_FACIL			0xC6	/* NUI selection */
#define CHRG_INFO_REQ_SERVICE_FACIL 		0x04	/* charging information - requesting service */
#define CHRG_INFO_IND_MON_UNIT_FACIL		0xC5	/* charging information - indicating monetary unit */
#define CHRG_INFO_IND_SEG_COUNT_FACIL		0xC2	/* charging information - indicating segment count */
#define CHRG_INFO_IND_CALL_DUR_FACIL		0xC1	/* charging information - indicating call duration */
#define RPOA_SELECT_BASIC_FORMAT_FACIL		0x44	/* RPOA selection - basic format */
#define RPOA_SELECT_EXT_FORMAT_FACIL		0xC4	/* RPOA selection - extended format */
#define CALL_DEFLECT_SELECTION_FACIL		0xD1	/* call deflection selection */
#define CALL_REDIR_DEFLEC_NOTIF_FACIL		0xC3 	/* call redirection or deflection notification */
#define CALLED_LINE_ADDR_MOD_NOT_FACIL 		0x08 	/* called line address modified notification */
#define TRANSIT_DELAY_SELECT_IND_FACIL 		0x49	/* transit delay selection and indication */
#define FACILITY_MARKER				0x00	/* the facility marker octet */

/* CCITT-specified DTE facilities */
#define CCITT_CALLING_ADDR_EXT_FACIL  		0xCB	/* calling address extension */
#define CCITT_CALLED_ADDR_EXT_FACIL  		0xC9	/* called address extension */
#define CCITT_MIN_THRU_CLS_NEG_FACIL  		0x0A	/* minimum throughput class negotiation */
#define CCITT_ETE_TX_DELAY_NEG_FACIL 		0xCA	/* end-to-end transit delay negotiation */
#define CCITT_PRIORITY_FACIL			0xD2	/* priority */
#define CCITT_PROTECTION_FACIL			0xD3	/* protection */
#define CCITT_EXPIDITED_DATA_NEG_FACIL		0x0B	/* expedited data negotiation */

/* for flow control (packet and window size) negotiation */
#define LGTH_FLOW_CTRL_FACIL_PARM_FLD		0x02	/* the length of a flow control negotiation 
							   parameter field */
#define LGTH_UNPKD_PKT_WIN_NEG_FACIL		0x06	/* the length of an 'unpacked' flow control 
							   facility field */
#define MIN_SIZE_ISO_FORMAT_NEG_FACILS 		4	/* the minimum permitted packet size in 
							   the parameter field (ISO format) */
#define MAX_SIZE_ISO_FORMAT_NEG_FACILS 		12	/* the maximum permitted packet size in the 
							   parameter field (ISO format) */
#define PKT_SIZE_ISO_FORMAT_16_BYTES		0x04	/* the ISO parameter field for a 16 byte 
							   data field */
#define PKT_SIZE_ISO_FORMAT_128_BYTES		0x07	/* the ISO parameter field for a 128 byte 
							   data field */
#define MIN_WIN_SIZE_IN_NEG_FACILS    		1	/* the minimum permitted window size in the 
							   parameter field */
#define MAX_WIN_SIZE_IN_NEG_FACILS 	 	7	/* the maximum permitted window size in the 
							   parameter field */
#define WIN_SIZE_OF_2				2	/* a window size of 2 */
#define DEFAULT_PARM_LIMIT 			0x00	/* a flag indicating that the negotiated 
							   window/packet sizes must be limited by our 
							   configuration file */
#define CCITT_PKT_WIN_LIMIT 			0x01	/* a flag indicating that the negotiated 
							   window/packet sizes must be limited in 
							   accordance with Tables 11 and 12 of ISO 8208 */

/* minimum and maximum facility parameter fields for throughput class negotiation */
#define THROUGHPUT_CLS_75_LOW_BITS		0x03	/* a throughput class of 75 bps */
#define THROUGHPUT_CLS_75_HIGH_BITS		0x30
#define THROUGHPUT_CLS_48K_LOW_BITS		0x0C	/* a throughput class of 48 kbps - 
							   this is the maximum permitted */
#define THROUGHPUT_CLS_48K_HIGH_BITS		0xC0	/* class for 1980 and 1984 compatibility */
#define THROUGHPUT_CLS_64K_LOW_BITS		0x0D	/* a throughput class of 64 kbps  - t
							   his is the maximum permitted */
#define THROUGHPUT_CLS_64K_HIGH_BITS		0xD0	/* class for 1980 and 1984 compatibility */

/* reverse charging and fast select */
#define REV_CHARGING_REQUESTED		   	0x01	/* the parameter field indicating that 
							   reverse charging has been */
																	/* selected */
#define INTERNAL_FACILS_REP_REV_CHRG		0x10	/* reverse charging facility code represetation 
							   for internal use */
#define BTS_1_5_SET_REV_CHR_FST_SEL		0x3E 	/* a mask to test if bits 1 to 5 
							   (reserved bits) are set in a  fast select 
							   parameter field */
/* facility categories */
#define CCITT_SPECIFIED_DTE_FACILS		0x0F	/* CCITT-specified DTE facilities */
#define NON_X25_FACILS_LOCAL_NETWORK		0x00	/* non-X.25 facilities suported by the local network */
#define NON_X25_FACILS_REMOTE_NETWORK		0xFF	/* non-X.25 facilities suported by a remote network */

/* general facility definitions */
#define ALL_CHARGING_INFO_FACILS_SUPP 		0x000F	/* a bit map representing all charging 
							   information facilities */
#define MASK_2_HIGH_BITS_OF_FACILS_CODE		0xC0	/* a bit map to mask the two high bits 
							   of the facility code to */

/* determine the format of the facility element */
#define LGTH_FACILITY_MARKER_FIELD		0x02	/* the length of a facility marker field */
#define ALL_FACILITIES_SUPPORTED		0xFFFF	/* a mask set if all facilities are supported */
#define HANDLE_LOW_BITS_OF_THRU_CLASS		0x0F	/* a mask for handling the low 4 bits of the 
							   throughput class */
#define HANDLE_HIGH_BITS_OF_THRU_CLASS		0xF0	/* a mask for handling the high 4 bits of the 
							   throughput class */
#define SIZEOF_PKT_SIZE_ARRAY			0x0D	/* the size of the packet size definition array */



/* definitions for the storage of asynchronous packets before passing to the application */
/* the size of the asynchronous packet buffer */
#define SIZEOF_ASY_RECORD_STORE_BFR	((END_ADDR_ASY_RECORD_STORE_BFR - BASE_ADDR_ASY_RECORD_STORE_BFR) + ONE_BYTE)
/* the permitted asynchronous packet buffer hysteresis before we put the HDLC level into the RNR mode */
#define RX_ASY_BFR_HYSTERESIS 		(SIZEOF_ASY_RECORD_STORE_BFR / 2)
#define ASY_TIME_STAMP_LGTH			 		4			/* the size of the asynchronous transaction time stamp */


#define OFF_ASY_STOR_ASY_PACKET_TYPE		0x09		/* the offset of the 'packet_type' within this structure */
#define PKT_SENT_TIMEOUT 				  		0x40		/* the packet was sent due to a timeout */
#define PKT_SENT_PROTOCOL_VIOLATION  		0x80		/* the packet was sent due to a protocol violation */
#define PKT_SENT_PROT_VIO_OR_TIMEOUT 		0xC0		/* the packet was sent due to a timeout or a protocol violation */
#define AUTOMATIC_ASYNC_RESPONSE 			0x80		/* high bit set to indicate that the transmitted packet was an */
																	/* automatic response */
#define LINK_LEVEL_RECOVERY 					0x80		/* the asynchronous occurrence was due to a link level recovery */
#define REPORT_ASY_RETRY_LIMIT_EXCEEDED 	0xC0		/* the application must be notified that the asynchronous retry */
																	/* limit has been exceeded */


#define USHORT unsigned short
#define UCHAR  unsigned char

/* definitions for use when transmitting internally-generated X.25 asynchronous packets */
/* the structure for recording details of the X.25 asynchronous packets to be transmitted */
typedef struct {
	USHORT LCN;													/* the logical channel on which the packet is to be issued */
	UCHAR next_X25_Tx_state;								/* the X.25 state after the issuing of the asynchronous packet */
	UCHAR cause;												/* the cause field to be used in the packet */
	UCHAR diagnostic;											/* the diagnostic field to be used in the packet */
} X25_INTERNAL_ASY_PKT_STRUCT;

#define MAX_NO_INTERNAL_ASY_PKTS				20			/* the maximum number of internally-generated X.25 asynchronous */
																	/* packets that may be stored */



/* definitions for use by the X.25 asynchronous retry timers */
/* the structure for handling X.25 asynchronous packet timers */
typedef struct {
	USHORT LCN_struct_no;	/* the LCN structure number associated with this timing structure */
	USHORT start_time;	/* the millisecond start time */
	USHORT timer_limit;	/* the number of milliseconds permitted before a timeout occurs */
	UCHAR retry_count;	/* the number of times the asynchronous packet has been re-issued */
	UCHAR retry_limit;	/* the number of consecutive times the asynchronous packet may be */
																	/* re-issued before a state change is forced */
} X25_ASY_TMR_STRUCT;

#define MAX_X25_ASY_TMR_STRUCTS		30	/* the maximum number of asynchronous timer structures */
#define EMPTY_X25_ASY_TMR_STRUCT	0xFFFF	/* a timer structure is vacant */
#define DONT_RESET_RETRY_COUNT 		0x00	/* flags used for the retransmission of asynchronous packets */
#define RESET_RETRY_COUNT 		0x01



/* definitions for use by the X.25 asynchronous history tables */
#define MAX_X25_HISTORY_STRUCTS		32	/* the maximum number of history structures (must be a power of */
																	/* two for rotational buffer coding) */
#define DO_NOT_RECORD_CAUSE_DIAG_FLDS	0x00	/* the cause and diagnostic fields should not be recorded */
#define RECORD_CAUSE_FIELD		0x01		/* the cause field should be recorded */
#define RECORD_DIAG_FIELD		0x02		/* the diagnostic field should be recorded */



/* definitions for use when calling the 'init_structs_for_all_LCNs()' function */
/* Note - these definitions are used in conjunction with X25_ST_RESTART_REQ_REC and X25_ST_RESTART_REQ_SNT */
#define LCN_STRUCT_INIT_AFTR_CONFIG	0x00		/* initialize all LCNs after a configuration command */
#define LCN_STRUCT_INIT_AFTR_RESTART	0x01		/* initialize all LCNs after a Restart sequence */



/* definitions for the 'HDLC_lvl_put_into_RNR_mode' variable */
#define HDLC_LVL_RNR_MODE_DATA_BFR	0x01		/* RNR mode was entered due to receive Data buffering limitations */
#define HDLC_LVL_RNR_MODE_ASY_BFR	0x02		/* RNR mode was entered due to asynchronous packet storage */
																	/* limitations */


/* settings for the HDLC link status */
#define HDLC_LINK_DISCONNECTED		0x00		/* the HDLC link is disconnected */
#define HDLC_LINK_IN_ABM		0x01		/* the HDLC link is in the ABM (connected) */



/* general constants */
#define MOD8_WINDOW			0x07	  	/* the maximum window for a modulo 8 implementation */
#define MAX_NO_DEL_D_BIT_RRs_QUEUED 	0x08		/* the maximum number of D-bit acknowledgements queued for */
																	/* transmission */
#define END_OF_PKT_TYPE_MAP_ARRAY	0xFE		/* a character denoting the end of the packet type mapping array */
#define BIT_0_SET			0x01
																	/* NB - this character must not be a valid ISO packet type */
																	/* (for example, 0xFF - Restart Conf) or internal packet type */
#define SPACE_CHAR			0x20		/* a space character for asynchronous argument formatting */
#define BIT_0_SET			0x01
#define BIT_2_SET			0x04
#define BIT_3_SET			0x08
#define EIGHT_BITS			0x08


#define CALLAC_DOES_NOT_INCL_ADDR_LGTH         0x0040  /* a transmitted or received Call Accept packet does not include */

#define NO_DIAG_PKTS_ISSUED_BY_DCE			0x0002	/* a station configured as a DCE will issue Diagnostic packets */

#define NO_DIAG_FIELD_IN_ASYNC_PKTS			0x0008	/* an asynchronous packet does not include a diagnostic field */

#define CCITT_1980_COMPATIBILITY				1980	/* 1980 compatibility */



/* bit settings for the 'X25_response_options' byte */

/* all received Data packets are acknowledged with an RR */
#define ALL_DATA_PKTS_ACKED_WITH_RR			0x0001
#define DISABLE_AUTO_CLEAR_CONF				0x0002	
#define DISABLE_AUTO_RESET_CONF				0x0004	
#define DISABLE_AUTO_RESTART_CONF			0x0008	
#define DISABLE_AUTO_INT_CONF				0x0010	
#define RESET_PVC_NET_DOWN_ON_RX_DATA			0x0020


/* ----------------------------------------------------------------------------
 *             Constants for the INCOMING_CALL_CONTROL command
 * --------------------------------------------------------------------------*/

#define CLEAR_ALL_INCOMING_CALLS	0x00	/* automatically clear all incoming calls */
#define PASS_INCOMING_CALLS_TO_APP	0x01	/* pass all incoming calls to the application */
#define ACCEPT_ALL_INCOMING_CALLS	0x02	/* automatically accept all incoming calls */



/* bit settings for the 'X25_protocol_options' byte */
#define REGISTRATION_PRAGMATICS_SUPP		0x0001	/* registration pragmatics supported */
#define NO_DIAG_PKTS_ISSUED_BY_DCE		0x0002	/* a station configured as a DCE will issue Diagnostic packets */
#define NO_RESTART_REQ_ON_ENTER_ABM		0x0004	/* a Restart Request packet is not issued when entering the ABM */
#define NO_DIAG_FIELD_IN_ASYNC_PKTS		0x0008	/* an asynchronous packet does not include a diagnostic field */
#define D_BIT_PRAGMATICS_NOT_SUPPORTED		0x0010	/* D-bit pragmatics are not supported */
#define AUTO_FLOW_CTRL_PARM_FACIL_INS 		0x0020	/* flow control facilities are automatically inserted in call */

#define TWO_BYTES 2
#define FOUR_BITS 4
#define ZERO 0

//__KERNEL__
#endif  

//_WANPIPE_X25_HEADER_
#endif


/* x25_timer.c */
extern inline int x25_queue_tq (struct tq_struct *bh_pointer);
extern inline int x25_mark_bh (void);

extern void x25_start_t10_t20_timer(x25_link_t *x25_link);
extern void x25_stop_t10_t20_timer(x25_link_t *x25_link);
extern void x25_start_t28_timer(x25_link_t *x25_link);
extern void x25_stop_t28_timer(x25_link_t *x25_link);


extern void x25_start_t11_t21_timer(x25_lcn_t *x25_lcn);
extern void x25_start_t12_t22_timer(x25_lcn_t *x25_lcn);
extern void x25_start_t13_t23_timer(x25_lcn_t *x25_lcn);


extern void x25_stop_t11_t21_timer(x25_lcn_t *x25_lcn);
extern void x25_stop_t12_t22_timer(x25_lcn_t *x25_lcn);
extern void x25_stop_t13_t23_timer(x25_lcn_t *x25_lcn);



/* x25_out.c */
extern void x25_link_send (unsigned long x25_link_data);
extern void x25_send_control (x25_link_t *x25_link, unsigned char qd_bit, 
		       unsigned short lcn, unsigned char type, 
		       unsigned char cause, unsigned char diag,
		       unsigned char *data_ptr, int data_len);
extern int x25_place_call (x25_lcn_t *x25_lcn);
extern int x25_clear_call (x25_lcn_t *x25_lcn,unsigned char force);
extern int x25_reset_call (x25_lcn_t *x25_lcn);
extern int x25_accept_call (x25_lcn_t *x25_lcn);


/* x25_subr.c */
extern inline void x25_release_lcn_dev (x25_link_t *x25_link, x25_lcn_t *x25_lcn);
extern inline x25_lcn_t * x25_get_free_api_dev (x25_link_t *x25_link, unsigned short lcn);
extern void x25_set_lcn_states(x25_link_t *x25, int x25_lcn_state);
extern void x25_initialize_all_lcn(x25_link_t *x25, int x25_lcn_state);
extern void x25_clear_link_queues(x25_link_t *x25, int x25_lcn_state);
extern void x25_initialize_lcn (x25_lcn_t *x25_lcn, int x25_lcn_state, int hard);
extern struct net_device * x25_get_free_lcn_dev(x25_link_t *x25_link, unsigned short lcn);
extern int x25_trigger_link_bh(x25_link_t *x25_link,char rx_kick);
extern int x25_trigger_link_rx_bh(x25_link_t *x25_link);
extern struct net_device * x25_get_lcn_dev(x25_link_t *x25_link, unsigned short lcn);
extern void x25_release_lcn_dev (x25_link_t *x25_link, x25_lcn_t *x25_lcn);
extern void handle_Rx_Clear_Request_pkt (x25_lcn_t *x25_lcn, struct sk_buff *skb, struct x25_frame *frame);
extern int handle_Rx_Call_Request_pkt(x25_link_t *x25_link, struct sk_buff *skb,struct x25_frame *frame);
extern void handle_Rx_Reset_Request_pkt(x25_lcn_t *x25_lcn, struct sk_buff *skb, struct x25_frame *frame);
extern int handle_Rx_Call_Accept_pkt(x25_lcn_t *x25_lcn, struct sk_buff *skb, struct x25_frame *frame);
extern inline int x25_validate_Pr(x25_lcn_t *x25_lcn, struct x25_frame *frame);
extern void set_LCN_misc_status_bits (x25_lcn_t *x25_lcn, unsigned char misc_status_bits);
extern void x25_debug_all_lcn(x25_link_t *x25);
extern inline x25_lcn_t *get_lcn_device (x25_link_t *x25_link, unsigned short lcn);
extern struct net_device *get_first_tx_dev(x25_link_t *x25_link);
extern struct net_device *get_next_tx_dev(x25_link_t *x25_link, int lcn);
extern void lcn_state_change(x25_lcn_t *x25_lcn, unsigned int state);


/* x25_iface.c */
extern int x25_data_tx_down (x25_link_t *x25, struct sk_buff *skb);
extern int x25_data_tx_up(x25_lcn_t *x25, struct sk_buff *skb, struct x25_frame *frame);
extern inline x25_lcn_t *dev_to_x25(struct net_device *dev);

/* x25_in.c */
extern int x25_data_input(x25_link_t *x25_link, struct sk_buff *skb);


/* x25_util.c */
extern int Restrt_Registr_Diag_pkt_error(x25_link_t *x25, 
					struct sk_buff *skb, 
					struct x25_frame *frame);

extern void PTI_err_LCN_0_pkt_on_non_0_LCN(x25_link_t *x25_link, 
				    unsigned char diag_code, 
				    struct x25_frame *frame);

extern void semi_oct_to_oct(unsigned char *src, 
		            unsigned char *dest, 
			    unsigned short lgth);

extern unsigned char inline gfi_decode (unsigned int config);

extern int check_insert_address_fields(unsigned char ASCII_prefix, 
				unsigned char *src_ptr, 
				unsigned char *dest_ptr,
				unsigned char address_lgth);

extern void insert_ASCII_prefix(unsigned char **dest_ptr, unsigned char ASCII_prefix_char);

extern int packet_length_error(x25_link_t *x25, struct x25_frame *frame);


extern int x25_decode_asy_pkt (x25_link_t* x25_link, 
			struct sk_buff *newskb, 
			struct sk_buff *asy_skb, 
			struct x25_frame *frame,
			int *off_facils_ptr,
			int *facils_lgth_ptr,
			int *user_data_lgth_ptr);


extern int x25_parse_call_string(x25_lcn_t *x25_lcn, unsigned char type, struct sk_buff *pkt_skb);


extern int select_outgoing_call_LCN(x25_lcn_t *x25_lcn);

extern unsigned short str_index(unsigned char *s, unsigned char *t, unsigned short max_chars);

extern int tokenize (char* str, char **tokens, char *arg1, char *arg2, char *arg3);

extern int x25_match_accept_criteria(x25_lcn_t *x25_lcn, char **token, int toknum);

extern int pkt_size_no (unsigned short pkt_size);

extern int error_in_decoding_facils(x25_lcn_t *x25_lcn, 
			     unsigned char type,        
			     unsigned char *X25_Rx_pkt_Data_ptr,
			     int facils_lgth,
			     int off_facils);

extern int asy_pkt_Data_lgth_excessive(unsigned int x25lcn_cfg, int X25_Data_lgth);
extern int decode_pkt_size (unsigned char *index);
extern int x25_update_stats (x25_link_t *x25_link, unsigned int type, unsigned char direction);
extern void x25_log_proc_event(x25_link_t *x25_link, 
		        unsigned char *lcn_dev_name,
		        unsigned char *event_name, 
		        unsigned short lcn, unsigned char cause, 
			unsigned char diag, unsigned char *call_string);


/* x25_facils.c */
extern void insert_flow_control_facils(x25_lcn_t *x25_lcn, unsigned char type, struct sk_buff *skb);


/* x25_dsp_iface.c */
extern int send_dsp_call_request (x25_lcn_t *x25_lcn,struct x25_frame *frame, struct sk_buff *skb);
extern void x25_update_dsp_state(x25_lcn_t *x25_lcn);
extern void send_dsp_reset(x25_lcn_t *x25_lcn);


/* x25_api_iface.c */
extern int x25_api_cmd_setup(x25_lcn_t *x25_lcn, struct ifreq *ifr);
extern int x25_api_get_cmd_result(x25_lcn_t *x25_lcn, struct ifreq *ifr);
extern int x25_api_place_call(x25_lcn_t *x25_lcn, struct ifreq *ifr);
extern int x25_api_clear_call(x25_lcn_t *x25_lcn, struct ifreq *ifr);
extern int x25_api_accept_call(x25_lcn_t *x25_lcn, struct ifreq *ifr);
extern int x25_api_reset_call(x25_lcn_t *x25_lcn, struct ifreq *ifr);
extern int send_api_oob_msg (x25_lcn_t *x25_lcn, struct x25_frame *frame, unsigned char *data_ptr, unsigned short data_len);
extern int send_global_api_oob_msg (x25_link_t *x25_link, struct x25_frame *frame,unsigned char *data_ptr, unsigned short data_len);
extern int send_api_call_request (x25_lcn_t *x25_lcn,struct x25_frame *frame, struct sk_buff *skb);
extern void x25_update_api_state(x25_lcn_t *x25_lcn);


/* x25_prot.c */
extern int x25_proc_init (void);
extern void x25_proc_cleanup (void);
extern int x25_proc_link_init (x25_link_t *x25_link);
extern int x25_proc_link_cleanup(x25_link_t *x25_link);
extern int x25_proc_add (x25_lcn_t* x25_lcn, struct proc_dir_entry *proc_dir);
extern int x25_proc_delete(x25_lcn_t* x25_lcn,struct proc_dir_entry *proc_dir);
extern int x25_proc_usage_check(void);



extern atomic_t x25_skb_alloc;
extern atomic_t x25_mem_alloc;

#define X25_DEBUG_MEM

#ifdef X25_DEBUG_MEM

 #define X25_SKB_DEC(x)  atomic_sub(x,&x25_skb_alloc)
 #define X25_SKB_INC(x)	 atomic_add(x,&x25_skb_alloc)

 #define ALLOC_SKB(skb,len) { skb = dev_alloc_skb(len);			\
			      if (skb != NULL){ X25_SKB_INC(skb->truesize);}else{ WAN_MEM_ASSERT("X25");} }
 #define KFREE_SKB(skb)     { X25_SKB_DEC(skb->truesize); dev_kfree_skb_any(skb); }


 #define X25_MEM_DEC(x)  atomic_sub(x,&x25_mem_alloc)
 #define X25_MEM_INC(x)	 atomic_add(x,&x25_mem_alloc) 			      
			      
 #define KMALLOC(ptr,len,flag)	{ ptr=kmalloc(len, flag); \
	  			  if (ptr != NULL){ X25_MEM_INC(len);} else {WAN_MEM_ASSERT("X25");}}
 #define KFREE(ptr)		{X25_MEM_DEC(sizeof(*ptr)); kfree(ptr);}
			      
#else
 #define KMALLOC(ptr,len,flag)	ptr=kmalloc(len, flag)
 #define KFREE(ptr)		kfree(ptr)			
			      
 #define ALLOC_SKB(new_skb,len, dsp) new_skb = dev_alloc_skb(len)
 #define KFREE_SKB(skb)	             dev_kfree_skb_any(skb)

 #define X25_SKB_DEC(x) 
 #define X25_SKB_INC(x)	 
 #define X25_MEM_DEC(x) 
 #define X25_MEM_INC(x)	
#endif

#define is_digit(ch) (((ch)>=(unsigned)'0'&&(ch)<=(unsigned)'9')?1:0)


/* X25_SW x25_switch.c */
#define X25_SW_FWD	1
#define X25_SW_BACK	2
extern int x25_sw_call_request(x25_link_t*, struct net_device*, struct sk_buff*, struct x25_frame*);
extern int x25_sw_accept_call(x25_lcn_t* x25_lcn, struct sk_buff* skb, struct x25_frame* frame);
extern x25_link_t* x25_get_switch_link(unsigned char* addr);
extern int x25_sw_send_control(x25_lcn_t* x25_lcn, struct sk_buff* skb, struct x25_frame* frame);
extern int x25_sw_restart_request(x25_link_t* x25_link);
extern int x25_sw_data_rx(x25_lcn_t* x25_lcn, struct sk_buff* skb, struct x25_frame* frame);
extern void x25_sw_disconnect(x25_lcn_t *x25_lcn);

/* SNMP */
extern int x25_snmp_data(x25_lcn_t* x25_lcn, struct ifreq* ifr);

extern unsigned int dec_to_uint (unsigned char* str, int len);
extern int x25_bind_lcn_to_dev(x25_link_t *x25_link,x25_lcn_t *x25_lcn);
