#!/bin/sh

LINUXSOURCE=/usr/src/linux
WANPIPEDIR=/usr/local/wanrouter
USBIN=/usr/sbin
HOMEDIR=`pwd`

echo

if [ ! -d $LINUXSOURCE ]; then
 	echo -e "ERROR: Linux source directory not found: /usr/src/linux!\n"
	exit 1
fi

if [ ! -d $WANPIPEDIR ]; then
	echo -e "ERROR: Wanpipe directory not found: /usr/local/wanrouter!\n"
	exit 1
fi

if [ ! -f $USBIN/pppd ]; then
	echo -e "ERROR: PPPD Daemon doesn't exist in /usr/sbin directory!"
	echo -e "       PPPD is used to establish ppp connection over the async line\n"
	exit 1
fi

if [ ! -f $USBIN/chat ]; then
	echo -e "ERROR: CHAT dialer doesn't exist in /usr/sbin directory!"
	echo -e "       PPPD uses CHAT to dial the modem!\n"
	exit 1
fi

eval "grep 2.2.1 $LINUXSOURCE/net/wanrouter/patchlevel > /dev/null"
if [ $? -ne 0 ]; then
	echo -e "
	ERROR: The latest distribution has not been installed 
	       please download the wanpipe-beta2-2.2.1.tgz from 
	       ftp.sangoma.com : linux/current_wanpipe/ and install it.\n "
	exit 1
fi

eval "grep \"define.*CONFIG_PPP\" $LINUXSOURCE/include/linux/autoconf.h > /dev/null" 
if [ $? -ne 0 ]; then
	echo -e "
	ERROR: The Linux Kernel has not been configured with
	       the PPP Async Module. Run 'make menuconfig', and select
	       PPP option from 'Network Device Support' Area, then 
	       remake modules using 'make modules' and 'make modules_install'\n"
	exit 1
fi

echo -e "Environment Check Complete!"
echo -e "

	Please read the README file in $HOMEDIR.\n"
