#!/bin/sh
#################################################################
# router_up:	Manual Router Startup Script
#
# 	Start the WANPIPE wanrouter using the command 
#       line arguments
#
# 	Author: Nenad Corbic
#################################################################


#Load modules
modprobe wanpipe

#Configure WANPIPE Protocol
./wanconfig -U [devices] \
               wanpipe1 WAN_SPPP \
               [interfaces] \
               wp1_sppp wanpipe1 - WANPIPE \
               [wanpipe1] \
               IOPORT 0x360 \
               IRQ 7 \
               Firmware  /usr/local/wanrouter/firmware/cdual514.sfm \
               CommPort	PRI \
               Receive_Only NO \
               Interface V35 \
               Clocking Internal \
               BaudRate 1600000 \
               MTU 1500 \
               UDPPORT 9000 \
               TTL 255 \
               [wp1_sppp] \
               MULTICAST  NO \
               IGNORE_DCD YES \
               IGNORE_CTS YES \
               IGNORE_KEEPALIVE	YES \
               HDLC_STREAMING YES \
               KEEPALIVE_TX_TIMER 10000

if [ $? -ne 0 ]; then
	echo "WANPIPE Startup Failed\n"
	exit 1 
fi

#Startup interfaces
ifconfig wp1_sppp 201.1.1.1 pointopoint 201.1.1.2 netmask 255.255.255.0 up

exit 0
