#!/usr/bin/perl

$SETUP="Setup";
$WANROUTER="wanrouter";
$WAN_SPEC="../rpm/wanpipe.spec";
$WAN_SPEC_UTIL="../rpm/wanpipe-util.spec";
$WAN_SPEC_MOD="../rpm/wanpipe-mod.spec";


$ver=`grep \"WANPIPE_VERSION .\" ../../../code/include/common/wanpipe_version.h | cut -d\'\"\' -f2`;
$ver=~s/ //g;
chop($ver);


if (!$ver){
	print "Error failed to obtain wanpipe version!";
	exit 0;
}

$beta=`grep \"WANPIPE_VERSION_BETA .\" ../../../code/include/common/wanpipe_version.h | cut -d\'\"\' -f2`;

if (!$beta){
	$beta=0;
}
$beta=~s/ //g;
chop($beta);

if ($beta){
	$version="beta".$beta."-".$ver;
}else{
	$version=$ver;
}
	

print "wanpipe version is --$ver--\n";

print "wanpipe beta is --$beta--\n";

open (FH, "Setup") || die;

while (<FH>){
	$setup .= $_;
}
close FH;

$setup=~s/PROD_VER.*=.*/PROD_VER=$version/;

open (FH, ">$SETUP");
print FH $setup;
close FH;

open (FH, "wanrouter") || die;

while (<FH>){
	$wan .= $_;
}
close FH;

$wan=~s/ROUTER_VERSION.*=.*/ROUTER_VERSION=$version/;

open (FH, ">$WANROUTER");
print FH $wan;
close FH;


open (FH, "$WAN_SPEC") || die;

undef $spec;
while (<FH>){
	$spec .= $_;
}
close FH;

$spec=~s/define.+version.*/define version           $ver/;
$spec=~s/define.+release.*/define release           0$beta/;

open (FH, ">$WAN_SPEC");
print FH $spec;
close FH;

#WANPIPE-MOD.SPEC

open (FH, "$WAN_SPEC_MOD") || die;

undef $spec;
while (<FH>){
	$spec .= $_;
}
close FH;

$spec=~s/define.+version.*/define version           $ver/;
$spec=~s/define.+release.*/define release           0$beta/;

open (FH, ">$WAN_SPEC_MOD");
print FH $spec;
close FH;

#WANPIPE-UTIL.SPEC

open (FH, "$WAN_SPEC_UTIL") || die;

undef $spec;
while (<FH>){
	$spec .= $_;
}
close FH;

$spec=~s/define.+version.*/define version           $ver/;
$spec=~s/define.+release.*/define release           0$beta/;

open (FH, ">$WAN_SPEC_UTIL");
print FH $spec;
close FH;


