#!/bin/sh

cmd=$1

if [ "$cmd" = "" ]; then
	echo "Usage: config_common.sh [ install | uninstall ]"
	exit 1
fi

if [ "$cmd" != "install" ] && [ "$cmd" != "uninstall" ]; then
	echo "Usage: config_common.sh [ install | uninstall ]"
	exit 1
fi


HOME=`pwd`

if [ ! -d ../wanpipe_common ]; then
	echo "Error ../wanpipe_common directory not found!"
	exit 1;
fi

COMMON_DIR="../wanpipe_common"

cd $HOME/code/include
if [ -e "common" ]; then
	echo "Clearing up include common"
	rm -f common
fi

if [ $cmd = "install" ]; then
	echo "Common inlude"
	ln -s ../../$COMMON_DIR/include common
fi


cd $HOME/code/router
if [ -e "common" ]; then
	echo "Clearing up router common"
	rm -f common
fi

if [ $cmd = "install" ]; then
	echo "Common router"
	ln -s ../../$COMMON_DIR/wanpipe common
fi


cd $HOME/code/wantools
if [ -e "common" ]; then
	echo "Clearing up wantools common"
	rm -f common
fi

if [ $cmd = "install" ]; then
	echo "Common wantools"
	ln -s ../../$COMMON_DIR/wantools common
fi

cd $HOME/code
if [ -e "adsl" ]; then
	echo "Clearing up adsl common"
	rm -f adsl
fi

if [ -e "atm" ]; then
	echo "Clearing up atm common"
	rm -f atm
fi

if [ -e "fr" ]; then
	echo "Clearing up atm common"
	rm -f fr
fi

if [ -e "generic" ]; then
	echo "Clearing up generic common"
	rm -f generic
fi

if [ $cmd = "install" ]; then
	echo "Common adsl"
	ln -s ../$COMMON_DIR/adsl adsl
fi

if [ $cmd = "install" ]; then
	echo "Common atm"
	ln -s ../$COMMON_DIR/atm atm
fi

if [ $cmd = "install" ]; then
	echo "Common fr"
	ln -s ../$COMMON_DIR/fr fr
fi

if [ $cmd = "install" ]; then
	echo "Common generic"
	ln -s ../$COMMON_DIR/generic generic
fi

cd $HOME
if [ -e "firmware" ]; then
        echo "Clearing up firmware common"
        rm -f firmware
fi

if [ $cmd = "install" ]; then
	echo "Common firmware"
	ln -s $COMMON_DIR/firmware firmware
fi


echo "Setup Finished"
